﻿using REBORN.Common.Enum;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace REBORN.Common.API
{
    /// <summary>
    /// API请求参数
    /// </summary>
    public class RequestParm
    {
        /// <summary>
        /// 集团id
        /// </summary>
        public int groupId { get; set; }
        /// <summary>
        /// 用户ID
        /// </summary>
        public string uid { get; set; }
        /// <summary>
        /// 请求消息
        /// </summary>
        public object msg { get; set; }

        /// <summary>
        /// 请求时间戳
        /// </summary>
        public string timestamp { get; set; }
        /// <summary>
        /// 签名
        /// </summary>
        public string sign { get; set; }

        /// <summary>
        /// token信息
        /// </summary>
        public string token { get; set; }
        /// <summary>
        /// 客户端版本
        /// </summary>
        public string version { get; set; }
        /// <summary>
        /// 语言  0中文   1繁体  2日文（未处理）
        /// </summary>
        public int languageId { get; set; }
        /// <summary>
        /// 语种类型
        /// </summary>
        public LanguageTypeEnum languageType { get; set; }

        /// <summary>
        /// 商户Id
        /// </summary>
        public int TenantId { get; set; }

        /// <summary>
        /// 小程序Id
        /// </summary>
        public int MallBaseId { get; set; }
    }
}
