﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Linq.Expressions;

namespace DapperExtensions.Lambda
{
    /// <summary>
    ///  缓存泛型接口
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public interface IExpressionCache<T> where T : class
    {
        /// <summary>
        /// 获取缓存
        /// </summary>
        /// <param name="key">键</param>
        /// <param name="creator">表达式</param>
        /// <returns></returns>
        T Get(System.Linq.Expressions.Expression key, Func<System.Linq.Expressions.Expression, T> creator);
    }
}
