﻿
using Property.Model.Extend;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;

namespace REBORN.DataHelper
{
    public class PropertyBetchDataHelper
    {
        /// <summary>
        /// 导入模板
        /// </summary>
        /// <param name="fileName"></param>
        /// <returns></returns>
        public static List<RB_Property_Info_Extend> ImportClaimData(string fileName)
        {
            List<RB_Property_Info_Extend> list = new List<RB_Property_Info_Extend>();
            var dt = REBORN.Common.Plugin.NPOIHelper.ImportExceltoDt(fileName, 0, 0, true);
            if (dt != null && dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    RB_Property_Info_Extend model = DataRowToModel(dr);
                    list.Add(model);
                }
            }
            return list;
        }
        /// <summary>
        /// DataRow转实体
        /// </summary>
        /// <param name="dr"></param>
        /// <returns></returns>
        public static RB_Property_Info_Extend DataRowToModel(DataRow dr)
        {
            RB_Property_Info_Extend model = new RB_Property_Info_Extend();
            if (dr != null)
            {
                if (dr.Table.Columns.Contains("资产名称") && !string.IsNullOrEmpty(dr["资产名称"].ToString().Trim()))
                {
                    model.Name = dr["资产名称"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("分类名称") && !string.IsNullOrEmpty(dr["分类名称"].ToString().Trim()))
                {
                    model.CategoryName = dr["分类名称"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("品牌") && !string.IsNullOrEmpty(dr["品牌"].ToString().Trim()))
                {
                    model.BrandName = dr["品牌"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("型号") && !string.IsNullOrEmpty(dr["型号"].ToString().Trim()))
                {
                    model.PropertyModel = dr["型号"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("单位") && !string.IsNullOrEmpty(dr["单位"].ToString().Trim()))
                {
                    model.Units = dr["单位"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("序列号") && !string.IsNullOrEmpty(dr["序列号"].ToString().Trim()))
                {
                    model.SerialNumber = dr["序列号"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("领用人") && !string.IsNullOrEmpty(dr["领用人"].ToString().Trim()))
                {
                    model.EmName = dr["领用人"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("领用时间") && !string.IsNullOrEmpty(dr["领用时间"].ToString().Trim()))
                {
                    model.StartTime = dr["领用时间"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("购置日期") && !string.IsNullOrEmpty(dr["购置日期"].ToString().Trim()))
                {
                    model.EndTime = dr["购置日期"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("金额") && !string.IsNullOrEmpty(dr["金额"].ToString().Trim()))
                {
                    model.Money = Convert.ToDecimal(dr["金额"].ToString().Trim());
                }
                if (dr.Table.Columns.Contains("使用月份期限") && !string.IsNullOrEmpty(dr["使用月份期限"].ToString().Trim()))
                {
                    model.UseMonths = Convert.ToInt32(dr["使用月份期限"].ToString().Trim());
                }
                if (dr.Table.Columns.Contains("所属公司") && !string.IsNullOrEmpty(dr["所属公司"].ToString().Trim()))
                {
                    model.BranchName = dr["所属公司"].ToString().Trim();
                }
                if (dr.Table.Columns.Contains("供应商") && !string.IsNullOrEmpty(dr["供应商"].ToString().Trim()))
                {
                    model.SupplierName = dr["供应商"].ToString().Trim();
                }
            }
            return model;
        }
    }
}