﻿
using Property.Model.Extend;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;

namespace REBORN.DataHelper
{
    public class SuppliesCheckBetchDataHelper
    {
        /// <summary>
        /// 导入模板
        /// </summary>
        /// <param name="fileName"></param>
        /// <returns></returns>
        public static List<RB_Supplies_CheckDetail_Extend> ImportClaimData(string fileName)
        {
            List<RB_Supplies_CheckDetail_Extend> list = new List<RB_Supplies_CheckDetail_Extend>();
            var dt = REBORN.Common.Plugin.NPOIHelper.ImportExceltoDt(fileName, 0, 0, true);
            if (dt != null && dt.Rows.Count > 0)
            {
                foreach (DataRow dr in dt.Rows)
                {
                    RB_Supplies_CheckDetail_Extend model = DataRowToModel(dr);
                    list.Add(model);
                }
            }
            return list;
        }
        /// <summary>
        /// DataRow转实体
        /// </summary>
        /// <param name="dr"></param>
        /// <returns></returns>
        public static RB_Supplies_CheckDetail_Extend DataRowToModel(DataRow dr)
        {
            RB_Supplies_CheckDetail_Extend model = new RB_Supplies_CheckDetail_Extend();
            if (dr != null)
            {
                if (dr.Table.Columns.Contains("ID") && !string.IsNullOrEmpty(dr["ID"].ToString()))
                {
                    model.Id = Convert.ToInt32(dr["ID"].ToString());
                }
                if (dr.Table.Columns.Contains("UserId") && !string.IsNullOrEmpty(dr["UserId"].ToString()))
                {
                    model.CheckEmpId = Convert.ToInt32(dr["UserId"].ToString());
                }
                if (dr.Table.Columns.Contains("盘点数量") && !string.IsNullOrEmpty(dr["盘点数量"].ToString()))
                {
                    model.RealityNum = Convert.ToInt32(dr["盘点数量"].ToString());
                }
                if (dr.Table.Columns.Contains("盘点备注") && !string.IsNullOrEmpty(dr["盘点备注"].ToString()))
                {
                    model.Remark = dr["盘点备注"].ToString();
                }
            }
            return model;
        }
    }
}