﻿using REBORN.Common.AOP;
using REBORN.Common.Enum;
using System;

namespace Property.Model.Entity
{
    /// <summary>
    /// 订单修改日志
    /// </summary>
    [Serializable]
    [DB(ConnectionName = "LogConnection")]
    public class RB_System_Push_Log
    {

        /// <summary>
        /// 编号
        /// </summary>        
        public int ID
        {
            get;
            set;
        }
        /// <summary>
        /// 接收人
        /// </summary>        
        public int? Recipient
        {
            get;
            set;
        }        
       /// <summary>
        /// 是否系统发送0，否1，是
        /// </summary>        
        public int? IsSys
        {
            get;
            set;
        }        
       /// <summary>
        /// 接收平台1、小满APP（包含IOS和Android）2、Web3、微信公众号4、微信小程序
        /// </summary>        
        public SystemPushLogTypeEnum? RecPlatform
        {
            get;
            set;
        }
        /// <summary>
        /// 内容
        /// </summary>        
        public string Content
        {
            get;
            set;
        }
        /// <summary>
        /// 标题
        /// </summary>        
        public string Title
        {
            get;
            set;
        }        

       /// <summary>
        /// 是否已读0-未读,1-已读
        /// </summary>        
        public int? IsRead
        {
            get;
            set;
        }

        /// <summary>
        /// 连接地址
        /// </summary>        
        public string Link
        {
            get;
            set;
        }

        /// <summary>
        /// 创建人
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }

        /// <summary>
        /// 创建时间
        /// </summary>        
        public DateTime? CreateTime
        {
            get;
            set;
        }

        /// <summary>
        /// 集团编号
        /// </summary>        
        public int? RB_Group_id
        {
            get;
            set;
        }

        /// <summary>
        /// 公司编号
        /// </summary>        
        public int? RB_Branch_id
        {
            get;
            set;
        }
        /// <summary>
        /// 推送类型
        /// </summary>
        public SysTemPushTypeEnum? Type { get; set; }

        /// <summary>
        /// 是否显示在快捷栏
        /// </summary>
        public int? ShowShortcut { get; set; }

        /// <summary>
        /// 来源id
        /// </summary>
        public int? SourceId { get; set; }

        /// <summary>
        /// 0-内部，1-同行
        /// </summary>
        public int RecipientType { get; set; }
    }
}