﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;

namespace Property.Model.Entity
{

    /// <summary>
    /// rb_workflow_audit Entity
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "FinanceConnection")]
    public class Rb_Workflow_Audit
    {

        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 审批条件id
        /// </summary>        
        public int? ConditionId
        {
            get;
            set;
        }
        /// <summary>
        /// 审核人类型  1主管(指定一级) 2 指定成员  3角色(岗位) 4空节点
        /// </summary>        
        public int? AuditType
        {
            get;
            set;
        }
        /// <summary>
        /// 1依次审批（本环节内审批人依次审批） 2 会签（须所有审批人同意）3 或签（一名审批人同意或拒绝即可）
        /// </summary>        
        public int? AuditWay
        {
            get;
            set;
        }
        /// <summary>
        /// 存发起人或者角色   发起人1 表示直属主管   2表示再上一级   依次类推
        /// </summary>        
        public int? RoleOrInitiator
        {
            get;
            set;
        }
        /// <summary>
        /// 步骤（排序）
        /// </summary>        
        public int? Sort
        {
            get;
            set;
        }

        /// <summary>
        /// 审核人描述
        /// </summary>
        public string AuditDescription { get; set; }
        /// <summary>
        /// 0常规1-特殊节点
        /// </summary>
        public WFSpecialNodeEnum? SpecialNode { get; set; }
    }
}