﻿using REBORN.Common.AOP;
using System;
using System.Collections.Generic;
using System.Text;

namespace Property.Model.Entity.Mall
{
    /// <summary>
    /// 商品出库实体
    /// </summary>
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_WarehouseOut_GoodsDetail
    {


        /// <summary>
        /// 入库单id
        /// </summary>
        public int StockInId { get; set; }

        /// <summary>
        /// 物料id
        /// </summary>
        public int MaterialId { get; set; }
        /// <summary>
        /// 出库id
        /// </summary>
        public int StockOutId { get; set; }

        /// <summary>
        /// 仓库id
        /// </summary>
        public int WarehouseId { get; set; }


        /// <summary>
        /// 申请id
        /// </summary>
        public int ApplyId { get; set; }


        /// <summary>
        /// Id
        /// </summary>        
        public int ID
        {
            get;
            set;
        }
        /// <summary>
        /// OrderId
        /// </summary>        
        public int OrderId
        {
            get;
            set;
        }

        /// <summary>
        /// 商品id
        /// </summary>        
        public int GoodsId
        {
            get;
            set;
        }

        /// <summary>
        /// 删除状态0-否，1-是
        /// </summary>        
        public int Status
        {
            get;
            set;
        }



        /// <summary>
        /// 订单商品id
        /// </summary>        
        public int OrderGoodsId
        {
            get;
            set;
        }

        /// <summary>
        /// 商品名称
        /// </summary>        
        public string GoodsName
        {
            get;
            set;
        }

        /// <summary>
        /// 规格
        /// </summary>        
        public string Specification
        {
            get;
            set;
        }
        /// <summary>
        /// 规格key
        /// </summary>
        public string SpecificationSort { get; set; }

        /// <summary>
        /// 货号
        /// </summary>        
        public string ProductCode
        {
            get;
            set;
        }



        /// <summary>
        /// 商户号
        /// </summary>        
        public int TenantId
        {
            get;
            set;
        }
        /// <summary>
        /// 小程序id
        /// </summary>        
        public int MallBaseId
        {
            get;
            set;
        }



        /// <summary>
        /// 成本价
        /// </summary>
        public decimal? CostMoney { get; set; }
    }
}
