﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 请购单
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Property_BuyingRequisition
    {

        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 请购单名称
        /// </summary>        
        public string Name
        {
            get;
            set;
        }
        /// <summary>
        /// 类型  1资产  2耗材
        /// </summary>        
        public int? Type
        {
            get;
            set;
        }
        /// <summary>
        /// 分类id   0表示没有
        /// </summary>        
        public int? CategoryId
        {
            get;
            set;
        }
        /// <summary>
        /// 购买状态   1已购买  2购买中  3驳回  4待处理
        /// </summary>        
        public BuyingRequisitionStatusEnum? BuyStatus
        {
            get;
            set;
        }
        /// <summary>
        /// 内容
        /// </summary>        
        public string Content
        {
            get;
            set;
        }
        /// <summary>
        /// 预计使用日期
        /// </summary>
        public DateTime? UseTime { get; set; }
        /// <summary>
        /// 购买日期
        /// </summary>
        public DateTime? BuyTime { get; set; }

        /// <summary>
        /// /驳回备注
        /// </summary>
        public string RejectRemark { get; set; }
        /// <summary>
        /// 状态 0正常  1删除
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 公司
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// CreateBy
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// CreateDate
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateBy
        /// </summary>        
        public int? UpdateBy
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateDate
        /// </summary>        
        public DateTime? UpdateDate
        {
            get;
            set;
        }
    }
}