﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产盘点明细实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Property_CheckDetail
    {

        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 资产id
        /// </summary>        
        public int? PropertyId
        {
            get;
            set;
        }
        /// <summary>
        /// 盘点期数id
        /// </summary>        
        public int? CheckId
        {
            get;
            set;
        }
        /// <summary>
        /// 审核状态  1未审核  2已审核  3审核驳回
        /// </summary>        
        public int? AuditStatus
        {
            get;
            set;
        }
        /// <summary>
        /// 盘点状态
        /// </summary>        
        public PropertyCheckStatusEnum? CheckStatus
        {
            get;
            set;
        }
        /// <summary>
        /// 盘点人
        /// </summary>        
        public int? CheckEmpId
        {
            get;
            set;
        }
        /// <summary>
        /// 盘点时间
        /// </summary>        
        public DateTime? CheckDate
        {
            get;
            set;
        }
        /// <summary>
        /// 审核人
        /// </summary>        
        public int? AuditEmpId
        {
            get;
            set;
        }
        /// <summary>
        /// 审核时间
        /// </summary>        
        public DateTime? AuditDate
        {
            get;
            set;
        }
        /// <summary>
        /// 备注
        /// </summary>        
        public string Remark
        {
            get;
            set;
        }
        /// <summary>
        /// 状态 0正常  1删除
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 公司
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// CreateBy
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// CreateDate
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateBy
        /// </summary>        
        public int? UpdateBy
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateDate
        /// </summary>        
        public DateTime? UpdateDate
        {
            get;
            set;
        }
        /// <summary>
        /// 盘点盈亏处理状态  0未处理  1已处理
        /// </summary>
        public int? DealStatus { get; set; } = 0;
        /// <summary>
        /// 盘点图片
        /// </summary>
        public string Images { get; set; }
    }
}