﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产信息实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Property_Info
    {

        /// <summary>
        /// rId
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 资产名称
        /// </summary>        
        public string Name
        {
            get;
            set;
        }
        /// <summary>
        /// 资产编码
        /// </summary>        
        public string PropertyNum
        {
            get;
            set;
        }
        /// <summary>
        /// 分类id
        /// </summary>        
        public int? CategoryId
        {
            get;
            set;
        }
        /// <summary>
        /// 品牌
        /// </summary>        
        public string BrandName
        {
            get;
            set;
        }
        /// <summary>
        /// 金额
        /// </summary>        
        public decimal? Money
        {
            get;
            set;
        }
        /// <summary>
        /// 购置日期
        /// </summary>        
        public DateTime? BuyDate
        {
            get;
            set;
        }
        /// <summary>
        /// 购置方式
        /// </summary>        
        public PropertyBuyTypeEnum? BuyType
        {
            get;
            set;
        }
        /// <summary>
        /// 计量单位
        /// </summary>        
        public string Units
        {
            get;
            set;
        }
        /// <summary>
        /// 预计使用期限(月份)   到了期限   提醒 可以更新新的咯
        /// </summary>        
        public int? UseMonths
        {
            get;
            set;
        }
        /// <summary>
        /// 1正常  2维修中
        /// </summary>        
        public PropertyUseStateEnum? UseStatus
        {
            get;
            set;
        }
        /// <summary>
        /// 资产状态 1空闲  2领用  3借用  4调拨中 5领用待确认 6退库待确认  7借用待确认  8归还待确认
        /// </summary>        
        public PropertyStatusEnum? PropertyStatus
        {
            get;
            set;
        }
        /// <summary>
        /// 型号
        /// </summary>        
        public string PropertyModel
        {
            get;
            set;
        }
        /// <summary>
        /// 资产图片
        /// </summary>        
        public string Images
        {
            get;
            set;
        }
        /// <summary>
        /// 序列号
        /// </summary>        
        public string SerialNumber
        {
            get;
            set;
        }
        /// <summary>
        /// 备注
        /// </summary>        
        public string Remark
        {
            get;
            set;
        }
        /// <summary>
        /// 使用人
        /// </summary>        
        public int? EmployeeId
        {
            get;
            set;
        }
        /// <summary>
        /// 领用/借用时间
        /// </summary>        
        public DateTime? GetTime
        {
            get;
            set;
        }
        /// <summary>
        /// 退库/归还时间
        /// </summary>        
        public DateTime? BackTime
        {
            get;
            set;
        }

        /// <summary>
        /// 供应商id
        /// </summary>
        public int? SupplierId { get; set; }

        /// <summary>
        /// 状态 0 正常 1删除
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 公司
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// CreateBy
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// CreateDate
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateBy
        /// </summary>        
        public int? UpdateBy
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateDate
        /// </summary>        
        public DateTime? UpdateDate
        {
            get;
            set;
        }
        /// <summary>
        /// 资产所属公司
        /// </summary>
        public int? BranchId { get; set; }

        /// <summary>
        /// 资产二维码
        /// </summary>
        public string QRCode { get; set; }
    }
}