﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产日志实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Property_Log
    {

        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 资产的id
        /// </summary>        
        public int? PropertyId
        {
            get;
            set;
        }
        /// <summary>
        /// 类型名称
        /// </summary>        
        public string TypeName
        {
            get;
            set;
        }
        /// <summary>
        /// 内容
        /// </summary>        
        public string Content
        {
            get;
            set;
        }
        /// <summary>
        /// 状态 0正常  1删除
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 公司
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// CreateBy
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// CreateDate
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }

        /// <summary>
        /// 签名图片
        /// </summary>
        public int? RecordId { get; set; } = 0;
        /// <summary>
        /// 是否是签名 0否  1是
        /// </summary>
        public int? IsSignature { get; set; } = 0;
    }
}