﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产使用表实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Property_UseReceive
    {

        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 编码
        /// </summary>
        public string OrderCode { get; set; }
        /// <summary>
        /// 领取人
        /// </summary>        
        public int? EmployeeId
        {
            get;
            set;
        }
        /// <summary>
        /// 领取时间
        /// </summary>        
        public DateTime? Time
        {
            get;
            set;
        }
        /// <summary>
        /// 归还时间
        /// </summary>        
        public DateTime? BackTime
        {
            get;
            set;
        }
        /// <summary>
        /// 审批状态
        /// </summary>        
        public OrderStateEnum? AuditStatus
        {
            get;
            set;
        }

        /// <summary>
        /// 调入公司id
        /// </summary>        
        public int? InBranchId
        {
            get;
            set;
        }
        /// <summary>
        /// 维修图片
        /// </summary>        
        public string Images
        {
            get;
            set;
        }
        /// <summary>
        /// 联系电话
        /// </summary>        
        public string Remark
        {
            get;
            set;
        }
        /// <summary>
        /// 状态 0正常  1删除
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 来源   1领取 2退库 3借用 4归还 5调拨 6维修 7处置
        /// </summary>        
        public PropertySourceEnum? Source
        {
            get;
            set;
        }
        /// <summary>
        /// 处置类型 
        /// </summary>        
        public PropertyDisposeEnum? DisposeType
        {
            get;
            set;
        }
        /// <summary>
        /// 处置金额
        /// </summary>
        public decimal? DisposeMoney { get; set; }
        /// <summary>
        /// 公司
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// CreateBy
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// CreateDate
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateBy
        /// </summary>        
        public int? UpdateBy
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateDate
        /// </summary>        
        public DateTime? UpdateDate
        {
            get;
            set;
        }
        /// <summary>
        /// 使用部门
        /// </summary>
        public int? DepartmentId { get; set; }
        /// <summary>
        /// 使用公司
        /// </summary>
        public int? BranchId { get; set; }
        /// <summary>
        /// 使用流程id
        /// </summary>
        public int? TempleteId { get; set; }
        /// <summary>
        /// 是否自助申请  1是  0否
        /// </summary>
        public int? IsSelfApplication { get; set; } = 0;
        /// <summary>
        /// 原领用人  有值表示变更领用人
        /// </summary>
        public int? ChangePerson { get; set; } = 0;
        /// <summary>
        /// 原领用时间
        /// </summary>
        public DateTime? ChangeTime { get; set; }
    }
}