﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产使用关联表实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Property_UseRelevance
    {

        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 关联接收id
        /// </summary>        
        public int? ReceiveId
        {
            get;
            set;
        }
        /// <summary>
        /// 关联资产id
        /// </summary>        
        public int? PropertyId
        {
            get;
            set;
        }
        /// <summary>
        /// 维修金额
        /// </summary>        
        public decimal? MendMoney
        {
            get;
            set;
        }
        /// <summary>
        /// 快递单号
        /// </summary>        
        public string ExpressNumber
        {
            get;
            set;
        }
        /// <summary>
        /// 备注
        /// </summary>        
        public string Remark
        {
            get;
            set;
        }
        /// <summary>
        /// 状态 0正常  1删除
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 公司
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// CreateBy
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// CreateDate
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateBy
        /// </summary>        
        public int? UpdateBy
        {
            get;
            set;
        }
        /// <summary>
        /// UpdateDate
        /// </summary>        
        public DateTime? UpdateDate
        {
            get;
            set;
        }
        /// <summary>
        /// 退库前使用人
        /// </summary>
        public int? CancelStockEmployeeId { get; set; }

        /// <summary>
        /// 以前公司（调拨）
        /// </summary>
        public int? HistoryBranchId { get; set; }
    }
}