﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 资产报损实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Supplies_ReportLossRecord
    {

        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }

        /// <summary>
        /// 盘点期数id
        /// </summary>        
        public int? CheckId
        {
            get;
            set;
        }

        /// <summary>
        /// 出库/入库id
        /// </summary>
        public int OutOrInId { get; set; }

        /// <summary>
        /// 报损/报溢  自动生成财务单据
        /// </summary>        
        public int? FinanceId
        {
            get;
            set;
        }


        /// <summary>
        /// 盘点状态
        /// </summary>        
        public PropertyCheckStatusEnum? CheckStatus
        {
            get;
            set;
        }

        /// <summary>
        /// 仓库id
        /// </summary>        
        public int? WarehouseId
        {
            get;
            set;
        }

        /// <summary>
        /// 备注
        /// </summary>        
        public string Remark
        {
            get;
            set;
        }
        /// <summary>
        /// 状态 0正常  1删除
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 公司
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// CreateBy
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// CreateDate
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }

    }
}