﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 耗材盘点报损记录详情
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "PropertyConnection")]
    public class RB_Supplies_ReportLossRecordDetail
    {

        /// <summary>
        /// Id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }

        /// <summary>
        /// 盘点期数id
        /// </summary>        
        public int? CheckId
        {
            get;
            set;
        }
        /// <summary>
        /// 盘点商品对应的id
        /// </summary>
        public int CheckDetailId { get; set; }

        /// <summary>
        /// 报损记录id
        /// </summary>        
        public int? ReportLossRecordId
        {
            get;
            set;
        }
        /// <summary>
        /// 耗材id
        /// </summary>        
        public int? SuppliesId
        {
            get;
            set;
        }
       
        /// <summary>
        /// 报损数量
        /// </summary>        
        public int? ReportLossNum
        {
            get;
            set;
        }

        /// <summary>
        /// 报损价格
        /// </summary>        
        public decimal? ReportLossPrice
        {
            get;
            set;
        }
        /// <summary>
        /// 盘点状态
        /// </summary>        
        public PropertyCheckStatusEnum? CheckStatus
        {
            get;
            set;
        }
        
        /// <summary>
        /// 备注(报损 /报溢 需备注记录  出库单号/入库单号)
        /// </summary>        
        public string Remark
        {
            get;
            set;
        }
       
        /// <summary>
        /// 状态 0正常  1删除
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 公司
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// CreateBy
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// CreateDate
        /// </summary>        
        public DateTime? CreateDate
        {
            get;
            set;
        }
       
    }
}