﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// RB_Audit_Dlegate Entity
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Audit_Delegate
    {

        /// <summary>
        /// 委托id
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 发起人
        /// </summary>    
        [RequiredValidate(showMessage = "发起人不能为空")]
        public int InitiatorEmpId
        {
            get;
            set;
        }
        /// <summary>
        /// 接收人
        /// </summary>
        [RequiredValidate(showMessage ="接收人不能为空")]
        public int ReciveEmpId
        {
            get;
            set;
        }
        /// <summary>
        /// 开始时间
        /// </summary>     
        [RequiredValidate(showMessage = "开始时间不能为空")]
        public DateTime StartDate
        {
            get;
            set;
        }
        /// <summary>
        /// 结束时间
        /// </summary>       
        [RequiredValidate(showMessage = "结束时间不能为空")]
        public DateTime EndDate
        {
            get;
            set;
        }
        /// <summary>
        /// 委托内容 1:工作审批，2：单据审批，3：客户审批(1,2)
        /// </summary>  
        [RequiredValidate(showMessage = "委托内容不能为空")]
        public string DelegateContent
        {
            get;
            set;
        }
        /// <summary>
        /// 委托状态 1：正常，2：已撤销，3：删除
        /// </summary>        
        public DelegateStateEnum DelegateState
        {
            get;
            set;
        }
        /// <summary>
        /// 创建时间
        /// </summary>        
        public DateTime CreateDate
        {
            get;
            set;
        }
        ///// <summary>
        ///// 父节点id
        ///// </summary>        
        //public int ParentId
        //{
        //    get;
        //    set;
        //}
        ///// <summary>
        ///// 根节点id
        ///// </summary>        
        //public int RootId
        //{
        //    get;
        //    set;
        //}
        ///// <summary>
        ///// 委托人顺序
        ///// </summary>        
        //public string DelegateEmpPath
        //{
        //    get;
        //    set;
        //}
    }
}
