﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{
    /// <summary>
    /// 分公司实体类
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Branch
    {

        /// <summary>
        /// 主键
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 分公司名称
        /// </summary> 
        [RequiredValidate(showMessage = "请输入公司名称")]
        [StringRangeValidate(1, 100, showMessage = "公司名称不能超过100个字符")]
        public string BName
        {
            get;
            set;
        }
        /// <summary>
        /// 域名
        /// </summary>      
        [StringRangeValidate(1, 50, showMessage = "域名不能超过50个字符")]
        public string Domain
        {
            get;
            set;
        }
        /// <summary>
        /// 联系人
        /// </summary>    
        [StringRangeValidate(1, 50, showMessage = "联系人不能超过50个字符")]
        public string ContactPersion
        {
            get;
            set;
        }
        /// <summary>
        /// 手机号码
        /// </summary>        
        [StringRangeValidate(1, 20, showMessage = "手机号码不能超过20个字符")]
        public string MobilePhone
        {
            get;
            set;
        }
        /// <summary>
        /// 座机
        /// </summary>      
        [StringRangeValidate(1, 50, showMessage = "座机不能超过50个字符")]
        public string Tel
        {
            get;
            set;
        }
        /// <summary>
        /// 联系地址
        /// </summary> 
        [StringRangeValidate(1, 100, showMessage = "地址不能超过100个字符")]
        public string Address
        {
            get;
            set;
        }
        /// <summary>
        /// 备注
        /// </summary>  
        [StringRangeValidate(1, 500, showMessage = "备注不能超过500个字符")]
        public string Remarks
        {
            get;
            set;
        }
        /// <summary>
        /// 状态(0开启/1冻结)
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 创建时间
        /// </summary>        
        public DateTime CreateTime
        {
            get;
            set;
        }
        /// <summary>
        /// 创建人
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// 更新时间
        /// </summary>        
        public DateTime UpdateTime
        {
            get;
            set;
        }
        /// <summary>
        /// 更新人
        /// </summary>        
        public int? Updateby
        {
            get;
            set;
        }
        /// <summary>
        /// 所属集团编号
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 出团通知书名称
        /// </summary>       
        [StringRangeValidate(1, 50, showMessage = "出团通知书不能超过50个字符")]
        public string NoticesName
        {
            get;
            set;
        }
        /// <summary>
        /// 机场服务人员
        /// </summary>        
        [StringRangeValidate(1, 50, showMessage = "机场服务人员不能超过50个字符")]
        public string AirportServicePerson
        {
            get;
            set;
        }
        /// <summary>
        /// 机场服务人员联系电话
        /// </summary>     
        [StringRangeValidate(1, 100, showMessage = "机场服务人员联系电话不能超过100个字符")]
        public string AirportServicePhone
        {
            get;
            set;
        }
        /// <summary>
        /// 是否显示0-显示1-不显示
        /// </summary>        
        public int? is_show
        {
            get;
            set;
        }
        /// <summary>
        /// 负责人
        /// </summary>        
        public int? BranchManager
        {
            get;
            set;
        }
        /// <summary>
        /// 是否为总公司
        /// </summary>
        public int? IsParentCompany
        {
            get; set;
        }
        /// <summary>
        /// 部门初始层级
        /// </summary>
        public int? BeginTier { get; set; }

        /// <summary>
        /// 所在城市
        /// </summary>
        public int? City { get; set; }

        /// <summary>
        /// 所在省份
        /// </summary>
        public int? Province { get; set; }
        /// <summary>
        /// 公司的确认章
        /// </summary>
        public string ConfirmationSignet { get; set; }

        /// <summary>
        /// 确认件抬头
        /// </summary>        
        public string CompanyTitle { get; set; }
        /// <summary>
        /// 集合时间
        /// </summary>
        public string GatheringTime { get; set; }
        /// <summary>
        /// 集合地点
        /// </summary>
        public string GatheringAddress { get; set; }
        /// <summary>
        /// 行程logo
        /// </summary>
        public string TravelLogo { get; set; }

        /// <summary>
        /// B2B是否显示 0-显示1-不显示
        /// </summary>        
        public int? B2BShow
        {
            get;
            set;
        }
        /// <summary>
        /// 坐标地址
        /// </summary>
        public string lnglat { get; set; }
    }
}