﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// rb_department Entity
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Department
    {

        /// <summary>
        /// 主键
        /// </summary>        
        public int DepartmentID
        {
            get;
            set;
        }
        /// <summary>
        /// 部门名称
        /// </summary>        
        [RequiredValidate(showMessage = "请输入部门名称")]
        [StringRangeValidate(1, 255, showMessage = "部门名称不能超过255个字符")]
        public string DepartmentName
        {
            get;
            set;
        }
        /// <summary>
        /// 负责人（弃用，请使用新的字段ManagerIds）
        /// </summary>        
        public int? DepartmentManager
        {
            get;
            set;
        }
        /// <summary>
        /// 联系电话
        /// </summary>   
        [StringRangeValidate(1, 50, showMessage = "部门名称不能超过50个字符")]
        public string DepartmentTel
        {
            get;
            set;
        }
        /// <summary>
        /// 集团编号
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 分公司编号
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 创建时间
        /// </summary>        
        public DateTime CreateTime
        {
            get;
            set;
        }
        /// <summary>
        /// 创建人
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// 更新时间
        /// </summary>        
        public DateTime UpdateTime
        {
            get;
            set;
        }
        /// <summary>
        /// 更新人
        /// </summary>        
        public int? UpdateBy
        {
            get;
            set;
        }
        /// <summary>
        /// 状态(0开启/1冻结)
        /// </summary>        
        public int? Status
        {
            get;
            set;
        }

        /// <summary>
        /// 父级节点id
        /// </summary>
        public int? ParentId { get; set; }

        /// <summary>
        /// 层级
        /// </summary>
        public int? Tier { get; set; }

        /// <summary>
        /// 根节点id
        /// </summary>
        public int? RootId { get; set; }
        /// <summary>
        /// 排序
        /// </summary>
        public int? Sort { get; set; }
        /// <summary>
        /// 是否是领队  0不是  1是
        /// </summary>
        public int? IsLeader { get; set; }

        /// <summary>
        /// 部门负责人（1,2）
        /// </summary>        
        public string ManagerIds
        {
            get;
            set;
        }
    }
}