﻿using REBORN.Common.AOP;
using REBORN.Common.Plugin;
using System;

namespace Property.Model.Entity
{
    /// <summary>
    /// rb_group Entity
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Group
    {

        /// <summary>
        /// 主键
        /// </summary>        
        public int Id
        {
            get;
            set;
        }
        /// <summary>
        /// 集团名称
        /// </summary>     
        [RequiredValidate(showMessage = "请输入集团名称")]
        [StringRangeValidate(1, 100, showMessage = "集团名称不能超过100个字符")]
        public string GroupName
        {
            get;
            set;
        }
        /// <summary>
        /// 域名
        /// </summary>        
        [StringRangeValidate(1, 50, showMessage = "域名不能超过50个字符")]
        public string Domain
        {
            get;
            set;
        }
        /// <summary>
        /// 联系人
        /// </summary>     
        [StringRangeValidate(1, 50, showMessage = "联系人不能超过50个字符")]
        public string ContactPersion
        {
            get;
            set;
        }
        /// <summary>
        /// 联系电话(手机)
        /// </summary>   
        [StringRangeValidate(1, 100, showMessage = "联系电话不能超过100个字符")]
        public string MobilePhone
        {
            get;
            set;
        }
        /// <summary>
        /// 座机
        /// </summary>        
        [StringRangeValidate(1, 100, showMessage = "座机不能超过100个字符")]
        public string Tel
        {
            get;
            set;
        }
        /// <summary>
        /// 地址
        /// </summary>        
        [StringRangeValidate(1, 100, showMessage = "地址不能超过100个字符")]
        public string Address
        {
            get;
            set;
        }
        /// <summary>
        /// 备注
        /// </summary>        
        [StringRangeValidate(1, 100, showMessage = "备注不能超过500个字符")]
        public string Remarks
        {
            get;
            set;
        }
        /// <summary>
        /// 状态
        /// </summary>        
        public REBORN.Common.Enum.DateStateEnum? Status
        {
            get;
            set;
        }
        /// <summary>
        /// 创建时间
        /// </summary>        
        public DateTime CreateTime
        {
            get;
            set;
        }
        /// <summary>
        /// 创建人变化
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }
        /// <summary>
        /// 更新时间
        /// </summary>        
        public DateTime UpdateTime
        {
            get;
            set;
        }
        /// <summary>
        /// 更新人
        /// </summary>        
        public int? UpdateBy
        {
            get;
            set;
        }
        /// <summary>
        /// 出团通知名
        /// </summary>        
        [StringRangeValidate(1, 50, showMessage = "出团通知书不能超过50个字符")]
        public string NoticesName
        {
            get;
            set;
        }
        /// <summary>
        /// 机场服务人员
        /// </summary>       
        [StringRangeValidate(1, 50, showMessage = "机场服务人员不能超过50个字符")]
        public string AirportServicePerson
        {
            get;
            set;
        }
        /// <summary>
        /// 机场服务人员电话
        /// </summary>      
        [StringRangeValidate(1, 100, showMessage = "机场服务人员电话不能超过100个字符")]
        public string AirportServicePhone
        {
            get;
            set;
        }
        /// <summary>
        /// 别名
        /// </summary>      
        [StringRangeValidate(1, 200, showMessage = "别名不能超过200个字符")]
        public string Aliases
        {
            get;
            set;
        }
        /// <summary>
        /// 版本id
        /// </summary>        
        public int? Versions_Id
        {
            get;
            set;
        }
        /// <summary>
        /// 部门最大层级
        /// </summary>
        public int? MaxDepartmentTier { get; set; }
        /// <summary>
        /// logo
        /// </summary>
        public string Logo { get; set; }
        /// <summary>
        /// 绑定的管理员帐号
        /// </summary>
        public int? AdminAccount { get; set; }

        /// <summary>
        /// 绑定的管理员角色
        /// </summary>
        public int? AdminRole { get; set; }

        /// <summary>
        /// B2B域名
        /// </summary>
        public string B2BDomain { get; set; }

        /// <summary>
        /// 集团下账户数量
        /// </summary>
        public int? EmployeeNum { get; set; }
    }
}