﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{

    /// <summary>
    /// 岗位实体
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Post
    {
        /// <summary>
        /// 主键
        /// </summary>        
        public int PostId
        {
            get;
            set;
        }

        /// <summary>
        /// 职位名称
        /// </summary>        
        [RequiredValidate(showMessage = "请输入岗位名称")]
        [StringRangeValidate(1, 50, showMessage = "岗位名称不能超过50个字符")]
        public string PostName
        {
            get;
            set;
        }

        /// <summary>
        /// 部门编号
        /// </summary>        
        public int RB_Department_Id
        {
            get;
            set;
        }

        /// <summary>
        /// 集团编号
        /// </summary>        
        public int? RB_Group_Id
        {
            get;
            set;
        }

        /// <summary>
        /// 分公司编号
        /// </summary>        
        public int? RB_Branch_Id
        {
            get;
            set;
        }

        /// <summary>
        /// 创建时间
        /// </summary>        
        public DateTime CreateTime
        {
            get;
            set;
        }

        /// <summary>
        /// 创建人
        /// </summary>        
        public int? CreateBy
        {
            get;
            set;
        }

        /// <summary>
        /// 修改时间
        /// </summary>        
        public DateTime UpdateTime
        {
            get;
            set;
        }

        /// <summary>
        /// 修改人
        /// </summary>        
        public int? UpdateBy
        {
            get;
            set;
        }

        /// <summary>
        /// 状态(0开启/1冻结)
        /// </summary>        
        public REBORN.Common.Enum.DateStateEnum? Status
        {
            get;
            set;
        }

        /// <summary>
        /// 是否应用分区 1是  2否
        /// </summary>
        public int? IsUseSubarea { get; set; }
    }
}