﻿using System;
using REBORN.Common.AOP;
using REBORN.Common.Plugin;

namespace Property.Model.Entity
{
    /// <summary>
    /// ERP系统菜单实体表
    /// </summary> 
    [Serializable]
    [DB(ConnectionName = "DefaultConnection")]
    public class RB_Sys_Menu
    {
        /// <summary>
        /// 主键
        /// </summary>        
        public int MenuId
        {
            get;
            set;
        }
        /// <summary>
        /// 菜单名称
        /// </summary>  
        [RequiredValidate(showMessage = "请输入菜单名称")]
        [StringRangeValidate(1, 255, showMessage = "菜单名称不能超过255个字符")]
        public string MenuName
        {
            get;
            set;
        }

        /// <summary>
        /// 菜单URL
        /// </summary> 
        [StringRangeValidate(1, 255, showMessage = "菜单地址不能超过255个字符")]
        public string MenuUrl
        {
            get;
            set;
        }

        /// <summary>
        /// 父节点编号
        /// </summary>        
        public int? ParentId
        {
            get;
            set;
        }

        /// <summary>
        /// 菜单样式(json字符串)
        /// </summary>        
        [StringRangeValidate(1, 255, showMessage = "菜单样式不能超过255个字符")]
        public string MenuStyle
        {
            get;
            set;
        }

        /// <summary>
        /// 状态(参考枚举)
        /// </summary>        
        public int? MenuStatus
        {
            get;
            set;
        }

        /// <summary>
        /// 层级
        /// </summary>
        public int? Tier { get; set; }

        /// <summary>
        /// 根节点id
        /// </summary>
        public int? RootId { get; set; }

        /// <summary>
        /// 排序
        /// </summary>
        public int? Sort { get; set; }

        /// <summary>
        /// 分组代码
        /// </summary>
        public string GroupingCode { get; set; }
        /// <summary>
        /// 菜单类型  1系统菜单  2资产菜单
        /// </summary>
        public int? MenuType { get; set; } = 1;
    }
}