﻿using REBORN.Common.AOP;
using Property.Model.Entity;
using System;
using System.Collections.Generic;

namespace Property.Model.Extend
{
    /// <summary>
    /// 财务 审批流程模版扩展实体
    /// </summary>
    [Serializable]
    [DB(ConnectionName = "FinanceConnection")]
    public class Rb_Workflow_Template_Finance_Extend : Rb_Workflow_Template
    {
        /// <summary>
        /// 工作流 条件表
        /// </summary>
        public Rb_Workflow_Condition_Extend Workflow_Condition { get; set; }


        /// <summary>
        /// 财务流程关联
        /// </summary>
        public List<RB_FinanceFlowConnect> FinancialInstitutions { get; set; }

        /// <summary>
        /// 公司流程列表
        /// </summary>
        public List<BranchProcess> BranchProcess { get; set; }
        /// <summary>
        /// 流程适用账户
        /// </summary>
        public List<int> list { get; set; }

        /// <summary>
        /// 不显示时   可以使用流程的员工
        /// </summary>
        public List<int> ShowEmployeeList { get; set; }
        /// <summary>
        /// 不显示时   可以使用流程的部门
        /// </summary>
        public List<int> ShowDepartmentList { get; set; }

        /// <summary>
        /// 子流程数量
        /// </summary>
        public int? FlowNum { get; set; }

        ///// <summary>
        ///// 费用类型数量
        ///// </summary>
        //public int CostNum { get; set; }

        ///// <summary>
        ///// 公司数量
        ///// </summary>
        //public string CompanyNum { get; set; }
        /// <summary>
        /// 公司名称
        /// </summary>
        public string BName { get; set; }
        /// <summary>
        /// 1-公司，3-集团通用
        /// </summary>
        public int? FinanceFlowConnectType { get; set; }
        /// <summary>
        /// 费用类型集合
        /// </summary>
        public List<string> CoseTypeList { get; set; }

        /// <summary>
        /// 对象名称集合
        /// </summary>
        public List<string> SuitableObjectNameList { get; set; }
        /// <summary>
        /// 对象数量
        /// </summary>
        public int? SuitableObjectCount { get; set; }
        /// <summary>
        /// 获取模板类型1-基础模板2-自定义模板
        /// </summary>
        public int? TempLateWay { get; set; }
        /// <summary>
        /// 基础模板ID
        /// </summary>
        public string TemplateIds { get; set; }
        /// <summary>
        /// 费用类型id
        /// </summary>
        public int? CostTypeId { get; set; }

    }
    /// <summary>
    /// 公司流程
    /// </summary>
    public class BranchProcess
    {
        /// <summary>
        /// 公司ID
        /// </summary>
        public int? Branch_Id { get; set; }
        /// <summary>
        /// 公司名称
        /// </summary>
        public string BName { get; set; }
        /// <summary>
        /// 已开启的基础流程数量
        /// </summary>
        public int? IsSet { get; set; }
        /// <summary>
        /// 自定义流程数量
        /// </summary>
        public int? Num { get; set; }
    }
}
