﻿using REBORN.Common;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;
using Property.Model.Entity;
using Property.Model.Extend;
using Property.Repository;
using System;
using System.Collections.Generic;
using System.Linq;
using Newtonsoft.Json;
using REBORN.Commom.Plugin;
using REBORN.Common.API;
using System.Data;
using REBORN.IM.Service;

namespace Property.Module.FixedAssets
{
    /// <summary>
    /// 登录模块
    /// </summary>
    public class PropertyModule
    {
        /// <summary>
        /// 资产分类
        /// </summary>
        private readonly RB_Property_CategoryRepository property_CategoryRepository = new RB_Property_CategoryRepository();
        /// <summary>
        /// 资产信息
        /// </summary>
        private readonly RB_Property_InfoRepository property_InfoRepository = new RB_Property_InfoRepository();

        /// <summary>
        /// 资产日志
        /// </summary>
        private readonly RB_Property_LogRepository property_LogRepository = new RB_Property_LogRepository();
        /// <summary>
        /// 供应商
        /// </summary>
        private readonly RB_Property_SupplierRepository property_SupplierRepository = new RB_Property_SupplierRepository();

        private readonly RB_Property_SignatureRelevanceRepository signatureRelevanceRepository = new RB_Property_SignatureRelevanceRepository();
        private readonly RB_Property_AuditRelevanceRepository auditRelevanceRepository = new RB_Property_AuditRelevanceRepository();

        /// <summary>
        /// 资产使用
        /// </summary>
        private readonly RB_Property_UseReceiveRepository useReceiveRepository = new RB_Property_UseReceiveRepository();
        /// <summary>
        /// 资产使用关联
        /// </summary>
        private readonly RB_Property_UseRelevanceRepository useRelevanceRepository = new RB_Property_UseRelevanceRepository();
        /// <summary>
        /// 请购单
        /// </summary>
        private readonly RB_Property_BuyingRequisitionRepository property_BuyingRequisitionRepository = new RB_Property_BuyingRequisitionRepository();

        private readonly Rb_branchRepository branchRepository = new Rb_branchRepository();
        private readonly Rb_departmentRepository departmentRepository = new Rb_departmentRepository();
        private readonly Rb_employeeRepository employeeRepository = new Rb_employeeRepository();

        //流程
        private readonly Rb_Workflow_TemplateRepository workflow_TemplateRepository = new Rb_Workflow_TemplateRepository();
        private readonly RB_FinanceFlowConnectRepository financeFlowConnectRepository = new RB_FinanceFlowConnectRepository();
        private readonly Rb_Workflow_AuditrecordRepository workflow_AuditrecordRepository = new Rb_Workflow_AuditrecordRepository();
        private readonly Rb_Workflow_AuditRelevanceRepository workflow_AuditRelevanceRepository = new Rb_Workflow_AuditRelevanceRepository();
        private readonly RB_Workfolw_Change_LogRepository workfolw_Change_LogRepository = new RB_Workfolw_Change_LogRepository();

        //资产折旧
        private readonly RB_Property_DepreciationRepository property_DepreciationRepository = new RB_Property_DepreciationRepository();
        //资产盘点
        private readonly RB_Property_CheckRepository property_CheckRepository = new RB_Property_CheckRepository();
        private readonly RB_Property_CheckDetailRepository property_CheckDetailRepository = new RB_Property_CheckDetailRepository();
        //耗材库存
        private readonly RB_Supplies_InventoryRepository supplies_InventoryRepository = new RB_Supplies_InventoryRepository();
        //物料档案
        private readonly RB_Supplies_MaterialRepository supplies_MaterialRepository = new RB_Supplies_MaterialRepository();
        private readonly RB_Supplies_StockInRepository supplies_StockInRepository = new RB_Supplies_StockInRepository();
        //流程模板
        private readonly WorkFlowModule workFlowModule = new WorkFlowModule();


        /// <summary>
        /// 获取分页列表
        /// </summary>
        /// <param name="PostID"></param>
        /// <returns></returns>
        public List<RB_Property_Category_Extend> CateporyGetPageList(int pageIndex, int pageSize, RB_Property_Category_Extend demodel, out long count)
        {
            return property_CategoryRepository.GetPageList(pageIndex, pageSize, demodel, out count);
        }

        /// <summary>
        /// 获取分类列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Property_Category_Extend> CateporyGetList(RB_Property_Category_Extend demodel)
        {
            return property_CategoryRepository.GetList(demodel);
        }

        /// <summary>
        /// 获取分类详情
        /// </summary>
        /// <param name="cateporyId"></param>
        /// <returns></returns>
        public RB_Property_Category_Extend GetCateporyInfo(int cateporyId)
        {
            return property_CategoryRepository.GetEntity(cateporyId).RefMapperTo<RB_Property_Category_Extend>();
        }

        /// <summary>
        /// 设置分类详情
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetCateporyInfo(RB_Property_Category_Extend demodel)
        {
            if (demodel.Id > 0)
            {
                var trans = property_CategoryRepository.DbTransaction;
                try
                {
                    var model = property_CategoryRepository.GetEntity(demodel.Id);

                    Dictionary<string, object> files = new Dictionary<string, object>() {
                        { nameof(RB_Property_Category_Extend.Name),demodel.Name},
                        { nameof(RB_Property_Category_Extend.ParentId),demodel.ParentId},
                        { nameof(RB_Property_Category_Extend.Tier),demodel.Tier},
                        { nameof(RB_Property_Category_Extend.UpdateBy),demodel.UpdateBy},
                        { nameof(RB_Property_Category_Extend.UpdateDate),demodel.UpdateDate},
                    };
                    List<WhereHelper> whereHelpers = new List<WhereHelper>() {
                         new WhereHelper(){
                            FiledName=nameof(RB_Property_Category_Extend.Id),
                            FiledValue=demodel.Id,
                            OperatorEnum=OperatorEnum.Equal
                         }
                    };
                    var flag = property_CategoryRepository.Update(files, whereHelpers, trans);
                    if (flag) {
                        if ((flag && model.ParentId != demodel.ParentId) || (flag && model.ParentId == demodel.ParentId && demodel.Status == 1))
                        {//部门换组了
                            RB_Property_Category_Extend dmodel = new RB_Property_Category_Extend
                            {
                                RB_Group_Id = demodel.RB_Group_Id,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                ParentId = demodel.Id
                            };
                            List<RB_Property_Category_Extend> ChildList = property_CategoryRepository.GetList(dmodel);
                            if (ChildList.Count > 0)
                                GetClildMenu(ChildList, demodel.Status, demodel.Tier, trans);
                        }
                    }
                    property_CategoryRepository.DBSession.Commit();
                    return flag;
                }
                catch (Exception ex)
                {
                    LogHelper.Write(ex, "SetCateporyInfo");
                    property_CategoryRepository.DBSession.Rollback("SetCateporyInfo");
                    return false;
                }
            }
            else {
                return property_CategoryRepository.Insert(demodel) > 0;
            }
        }

        /// <summary>
        /// 递归修改所有子分类
        /// </summary>
        /// <param name="ChildList"></param>
        /// <param name="status"></param>
        /// <param name="tier"></param>        
        /// <param name="trans"></param>
        public void GetClildMenu(List<RB_Property_Category_Extend> ChildList, int? status, int? tier, System.Data.IDbTransaction trans)
        {
            foreach (var item in ChildList)
            {
                RB_Property_Category_Extend dmodel = new RB_Property_Category_Extend
                {
                    RB_Group_Id = item.RB_Group_Id,
                    ParentId = item.Id
                };
                List<RB_Property_Category_Extend> ChildList1 = property_CategoryRepository.GetList(dmodel);
                if (ChildList1.Count > 0)
                {
                    GetClildMenu(ChildList1, status, tier + 1, trans);
                }
                if (status == 1) item.Status = 1;
                IDictionary<string, object> fileds = new Dictionary<string, object>
                {
                    { nameof(RB_Property_Category_Extend.Status), item.Status },
                    { nameof(RB_Property_Category_Extend.Tier), tier+1 }
                };

                IList<WhereHelper> whereHelpers = new List<WhereHelper>
                {
                    new WhereHelper()
                    {
                        FiledName = nameof(RB_Property_Category_Extend.Id),
                        FiledValue = item.Id,
                        OperatorEnum = OperatorEnum.Equal
                    }
                };
                property_CategoryRepository.Update(fileds, whereHelpers, trans);
            }
        }

        /// <summary>
        /// 获取资产分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> PropertyGetPageList(int pageIndex, int pageSize, RB_Property_Info_Extend demodel, out long count)
        {
            if (demodel.IsSelectMyProperty == 1) {
                //查询所有领用借用待确认的
                var plist = useRelevanceRepository.GetPropertySureList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = demodel.RB_Group_Id, EmployeeId = demodel.CreateBy });
                demodel.PropertyIdStr = string.Join(",", plist.Select(x => x.PropertyId ?? 0).Distinct());
            }
            var list = property_InfoRepository.GetPageList(pageIndex, pageSize, demodel, out count);

            List<RB_Property_UseReceive_Extend> ulist = new List<RB_Property_UseReceive_Extend>();
            if (demodel.IsSelectMyProperty == 1)
            {
                var clist = list.Where(x => x.PropertyStatus == PropertyStatusEnum.GiveBackW || x.PropertyStatus == PropertyStatusEnum.ReceiveW || x.PropertyStatus == PropertyStatusEnum.BorrowW || x.PropertyStatus == PropertyStatusEnum.CancellingStocksW).ToList();
                if (clist.Any())
                {
                    //查询所有的流程
                    ulist = useReceiveRepository.GetPropertyUseReceiveList(new RB_Property_UseReceive_Extend() { RB_Group_Id = demodel.RB_Group_Id, PropertyIdStr = string.Join(",", clist.Select(x => x.Id)), AuditStatus = OrderStateEnum.Auditing });
                }
            }
            foreach (var item in list)
            {
                if (item.EmployeeId > 0)
                {
                    var emodel = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId);
                    item.EmName = emodel?.EmName ?? "";
                    item.EmBranchId = emodel.RB_Branch_id;
                    item.EmDepartmentId = emodel.RB_Department_Id;
                    item.EmDepartmentName = emodel.DepartName;
                    item.EmBranchName = emodel.BranchName;
                }
                else
                {
                    item.EmName = "";
                }

                if (item.Images == "" || item.Images == null)
                {
                    item.Images = "[]";
                }
                var imglist = JsonConvert.DeserializeObject<List<string>>(item.Images);
                item.ImageList = new List<string>();
                foreach (var img in imglist)
                {
                    item.ImageList.Add(Config.GetFileUrl(img));
                }
                if (demodel.IsSelectMyProperty == 1) {
                    if (item.PropertyStatus == PropertyStatusEnum.ReceiveW || item.PropertyStatus == PropertyStatusEnum.BorrowW || item.PropertyStatus == PropertyStatusEnum.CancellingStocksW || item.PropertyStatus == PropertyStatusEnum.GiveBackW) {
                        var umodel = ulist.Where(x => x.PropertyId == item.Id).FirstOrDefault();
                        if (umodel != null && umodel.TempleteId > 0)
                        {
                            item.UseReceiveId = umodel.Id;
                        }
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 获取资产二维码列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyQRCodeList(RB_Property_Info_Extend demodel)
        {
            var list = property_InfoRepository.GetPropertyQRCodeList(demodel);
            return list;
        }

        /// <summary>
        /// 获取资产履历分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyRecordPageQuery(int pageIndex, int pageSize, RB_Property_Info_Extend demodel, out long count)
        {
            var list = property_InfoRepository.GetPropertyRecordPageQuery(pageIndex, pageSize, demodel, out count);
            if (list.Any())
            {
                //查询资产的日志列表
                string pids = string.Join(",", list.Select(x => x.Id));
                var logList = property_LogRepository.GetList(new RB_Property_Log_Extend() { RB_Group_Id = demodel.RB_Group_Id, PropertyIds = pids, TypeName = demodel.LogType });
                foreach (var item in list)
                {
                    if (item.EmployeeId > 0)
                    {
                        item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                    }
                    else
                    {
                        item.EmName = "";
                    }
                    item.LogList = logList.Where(x => x.PropertyId == item.Id).ToList();
                }
            }
            return list;
        }

        /// <summary>
        /// 获取资产待归还分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyStayBackPageQuery(int pageIndex, int pageSize, RB_Property_Info_Extend demodel, out long count)
        {
            var list = property_InfoRepository.GetPropertyStayBackPageQuery(pageIndex, pageSize, demodel, out count);
            if (list.Any())
            {
                foreach (var item in list)
                {
                    if (item.EmployeeId > 0)
                    {
                        item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                    }
                    else
                    {
                        item.EmName = "";
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 获取资产到期分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyMaturityPageQuery(int pageIndex, int pageSize, RB_Property_Info_Extend demodel, out long count)
        {
            var list = property_InfoRepository.GetPropertyMaturityPageQuery(pageIndex, pageSize, demodel, out count);
            if (list.Any())
            {
                foreach (var item in list)
                {
                    if (item.EmployeeId > 0)
                    {
                        item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                    }
                    else
                    {
                        item.EmName = "";
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 获取资产汇总列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyGroupQuery( RB_Property_Info_Extend demodel)
        {
            var list = property_InfoRepository.GetPropertyGroupQuery(demodel);
            return list;
        }

        /// <summary>
        /// 获取资产详情
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public RB_Property_Info_Extend GetPropertyInfo(RB_Property_Info_Extend demodel)
        {
            var item = property_InfoRepository.GetEntity(demodel.Id).RefMapperTo<RB_Property_Info_Extend>();
           
            if (item.EmployeeId > 0)
            {
                item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
            }
            else
            {
                item.EmName = "";
            }

            if (item.Images == "" || item.Images == null)
            {
                item.Images = "[]";
            }
            var imglist = JsonConvert.DeserializeObject<List<string>>(item.Images);
            item.ImageList = new List<string>();
            foreach (var img in imglist)
            {
                item.ImageList.Add(Config.GetFileUrl(img));
            }
            
            return item;
        }

        /// <summary>
        /// 删除分类
        /// </summary>
        /// <param name="cateporyId"></param>
        /// <returns></returns>
        public bool DelCateporyInfo(int cateporyId, UserInfo userInfo)
        {
            var trans = property_CategoryRepository.DbTransaction;
            try
            {
                var model = property_CategoryRepository.GetEntity(cateporyId);
                Dictionary<string, object> files = new Dictionary<string, object>() {
                    { nameof(RB_Property_Category_Extend.Status),(int)DateStateEnum.Delete},
                    { nameof(RB_Property_Category_Extend.UpdateBy),userInfo.EmployeeId},
                    { nameof(RB_Property_Category_Extend.UpdateDate),DateTime.Now}
                };
                List<WhereHelper> whereHelpers = new List<WhereHelper>() {
                    new WhereHelper(){
                        FiledName=nameof(RB_Property_Category_Extend.Id),
                        FiledValue=cateporyId,
                        OperatorEnum=OperatorEnum.Equal
                    }
                };
                var flag = property_CategoryRepository.Update(files, whereHelpers, trans);
                if (flag)
                {
                    RB_Property_Category_Extend dmodel = new RB_Property_Category_Extend
                    {
                        RB_Group_Id = model.RB_Group_Id,
                        ParentId = model.Id
                    };
                    List<RB_Property_Category_Extend> ChildList = property_CategoryRepository.GetList(dmodel);
                    if (ChildList.Count > 0)
                        GetClildMenu(ChildList, (int)DateStateEnum.Delete, model.Tier, trans);

                }
                property_CategoryRepository.DBSession.Commit();
                return flag;
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "DelCateporyInfo");
                property_CategoryRepository.DBSession.Rollback("DelCateporyInfo");
                return false;
            }
        }

        /// <summary>
        /// 批量导入资产
        /// </summary>
        /// <param name="deList"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult SetPropertyInfoBatchImport(List<RB_Property_Info_Extend> deList, UserInfo userInfo)
        {
            //查询集团下所有的员工列表
            var elist = employeeRepository.GetList(new RB_Employee_Extend() { RB_Group_id = userInfo.RB_Group_id });
            //查询所有的公司
            var blist = branchRepository.GetList(new RB_Branch_Extend() { RB_Group_Id = userInfo.RB_Group_id });
            //查询所有的供应商
            var slist = property_SupplierRepository.GetList(new RB_Property_Supplier_Extend() { RB_Group_Id = userInfo.RB_Group_id });
            //查询所有的资产分类
            var clist = property_CategoryRepository.GetList(new RB_Property_Category_Extend() { RB_Group_Id = userInfo.RB_Group_id });
            //再次验证数据有效性
            foreach (var item in deList) {
                if (!string.IsNullOrEmpty(item.EmName)) {
                    var eclist = elist.Where(x => x.EmName == item.EmName).ToList();
                    if (eclist.Count() > 1)
                    {
                        return ApiResult.ParamIsNull("ID:" + item.Id + ",资产名称:" + item.Name + ",领用人:" + item.EmName + "  匹配有重复人员！请删除此条数据后再试");
                    }
                    else if (eclist.Count() == 0) {
                        return ApiResult.ParamIsNull("ID:" + item.Id + ",资产名称:" + item.Name + ",领用人:" + item.EmName + "  未匹配到领用人！请修改此条数据后再试");
                    }
                    item.EmployeeId = eclist.FirstOrDefault().EmployeeId;
                }
                //公司
                var bModel= blist.Where(x => x.BName.Contains(item.BranchName)).FirstOrDefault();
                if (bModel == null) { 
                    return ApiResult.ParamIsNull("ID:" + item.Id + ",资产名称:" + item.Name + ",领用人:" + item.EmName + "  未匹配到公司信息！请修改此条数据后再试");
                }
                item.BranchId = bModel.Id;
                //分类
                var cModel = clist.Where(x => x.Name==item.CategoryName).FirstOrDefault();
                if (cModel == null)
                {
                    return ApiResult.ParamIsNull("ID:" + item.Id + ",资产名称:" + item.Name + ",领用人:" + item.EmName + "  未匹配到分类信息！请修改此条数据后再试");
                }
                item.CategoryId = cModel.Id;
                //供应商
                var sModel = slist.Where(x => x.Name == item.SupplierName).FirstOrDefault();
                if (sModel == null)
                {
                    return ApiResult.ParamIsNull("ID:" + item.Id + ",资产名称:" + item.Name + ",领用人:" + item.EmName + "  未匹配到供应商信息！请修改此条数据后再试");
                }
                item.SupplierId = sModel.Id;
            }
            var trans = property_InfoRepository.DbTransaction;
            try
            {
                //有效数据批量新增
                foreach (var demodel in deList)
                {
                    demodel.UseStatus = PropertyUseStateEnum.Normal;
                    demodel.PropertyStatus = PropertyStatusEnum.Leisure;
                    demodel.EmployeeId ??= 0;
                    if (demodel.EmployeeId > 0)
                    {
                        demodel.PropertyStatus = PropertyStatusEnum.Receive;
                        demodel.GetTime= Convert.ToDateTime(demodel.StartTime);
                    }
                    demodel.BuyType = PropertyBuyTypeEnum.Purchase;
                    demodel.BuyDate = Convert.ToDateTime(demodel.EndTime);

                    int PropertyId = property_InfoRepository.Insert(demodel, trans);
                    bool flag = PropertyId > 0;
                    if (flag)
                    {
                        //编码自动生成
                        string BMStr = PropertyId.ToString();
                        if (BMStr.Length < 5)
                        {
                            switch (BMStr.Length)
                            {
                                case 1:
                                    BMStr = "0000" + BMStr; break;
                                case 2:
                                    BMStr = "000" + BMStr; break;
                                case 3:
                                    BMStr = "00" + BMStr; break;
                                case 4:
                                    BMStr = "0" + BMStr; break;
                            }
                        }
                        Dictionary<string, object> files = new Dictionary<string, object>() {
                            { nameof(RB_Property_Info.PropertyNum),BMStr}
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Property_Info.Id),
                                  FiledValue=PropertyId,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        property_InfoRepository.Update(files, wheres, trans);
                        string Content = "批量导入资产";
                        if (demodel.EmployeeId > 0)
                        {
                            Content += ";设置使用人：" + demodel.EmName;
                        }
                        //写入日志
                        property_LogRepository.Insert(new RB_Property_Log()
                        {
                            PropertyId = PropertyId,
                            Status = 0,
                            Content = Content,
                            TypeName = "入库",
                            RB_Branch_Id = userInfo.RB_Branch_id,
                            RB_Group_Id = userInfo.RB_Group_id,
                            CreateBy = userInfo.EmployeeId,
                            CreateDate = DateTime.Now
                        }, trans);
                    }
                }
                property_InfoRepository.DBSession.Commit();
                return ApiResult.Success();
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "SetPropertyInfoBatchImport");
                property_InfoRepository.DBSession.Rollback();
                return ApiResult.Failed();
            }
        }

        /// <summary>
        /// 删除资产信息
        /// </summary>
        /// <param name="propertyId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelPropertyInfo(int propertyId, UserInfo userInfo)
        {
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Property_Info.Status),(int)DateStateEnum.Delete},
                { nameof(RB_Property_Info.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Property_Info.UpdateDate),DateTime.Now}
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                     FiledName=nameof(RB_Property_Info.Id),
                      FiledValue=propertyId,
                       OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = property_InfoRepository.Update(files, wheres);
            if (flag) {
                //写入日志
                property_LogRepository.Insert(new RB_Property_Log()
                {
                    PropertyId = propertyId,
                    Status = 0,
                    Content = "删除资产信息",
                    TypeName = "删除",
                    RB_Branch_Id = userInfo.RB_Branch_id,
                    RB_Group_Id = userInfo.RB_Group_id,
                    CreateBy = userInfo.EmployeeId,
                    CreateDate = DateTime.Now
                });
            }
            return flag;
        }

        /// <summary>
        /// 资产保存
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetPropertyInfo(RB_Property_Info_Extend demodel, UserInfo userInfo)
        {
            if (demodel.Id > 0)
            {
                //图片处理
                List<string> imgList = new List<string>();
                ImageOperation(demodel.ImageList, out imgList);//转移图片  未做删除处理
                demodel.Images = JsonConvert.SerializeObject(imgList);

                var dmodel = property_InfoRepository.GetEntity(demodel.Id);
                if (string.IsNullOrEmpty(dmodel.QRCode)) {
                    #region 生成二维码
                    string QRPath = DateTime.Now.Ticks.ToString() + ".png";
                    string basepath = AppContext.BaseDirectory;
                    string path_server = basepath + "\\upfile\\code\\" + QRPath;
                    string ImageAddress = "/upfile/code/" + QRPath;
                    string logoPath = basepath + "\\ExportFile\\Branch\\Logo.png";
                    try
                    {
                        QRCodeHelper.Create_CodeImages("PropertyCheck|Id=" + demodel.Id, 5, logoPath, path_server, System.Drawing.Imaging.ImageFormat.Png);
                    }
                    catch (Exception ex)
                    {
                        LogHelper.Write(ex, "QRCodeHelper.Create_CodeImages");
                        ImageAddress = "";
                    }
                    #endregion
                    dmodel.QRCode = ImageAddress;
                }

                dmodel.BrandName = demodel.BrandName;
                dmodel.BuyDate = demodel.BuyDate;
                dmodel.BuyType = demodel.BuyType;
                dmodel.CategoryId = demodel.CategoryId;
                dmodel.Images = demodel.Images;
                dmodel.Money = demodel.Money;
                dmodel.Name = demodel.Name;
                dmodel.PropertyModel = demodel.PropertyModel;
                dmodel.PropertyNum = demodel.PropertyNum;
                dmodel.Remark = demodel.Remark;
                dmodel.SerialNumber = demodel.SerialNumber;
                dmodel.SupplierId = demodel.SupplierId;
                dmodel.Units = demodel.Units;
                dmodel.UpdateBy = demodel.UpdateBy;
                dmodel.UpdateDate = demodel.UpdateDate;
                dmodel.UseMonths = demodel.UseMonths;
                dmodel.UseStatus = demodel.UseStatus;//暂时
                bool flag = property_InfoRepository.Update(dmodel);
                if (flag)
                {
                    //写入日志
                    property_LogRepository.Insert(new RB_Property_Log()
                    {
                        PropertyId = dmodel.Id,
                        Status = 0,
                        Content = "修改资产信息",
                        TypeName = "修改",
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        CreateBy = userInfo.EmployeeId,
                        CreateDate = DateTime.Now
                    });
                }
                return flag;
            }
            else {
                //图片处理
                List<string> imgList = new List<string>();
                ImageOperation(demodel.ImageList, out imgList);//转移图片  未做删除处理
                demodel.Images = JsonConvert.SerializeObject(imgList);

                demodel.UseStatus = PropertyUseStateEnum.Normal;
                demodel.PropertyStatus = PropertyStatusEnum.Leisure;
                demodel.EmployeeId ??= 0;
                if (demodel.EmployeeId > 0) {
                    demodel.PropertyStatus = PropertyStatusEnum.Receive;
                }

                int PropertyId = property_InfoRepository.Insert(demodel);
                bool flag = PropertyId > 0;
                if (flag)
                {
                    //编码自动生成
                    string BMStr = PropertyId.ToString();
                    if (BMStr.Length < 5) {
                        switch (BMStr.Length) {
                            case 1:
                                BMStr = "0000" + BMStr; break;
                            case 2:
                                BMStr = "000" + BMStr; break;
                            case 3:
                                BMStr = "00" + BMStr; break;
                            case 4:
                                BMStr = "0" + BMStr; break;
                        }
                    }

                    #region 生成二维码
                    string QRPath = DateTime.Now.Ticks.ToString() + ".png";
                    string basepath = AppContext.BaseDirectory;
                    string path_server = basepath + "\\upfile\\code\\" + QRPath;
                    string ImageAddress= "/upfile/code/" + QRPath;
                    string logoPath = basepath + "\\ExportFile\\Branch\\Logo.png";
                    try
                    {
                        QRCodeHelper.Create_CodeImages("PropertyCheck|Id=" + PropertyId, 5, logoPath, path_server, System.Drawing.Imaging.ImageFormat.Png);
                    }
                    catch (Exception ex)
                    {
                        LogHelper.Write(ex, "QRCodeHelper.Create_CodeImages");
                        ImageAddress = "";
                    }
                    

                    #endregion

                    Dictionary<string, object> files = new Dictionary<string, object>() {
                        { nameof(RB_Property_Info.PropertyNum),BMStr},
                        { nameof(RB_Property_Info.QRCode),ImageAddress}
                    };
                    List<WhereHelper> wheres = new List<WhereHelper>() {
                        new WhereHelper(){
                             FiledName=nameof(RB_Property_Info.Id),
                              FiledValue=PropertyId,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    property_InfoRepository.Update(files, wheres);
                    string Content = "新增资产";
                    if (demodel.EmployeeId > 0) {
                        Content += ";设置使用人：" + CacheManager.User.UserReidsCache.GetEmployee(demodel.EmployeeId)?.EmName ?? "";
                    }
                    //写入日志
                    property_LogRepository.Insert(new RB_Property_Log()
                    {
                        PropertyId = PropertyId,
                        Status = 0,
                        Content = Content,
                        TypeName = "入库",
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        CreateBy = userInfo.EmployeeId,
                        CreateDate = DateTime.Now
                    });
                }
                return flag;
            }
        }

        /// <summary>
        /// 设置供应商信息
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetSupplierInfo(RB_Property_Supplier_Extend demodel)
        {
            if (demodel.Id > 0)
            {
                var model = property_SupplierRepository.GetEntity(demodel.Id);
                model.Name = demodel.Name;
                model.Mobile = demodel.Mobile;
                model.Contact = demodel.Contact;
                model.UpdateBy = demodel.UpdateBy;
                model.UpdateDate = DateTime.Now;
                return property_SupplierRepository.Update(model);
            }
            else {
                return property_SupplierRepository.Insert(demodel) > 0;
            }
        }

        /// <summary>
        /// 获取资产日志
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Log_Extend> GetPropertyLogPageList(int pageIndex, int pageSize, RB_Property_Log_Extend demodel, out long count)
        {
            var list = property_LogRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            //看是否有签名
            if (list.Where(x => x.IsSignature == 1).Any()) {
                //查询所有签名的记录
                string RecordIdStr = string.Join(",", list.Where(x => x.IsSignature == 1).Select(x => x.RecordId ?? 0));
                var rlist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { RecordIdStr = RecordIdStr });
                if (rlist.Any())
                {
                    foreach (var item in list.Where(x => x.IsSignature == 1).ToList()) {
                        var rmodel = rlist.Where(x => x.Id == item.RecordId).FirstOrDefault();
                        if (rmodel != null)
                        {
                            item.SignImage = rmodel.SignImage ?? "";
                        }
                        else {
                            item.IsSignature = 0;
                            item.SignImage = "";
                        }
                    }
                }
                else {
                    list.Where(x => x.IsSignature == 1).ToList().ForEach(x =>
                    {
                        x.IsSignature = 0;
                    });
                }
            }
            return list;
        }

        /// <summary>
        /// 删除供应商信息
        /// </summary>
        /// <param name="supplierId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelSupplierInfo(int supplierId, UserInfo userInfo)
        {
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Property_Supplier.Status),(int)DateStateEnum.Delete},
                { nameof(RB_Property_Supplier.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Property_Supplier.UpdateDate),DateTime.Now},
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                 FiledName=nameof(RB_Property_Supplier.Id),
                  FiledValue=supplierId,
                   OperatorEnum=OperatorEnum.Equal
                }
            };
            return property_SupplierRepository.Update(files, wheres);
        }

        /// <summary>
        /// 获取供应商列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Property_Supplier_Extend> GetSupplierList(RB_Property_Supplier_Extend demodel)
        {
            return property_SupplierRepository.GetList(demodel);
        }

        /// <summary>
        /// 获取签字配置列表
        /// </summary>
        /// <param name="GroupId"></param>
        /// <returns></returns>
        public List<RB_Property_SignatureRelevance> GetPropertySignSetList(int GroupId)
        {
            return signatureRelevanceRepository.GetList(new RB_Property_SignatureRelevance() { RB_Group_Id = GroupId });
        }

        /// <summary>
        /// 获取审批配置列表
        /// </summary>
        /// <param name="GroupId"></param>
        /// <returns></returns>
        public List<RB_Property_AuditRelevance> GetPropertyFlowAuditSetList(int GroupId)
        {
            return auditRelevanceRepository.GetList(new RB_Property_AuditRelevance() { RB_Group_Id = GroupId });
        }

        /// <summary>
        /// 获取供应商分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Supplier_Extend> GetSupplierPageList(int pageIndex, int pageSize, RB_Property_Supplier_Extend demodel, out long count)
        {
            return property_SupplierRepository.GetPageList(pageIndex, pageSize, demodel, out count);
        }

        /// <summary>
        /// 处理图片
        /// </summary>
        /// <param name="images"></param>
        /// <param name="imgList"></param>
        private static void ImageOperation(List<string> images, out List<string> imgList)
        {
            imgList = new List<string>();
            if (images != null && images.Count() > 0)
            {
                for (int i = 0; i < images.Count(); i++)
                {
                    string userFile = "/New/Upload/Property/";
                    string NewFileUrl = "";
                    if (Config.GetFilePath(images[i]).Contains("/New/"))
                    {
                        NewFileUrl = Config.GetFilePath(images[i]).Replace("Temporary", "Property");
                    }
                    else
                    {
                        NewFileUrl = "/New" + Config.GetFilePath(images[i]).Replace("Temporary", "Property");
                    }
                    FileCommonHelper.OssFileMove(Config.GetFilePath(images[i]), userFile);
                    imgList.Add(NewFileUrl);
                }
            }
        }

        /// <summary>
        /// 设置审批设置
        /// </summary>
        /// <param name="type"></param>
        /// <param name="enabled"></param>
        /// <param name="auditType"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetPropertyFlowAuditSetList(int type, int enabled, int auditType, UserInfo userInfo)
        {
            if (auditType == 1)
            {
                //审批
                var auditModel = auditRelevanceRepository.GetList(new RB_Property_AuditRelevance() { RB_Group_Id = userInfo.RB_Group_id, Type = (PropertyFlowEnum)type }).FirstOrDefault();
                if (auditModel != null)
                {
                    auditModel.Enabled = enabled;
                    auditModel.CreateBy = userInfo.EmployeeId;
                    auditModel.CreateDate = DateTime.Now;
                    return auditRelevanceRepository.Update(auditModel);
                }
                else {
                    return auditRelevanceRepository.Insert(new RB_Property_AuditRelevance()
                    {
                        CreateBy = userInfo.EmployeeId,
                        CreateDate = DateTime.Now,
                        Enabled = enabled,
                        Id = 0,
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        Status = 0,
                        Type = (PropertyFlowEnum)type
                    }) > 0;
                }
            }
            else {
                //签名
                var auditModel = signatureRelevanceRepository.GetList(new RB_Property_SignatureRelevance() { RB_Group_Id = userInfo.RB_Group_id, Type = (PropertySignEnum)type }).FirstOrDefault();
                if (auditModel != null)
                {
                    auditModel.Enabled = enabled;
                    auditModel.CreateBy = userInfo.EmployeeId;
                    auditModel.CreateDate = DateTime.Now;
                    return signatureRelevanceRepository.Update(auditModel);
                }
                else
                {
                    return signatureRelevanceRepository.Insert(new RB_Property_SignatureRelevance()
                    {
                        CreateBy = userInfo.EmployeeId,
                        CreateDate = DateTime.Now,
                        Enabled = enabled,
                        Id = 0,
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        Status = 0,
                        Type = (PropertySignEnum)type
                    }) > 0;
                }
            }
        }

        #region 资产领取

        /// <summary>
        /// 获取资产领取单分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_UseReceive_Extend> GetPropertyReceivePageList(int pageIndex, int pageSize, RB_Property_UseReceive_Extend demodel, out long count)
        {
            var list = useReceiveRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Property_UseRelevance_Extend> urlist = new List<RB_Property_UseRelevance_Extend>();
            List<RB_Branch_Extend> blist = new List<RB_Branch_Extend>();
            List<RB_Department_Extend> dlist = new List<RB_Department_Extend>();
            List<RB_Branch_Extend> bOldlist = new List<RB_Branch_Extend>();
            List<RB_Branch_Extend> bInlist = new List<RB_Branch_Extend>();
            if (list.Any()) {
                string rstr = string.Join(",", list.Select(x => x.Id));
                urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = demodel.RB_Group_Id, ReceiveIdStr = rstr });

                string bstr = string.Join(",", list.Select(x => x.BranchId ?? 0).Distinct());
                string dstr = string.Join(",", list.Select(x => x.DepartmentId ?? 0).Distinct());
                blist = branchRepository.GetBranchNameByIds(bstr);
                dlist = departmentRepository.GetDepartmentByDepartmentIds(dstr);

                string boldstr = string.Join(",", urlist.Select(x => x.HistoryBranchId ?? 0).Distinct());
                string bnewstr = string.Join(",", list.Select(x => x.InBranchId ?? 0).Distinct());
                bOldlist = branchRepository.GetBranchNameByIds(boldstr);
                bInlist = branchRepository.GetBranchNameByIds(bnewstr);

                List<Rb_Workflow_AuditRelevance_Extend> arlist = new List<Rb_Workflow_AuditRelevance_Extend>();
                if (demodel.IsSelfApplication == 1)
                {
                    //自助申请的查询
                    //查询所有的签名流程
                    arlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(0, rstr, WFRrocessStatus.NotAudit);
                }

                foreach (var item in list)
                {
                    item.DetailList = urlist.Where(x => x.ReceiveId == item.Id).ToList();
                    var bmodel = blist.Where(x => x.Id == item.BranchId).FirstOrDefault();
                    var dmodel = dlist.Where(x => x.DepartmentID == item.DepartmentId).FirstOrDefault();
                    item.BranchName = bmodel?.BName ?? "";
                    item.DepartmentName = dmodel?.DepartmentName ?? "";
                    item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                    //调拨
                    var binmodel = bInlist.Where(x => x.Id == item.InBranchId).FirstOrDefault();
                    item.InBranchName = binmodel?.BName ?? "";
                    foreach (var bitem in item.DetailList) {
                        var boldmodel = bOldlist.Where(x => x.Id == bitem.HistoryBranchId).FirstOrDefault();
                        bitem.HistoryBranchName = boldmodel?.BName ?? "";
                    }
                    //维修
                    item.ImageList = new List<string>();
                    if (!string.IsNullOrEmpty(item.Images))
                    {
                        var imglist = JsonConvert.DeserializeObject<List<string>>(item.Images);
                        foreach (var img in imglist)
                        {
                            item.ImageList.Add(Config.GetFileUrl(img));
                        }
                    }

                    item.IsApplyForSign = 0;
                    if (demodel.IsSelfApplication == 1)
                    {
                        var arModel = arlist.Where(x => x.WorkFlowId == item.Id).OrderBy(x => x.Sort).FirstOrDefault();
                        if (arModel != null && arModel.SpecialNode == WFSpecialNodeEnum.Pay)
                        {
                            item.IsApplyForSign = 1;
                        }
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 删除资产领取
        /// </summary>
        /// <param name="receiveId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelPropertyReceive(int receiveId, UserInfo userInfo)
        {
            var model = useReceiveRepository.GetEntity(receiveId);
            model.AuditStatus = OrderStateEnum.Complete;
            model.Status = (int)DateStateEnum.Delete;
            model.TempleteId = 0;
            model.UpdateBy = userInfo.EmployeeId;
            model.UpdateDate = DateTime.Now;
            bool flag = useReceiveRepository.Update(model);
            if (flag) {
                //判断下资产是否是待确认状态  是的话  需要修改~
                var dlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = userInfo.RB_Group_id, ReceiveId = receiveId });
                if (dlist.Any()) {
                    //查询所有的资产列表
                    string pstr = string.Join(",", dlist.Select(x => x.PropertyId));
                    var plist = property_InfoRepository.GetList(new RB_Property_Info_Extend() { RB_Group_Id = userInfo.RB_Group_id, PropertyIdStr = pstr });
                    if (plist.Any()) {
                        foreach (var item in plist) {
                            Dictionary<string, object> files = new Dictionary<string, object>();
                            bool IsUpdate = false;
                            if (item.PropertyStatus == PropertyStatusEnum.ReceiveW)
                            {
                                if (model.ChangePerson > 0)
                                {
                                    files.Add(nameof(RB_Property_Info.PropertyStatus), PropertyStatusEnum.Receive);
                                    files.Add(nameof(RB_Property_Info.EmployeeId), model.ChangePerson);
                                    files.Add(nameof(RB_Property_Info.GetTime), model.ChangeTime);
                                }
                                else
                                {
                                    files.Add(nameof(RB_Property_Info.PropertyStatus), PropertyStatusEnum.Leisure);
                                }
                                IsUpdate = true;
                            }
                            else if (item.PropertyStatus == PropertyStatusEnum.CancellingStocksW) {
                                files.Add(nameof(RB_Property_Info.PropertyStatus), PropertyStatusEnum.Receive);
                                IsUpdate = true;
                            }
                            else if (item.PropertyStatus == PropertyStatusEnum.BorrowW)
                            {
                                files.Add(nameof(RB_Property_Info.PropertyStatus), PropertyStatusEnum.Leisure);
                                IsUpdate = true;
                            }
                            else if (item.PropertyStatus == PropertyStatusEnum.GiveBackW)
                            {
                                files.Add(nameof(RB_Property_Info.PropertyStatus), PropertyStatusEnum.Borrow);
                                IsUpdate = true;
                            }
                            else if (item.PropertyStatus == PropertyStatusEnum.AllotW)
                            {
                                files.Add(nameof(RB_Property_Info.PropertyStatus), PropertyStatusEnum.Leisure);
                                IsUpdate = true;
                            }
                            else if (item.PropertyStatus == PropertyStatusEnum.DisposeW)
                            {
                                files.Add(nameof(RB_Property_Info.PropertyStatus), PropertyStatusEnum.Leisure);
                                IsUpdate = true;
                            }
                            if (IsUpdate) {
                                List<WhereHelper> wheres = new List<WhereHelper>() {
                                    new WhereHelper(){
                                         FiledName=nameof(RB_Property_Info.Id),
                                          FiledValue=item.Id,
                                           OperatorEnum=OperatorEnum.Equal
                                    }
                                };
                                property_InfoRepository.Update(files, wheres);
                            }
                        }
                    }
                }

                //首先删除流程相关 与 流程审批人
                workFlowModule.ModifyAuditDeleteAllInfo(receiveId, null);
            }
            return flag;
        }

        /// <summary>
        /// 终止资产派发
        /// </summary>
        /// <param name="receiveId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool CancelPropertyReceive(int receiveId, UserInfo userInfo)
        {
            var model = useReceiveRepository.GetEntity(receiveId);
            model.AuditStatus = OrderStateEnum.Terminate;
            //model.TempleteId = 0;
            model.UpdateBy = userInfo.EmployeeId;
            model.UpdateDate = DateTime.Now;
            bool flag = useReceiveRepository.Update(model);
            return flag;
        }

        /// <summary>
        /// 验证
        /// </summary>
        /// <param name="useId"></param>
        /// <param name="type"></param>
        /// <param name="pstr"></param>
        /// <param name="GroupId"></param>
        /// <returns></returns>
        public string ValidatePropertyStatus(int useId, PropertySourceEnum? type, string pstr, int GroupId, out List<RB_Property_Info_Extend> PList)
        {
            string msg = "";
            var list = property_InfoRepository.GetList(new RB_Property_Info_Extend() { RB_Group_Id = GroupId, PropertyIdStr = pstr });
            PList = list;
            var clist = list;
            if (useId > 0)
            {
                var urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = GroupId, ReceiveId = useId });
                if (urlist.Any())
                {
                    clist = clist.Where(x => !urlist.Select(z => z.PropertyId ?? 0).Distinct().Contains(x.Id)).ToList();
                }
            }
            if (type == PropertySourceEnum.Receive || type == PropertySourceEnum.Borrow || type == PropertySourceEnum.Allot || type == PropertySourceEnum.Dispose)
            {
                //验证空闲
                foreach (var item in clist)
                {
                    if (item.PropertyStatus != PropertyStatusEnum.Leisure)
                    {
                        msg += item.PropertyNum + ",";
                    }
                }
            }
            else if (type == PropertySourceEnum.CancellingStocks)
            {
                //验证领用
                foreach (var item in clist)
                {
                    if (item.PropertyStatus != PropertyStatusEnum.Receive)
                    {
                        msg += item.PropertyNum + ",";
                    }
                }
            }
            else if (type == PropertySourceEnum.GiveBack) {
                //验证借用
                foreach (var item in clist)
                {
                    if (item.PropertyStatus != PropertyStatusEnum.Borrow)
                    {
                        msg += item.PropertyNum + ",";
                    }
                }
            }
            
            if (msg != "")
            {
                msg = msg[0..^1];
            }
            return msg;
        }

        /// <summary>
        /// 获取使用实体
        /// </summary>
        /// <param name="Id"></param>
        /// <returns></returns>
        public RB_Property_UseReceive GetUseReceiveEntity(int Id) {
            return useReceiveRepository.GetEntity(Id);
        }

        /// <summary>
        /// 变更领用人
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult SetPropertyChangePersonReceive(RB_Property_UseReceive_Extend demodel, UserInfo userInfo) 
        {
            //组装数据
            var pModel = property_InfoRepository.GetEntity(demodel.PropertyId).RefMapperTo<RB_Property_Info_Extend>();
            if (pModel == null) {
                return ApiResult.ParamIsNull("资产不存在，请核实后再试");
            }
            if (pModel.EmployeeId == demodel.EmployeeId) {
                return ApiResult.Failed("变更后的领用人不能是原领用人");
            }
            demodel.ChangePerson = pModel.EmployeeId;
            demodel.ChangeTime = pModel.GetTime;
            List<RB_Property_Info_Extend> PList = new List<RB_Property_Info_Extend>
            {
                pModel
            };
            demodel.DetailList = new List<RB_Property_UseRelevance_Extend>() {
             new RB_Property_UseRelevance_Extend(){
              PropertyId=pModel.Id
             }
            };
            return SetPropertyUseReceiveCommon(demodel, userInfo, PList, PropertyFlowEnum.Change, true);
        }

        /// <summary>
        /// 资产使用人公共方法
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult SetPropertyUseReceiveCommon(RB_Property_UseReceive_Extend demodel, UserInfo userInfo, List<RB_Property_Info_Extend> PList, PropertyFlowEnum auditenum = PropertyFlowEnum.Receive,bool IsChangePerson=false)
        {
            var trans = useReceiveRepository.DbTransaction;
            try
            {
                string OrderCodeType = "LY";
                #region 根据Source 获取审批流程
                switch (demodel.Source)
                {
                    case PropertySourceEnum.Receive:
                        auditenum = PropertyFlowEnum.Receive;
                        if(IsChangePerson)
                            OrderCodeType = "BG";
                        else
                            OrderCodeType = "LY";
                        break;
                    case PropertySourceEnum.CancellingStocks:
                        auditenum = PropertyFlowEnum.CancellingStocks;
                        OrderCodeType = "TK";
                        break;
                    case PropertySourceEnum.Borrow:
                        auditenum = PropertyFlowEnum.Borrow;
                        OrderCodeType = "JY";
                        break;
                    case PropertySourceEnum.GiveBack:
                        auditenum = PropertyFlowEnum.GiveBack;
                        OrderCodeType = "GH";
                        break;
                    case PropertySourceEnum.Allot:
                        auditenum = PropertyFlowEnum.Allot;
                        OrderCodeType = "TB";
                        break;
                    case PropertySourceEnum.Maintain:
                        auditenum = PropertyFlowEnum.Maintain;
                        OrderCodeType = "WX";
                        break;
                    case PropertySourceEnum.Dispose:
                        auditenum = PropertyFlowEnum.Dispose;
                        OrderCodeType = "CZ";
                        break;
                }
                #endregion

                if (demodel.Id > 0)
                {
                    var model = useReceiveRepository.GetEntity(demodel.Id);
                    if (model.ChangePerson > 0) {
                        useReceiveRepository.DBSession.Commit();
                        return ApiResult.Failed("变更领用人申请无法修改，请执行删除");
                    }
                    #region 验证是否自助申请
                    if (model.IsSelfApplication == 1 && demodel.EmployeeId == userInfo.EmployeeId)
                    {
                        if (demodel.Source == PropertySourceEnum.Receive)
                        {
                            auditenum = PropertyFlowEnum.EmpReceive;
                        }
                        else if (demodel.Source == PropertySourceEnum.CancellingStocks)
                        {
                            auditenum = PropertyFlowEnum.EmpCancellingStocks;
                        }
                        else
                        {
                            useReceiveRepository.DBSession.Commit("SetPropertyReceive");
                            return ApiResult.ParamIsNull("自助申请未开放，请核实后再试！");
                        }
                    }
                    #endregion
                    //判断是否需要流程审批
                    var tmodel = GetTempleteModel(auditenum, demodel.BranchId ?? 0);
                    var rmodel = auditRelevanceRepository.GetList(new RB_Property_AuditRelevance() { RB_Group_Id = demodel.RB_Group_Id, Type = auditenum }).FirstOrDefault();
                    model.AuditStatus = OrderStateEnum.Complete;
                    model.TempleteId = 0;
                    if (rmodel != null && rmodel.Enabled == 1)
                    {
                        if (tmodel == null) {
                            useReceiveRepository.DBSession.Commit("SetPropertyReceive");
                            return ApiResult.Failed("未匹配到相关的流程信息,请联系管理员！");
                        }
                        model.AuditStatus = OrderStateEnum.Auditing;
                        model.TempleteId = tmodel?.Id ?? 0;
                    }
                    
                    if (model.Source == PropertySourceEnum.Receive)
                    {
                        model.EmployeeId = demodel.EmployeeId ?? 0;
                        model.Time = demodel.Time;
                    }
                    else if (model.Source == PropertySourceEnum.CancellingStocks)
                    {
                        model.BackTime = demodel.BackTime;
                    }
                    else if (model.Source == PropertySourceEnum.Borrow)
                    {
                        model.EmployeeId = demodel.EmployeeId ?? 0;
                        model.Time = demodel.Time;
                        model.BackTime = demodel.BackTime;
                    }
                    else if (model.Source == PropertySourceEnum.GiveBack) {
                        model.BackTime = demodel.BackTime;
                    }
                    else if (model.Source == PropertySourceEnum.Allot)
                    {
                        model.Time = demodel.Time;
                        model.InBranchId = demodel.InBranchId;
                    }
                    else if (demodel.Source == PropertySourceEnum.Maintain)
                    {
                        model.EmployeeId = demodel.EmployeeId ?? 0;
                        model.Time = demodel.Time;
                        //图片处理
                        List<string> imgList = new List<string>();
                        ImageOperation(demodel.ImageList, out imgList);//转移图片  未做删除处理
                        model.Images = JsonConvert.SerializeObject(imgList);
                    }
                    else if (model.Source == PropertySourceEnum.Dispose)
                    {
                        model.BackTime = demodel.BackTime;
                    }

                    model.Remark = demodel.Remark;
                    model.UpdateBy = demodel.UpdateBy;
                    model.UpdateDate = demodel.UpdateDate;
                    bool flag = useReceiveRepository.Update(model, trans);
                    if (flag) {

                        var dlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = demodel.RB_Group_Id, ReceiveId = demodel.Id });
                        var InsertList = demodel.DetailList.Where(x => !dlist.Select(z => z.PropertyId ?? 0).Contains(x.PropertyId ?? 0)).ToList();
                        var DelList = dlist.Where(x => !demodel.DetailList.Select(z => z.PropertyId).Contains(x.PropertyId)).ToList();

                        //插入明细
                        foreach (var item in InsertList)
                        {
                            var pmodel = PList.Where(x => x.Id == item.PropertyId).FirstOrDefault();
                            useRelevanceRepository.Insert(new RB_Property_UseRelevance()
                            {
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                ExpressNumber = "",
                                Id = 0,
                                MendMoney = item.MendMoney??0,
                                PropertyId = item.PropertyId,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                RB_Group_Id = demodel.RB_Group_Id,
                                ReceiveId = demodel.Id,
                                Remark = demodel.Remark,
                                Status = 0,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate,
                                CancelStockEmployeeId = pmodel?.EmployeeId ?? 0,
                                HistoryBranchId = pmodel.BranchId ?? 0
                            }, trans);
                            if (demodel.AuditStatus == OrderStateEnum.Complete || demodel.AuditStatus == OrderStateEnum.Auditing)
                            {
                                #region 资产状态
                                PropertyStatusEnum PropertyStatus = PropertyStatusEnum.Receive;
                                switch (demodel.Source)
                                {
                                    case PropertySourceEnum.Receive:
                                        PropertyStatus = PropertyStatusEnum.Receive;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.ReceiveW;
                                        }
                                        break;
                                    case PropertySourceEnum.CancellingStocks:
                                        PropertyStatus = PropertyStatusEnum.Leisure;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.CancellingStocksW;
                                        }
                                        break;
                                    case PropertySourceEnum.Borrow:
                                        PropertyStatus = PropertyStatusEnum.Borrow;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.BorrowW;
                                        }
                                        break;
                                    case PropertySourceEnum.GiveBack:
                                        PropertyStatus = PropertyStatusEnum.Leisure;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.GiveBackW;
                                        }
                                        break;
                                    case PropertySourceEnum.Allot:
                                        PropertyStatus = PropertyStatusEnum.Leisure;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.AllotW;
                                        }
                                        break;
                                    case PropertySourceEnum.Dispose:
                                        PropertyStatus = PropertyStatusEnum.Dispose;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.DisposeW;
                                        }
                                        break;
                                    case PropertySourceEnum.Maintain:
                                        PropertyStatus = pmodel.PropertyStatus ?? PropertyStatusEnum.Leisure;
                                        break;
                                }
                                #endregion
                                //更新资产状态
                                Dictionary<string, object> filesu = new Dictionary<string, object>() {
                                    { nameof(RB_Property_Info.PropertyStatus),PropertyStatus}
                                };
                                if (demodel.AuditStatus == OrderStateEnum.Complete)
                                {
                                    if (demodel.Source == PropertySourceEnum.Receive)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.EmployeeId), demodel.EmployeeId ?? 0);
                                        filesu.Add(nameof(RB_Property_Info.GetTime), demodel.Time);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.CancellingStocks)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.BackTime), demodel.BackTime);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Borrow)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.EmployeeId), demodel.EmployeeId ?? 0);
                                        filesu.Add(nameof(RB_Property_Info.GetTime), demodel.Time);
                                        filesu.Add(nameof(RB_Property_Info.BackTime), demodel.BackTime);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.GiveBack) {
                                        filesu.Add(nameof(RB_Property_Info.BackTime), demodel.BackTime);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Allot)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.BranchId), demodel.InBranchId);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Maintain)
                                    {
                                        //filesu.Add(nameof(RB_Property_Info.UseStatus), (int)PropertyUseStateEnum.Repair);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Dispose)
                                    {
                                        
                                    }
                                }
                                List<WhereHelper> wheresu = new List<WhereHelper>() {
                                    new WhereHelper(){
                                     FiledName=nameof(RB_Property_Info.Id),
                                      FiledValue=item.PropertyId,
                                       OperatorEnum=OperatorEnum.Equal
                                    }
                                };
                                property_InfoRepository.Update(filesu, wheresu, trans);
                                //如果是完成  需要写入资产日志
                            }
                        }
                        foreach (var item in DelList) {
                            Dictionary<string, object> files = new Dictionary<string, object>() {
                                { nameof(RB_Property_UseRelevance.Status),(int)DateStateEnum.Delete}
                            };
                            List<WhereHelper> wheres = new List<WhereHelper>() {
                                new WhereHelper(){
                                 FiledName=nameof(RB_Property_UseRelevance.Id),
                                  FiledValue=item.Id,
                                   OperatorEnum=OperatorEnum.Equal
                                }
                            };
                            useRelevanceRepository.Update(files, wheres, trans);
                            if (demodel.AuditStatus == OrderStateEnum.Complete || demodel.AuditStatus == OrderStateEnum.Auditing)
                            {
                                #region 资产状态
                                PropertyStatusEnum PropertyStatus = PropertyStatusEnum.Receive;
                                switch (demodel.Source)
                                {
                                    case PropertySourceEnum.Receive:
                                        PropertyStatus = PropertyStatusEnum.Receive;
                                        break;
                                    case PropertySourceEnum.CancellingStocks:
                                        PropertyStatus = PropertyStatusEnum.Receive;
                                        break;
                                    case PropertySourceEnum.Borrow:
                                        PropertyStatus = PropertyStatusEnum.Borrow;
                                        break;
                                    case PropertySourceEnum.GiveBack:
                                        PropertyStatus = PropertyStatusEnum.Borrow;
                                        break;
                                    case PropertySourceEnum.Allot:
                                        PropertyStatus = PropertyStatusEnum.Leisure;
                                        break;
                                    case PropertySourceEnum.Dispose:
                                        PropertyStatus = PropertyStatusEnum.Leisure;
                                        break;
                                }
                                #endregion
                                //更新资产状态
                                Dictionary<string, object> filesu = new Dictionary<string, object>() {
                                    { nameof(RB_Property_Info.PropertyStatus),PropertyStatus}
                                };
                                List<WhereHelper> wheresu = new List<WhereHelper>() {
                                    new WhereHelper(){
                                     FiledName=nameof(RB_Property_Info.Id),
                                      FiledValue=item.PropertyId,
                                       OperatorEnum=OperatorEnum.Equal
                                    }
                                };
                                property_InfoRepository.Update(filesu, wheresu, trans);
                            }
                        }
                        //维修修改维修金额
                        if (demodel.Source == PropertySourceEnum.Maintain) {
                            var UpdateList = dlist.Where(x => demodel.DetailList.Select(z => z.PropertyId).Contains(x.PropertyId)).ToList();
                            foreach (var item in UpdateList) {
                                Dictionary<string, object> ufiles = new Dictionary<string, object>() {
                                    { nameof(RB_Property_UseRelevance_Extend.MendMoney),item.MendMoney}
                                };
                                List<WhereHelper> uwheres = new List<WhereHelper>() {
                                    new WhereHelper(){
                                         FiledName=nameof(RB_Property_UseRelevance_Extend.Id),
                                          FiledValue=item.Id,
                                           OperatorEnum=OperatorEnum.Equal
                                    }
                                };
                                useRelevanceRepository.Update(ufiles, uwheres, trans);
                            }
                        }

                        if (model.AuditStatus == OrderStateEnum.Auditing)
                        {
                            //查询流程是否存在
                            if (tmodel == null)
                            {
                                useReceiveRepository.DBSession.Rollback("SetPropertyReceive");
                                return ApiResult.Failed("未匹配到相关的流程信息,请联系管理员！");
                            }
                            //首先删除流程相关 与 流程审批人
                            workFlowModule.ModifyAuditDeleteAllInfo(demodel.Id, trans);
                            //开始创建流程
                            List<EmAccoutIdModel> sendAccount = new List<EmAccoutIdModel>();
                            List<int> ApplyForList = new List<int>();
                            if (demodel.Source == PropertySourceEnum.Receive || demodel.Source == PropertySourceEnum.Borrow)
                            {
                                ApplyForList = new List<int>() { demodel.EmployeeId ?? 0 };
                            }
                            else if (demodel.Source == PropertySourceEnum.CancellingStocks || demodel.Source == PropertySourceEnum.GiveBack)
                            {
                                ApplyForList = PList.Select(x => x.EmployeeId ?? 0).ToList();       
                            }
                            bool cflag = workFlowModule.InsertAuditRelevance(tmodel, demodel.Source, userInfo.EmployeeId, userInfo.EmployeeId, demodel.Id, ApplyForList, out sendAccount, 1, null, trans);
                            if (cflag == false)
                            {
                                useReceiveRepository.DBSession.Rollback("SetPropertyReceive1");
                                return ApiResult.Failed("流程有误，请核实后再试");
                            }
                            //日志
                            RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                            {
                                LogId = 0,
                                RB_Branch_Id = userInfo.RB_Branch_id,
                                RB_Group_Id = userInfo.RB_Group_id,
                                UpdateBy = userInfo.EmployeeId,
                                UpdateDate = System.DateTime.Now,
                                ResourceId = demodel.Id,
                                Content = "修改提交",
                                Type = 1
                            };
                            workfolw_Change_LogRepository.Insert(logModel, trans);

                            //推送消息
                            if (sendAccount.Any())
                            {
                                PushAuditMessage(sendAccount, demodel.Id, "您有待审核的资产信息", "资产审核通知", userInfo.EmployeeId, SysTemPushTypeEnum.PropertyAudit);
                            }
                        }
                    }
                    useReceiveRepository.DBSession.Commit();
                    if (flag)
                    {
                        return ApiResult.Success();
                    }
                    else
                    {
                        return ApiResult.Failed();
                    }
                }
                else
                {
                    if (IsChangePerson) {
                        auditenum = PropertyFlowEnum.Change;
                    }
                    #region 验证是否自助申请
                    if (demodel.IsSelfApplication == 1 && (demodel.EmployeeId == userInfo.EmployeeId || demodel.Source == PropertySourceEnum.CancellingStocks))
                    {
                        if (demodel.Source == PropertySourceEnum.Receive)
                        {
                            auditenum = PropertyFlowEnum.EmpReceive;
                        }
                        else if (demodel.Source == PropertySourceEnum.CancellingStocks)
                        {
                            auditenum = PropertyFlowEnum.EmpCancellingStocks;
                        }
                        else
                        {
                            useReceiveRepository.DBSession.Commit("SetPropertyReceive");
                            return ApiResult.ParamIsNull("自助申请未开放，请核实后再试！");
                        }
                    }
                    #endregion
                    //判断是否需要流程审批
                    var tmodel = GetTempleteModel(auditenum, demodel.BranchId ?? 0);
                    demodel.AuditStatus = OrderStateEnum.Complete;
                    var rmodel = auditRelevanceRepository.GetList(new RB_Property_AuditRelevance() { RB_Group_Id = demodel.RB_Group_Id, Type = auditenum }).FirstOrDefault();

                    demodel.TempleteId = 0;
                    if (rmodel != null && rmodel.Enabled == 1)
                    {
                        if (tmodel == null) {
                            useReceiveRepository.DBSession.Commit("SetPropertyReceive");
                            return ApiResult.ParamIsNull("未匹配到相关的流程信息,请联系管理员！");
                        }
                        demodel.AuditStatus = OrderStateEnum.Auditing;
                        demodel.TempleteId = tmodel?.Id ?? 0;
                    }
                    if (demodel.Source == PropertySourceEnum.Maintain) {
                        //图片处理
                        List<string> imgList = new List<string>();
                        ImageOperation(demodel.ImageList, out imgList);//转移图片  未做删除处理
                        demodel.Images = JsonConvert.SerializeObject(imgList);
                    }
                    int Id = useReceiveRepository.Insert(demodel, trans);
                    if (Id > 0)
                    {
                        #region  编码自动生成
                        string BMStr = Id.ToString();
                        if (BMStr.Length < 5)
                        {
                            switch (BMStr.Length)
                            {
                                case 1:
                                    BMStr = "0000" + BMStr; break;
                                case 2:
                                    BMStr = "000" + BMStr; break;
                                case 3:
                                    BMStr = "00" + BMStr; break;
                                case 4:
                                    BMStr = "0" + BMStr; break;
                            }
                        }
                        BMStr = OrderCodeType + DateTime.Now.ToString("yyyyMMdd") + BMStr;
                        #endregion
                        #region 更新编码
                        Dictionary<string, object> files = new Dictionary<string, object>() {
                            { nameof(RB_Property_UseReceive.OrderCode),BMStr}
                        };
                        List<WhereHelper> wheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Property_UseReceive.Id),
                                  FiledValue=Id,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        useReceiveRepository.Update(files, wheres, trans);
                        #endregion

                        //插入明细
                        foreach (var item in demodel.DetailList)
                        {
                            var pmodel = PList.Where(x => x.Id == item.PropertyId).FirstOrDefault();
                            useRelevanceRepository.Insert(new RB_Property_UseRelevance()
                            {
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                ExpressNumber = "",
                                Id = 0,
                                MendMoney = item.MendMoney,
                                PropertyId = item.PropertyId,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                RB_Group_Id = demodel.RB_Group_Id,
                                ReceiveId = Id,
                                Remark = demodel.Remark,
                                Status = 0,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate,
                                CancelStockEmployeeId = pmodel?.EmployeeId ?? 0,
                                HistoryBranchId = pmodel.BranchId ?? 0
                            }, trans);

                            if (demodel.AuditStatus == OrderStateEnum.Complete || demodel.AuditStatus == OrderStateEnum.Auditing)
                            {
                                #region 资产状态
                                PropertyStatusEnum PropertyStatus = PropertyStatusEnum.Receive;
                                switch (demodel.Source) {
                                    case PropertySourceEnum.Receive:
                                        PropertyStatus = PropertyStatusEnum.Receive;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.ReceiveW;
                                        }
                                        break;
                                    case PropertySourceEnum.CancellingStocks:
                                        PropertyStatus = PropertyStatusEnum.Leisure;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.CancellingStocksW;
                                        }
                                        break;
                                    case PropertySourceEnum.Borrow:
                                        PropertyStatus = PropertyStatusEnum.Borrow;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.BorrowW;
                                        }
                                        break;
                                    case PropertySourceEnum.GiveBack:
                                        PropertyStatus = PropertyStatusEnum.Leisure;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.GiveBackW;
                                        }
                                        break;
                                    case PropertySourceEnum.Allot:
                                        PropertyStatus = PropertyStatusEnum.Leisure;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.AllotW;
                                        }
                                        break;
                                    case PropertySourceEnum.Dispose:
                                        PropertyStatus = PropertyStatusEnum.Dispose;
                                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                                        {
                                            PropertyStatus = PropertyStatusEnum.DisposeW;
                                        }
                                        break;
                                    case PropertySourceEnum.Maintain:
                                        PropertyStatus = pmodel.PropertyStatus ?? PropertyStatusEnum.Leisure;
                                        break;
                                }
                                #endregion
                                //更新资产状态
                                Dictionary<string, object> filesu = new Dictionary<string, object>() {
                                    { nameof(RB_Property_Info.PropertyStatus),PropertyStatus}
                                };
                                if (demodel.AuditStatus == OrderStateEnum.Complete) {
                                    if (demodel.Source == PropertySourceEnum.Receive)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.EmployeeId), demodel.EmployeeId ?? 0);
                                        filesu.Add(nameof(RB_Property_Info.GetTime), demodel.Time);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.CancellingStocks)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.BackTime), demodel.BackTime);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Borrow)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.EmployeeId), demodel.EmployeeId ?? 0);
                                        filesu.Add(nameof(RB_Property_Info.GetTime), demodel.Time);
                                        filesu.Add(nameof(RB_Property_Info.BackTime), demodel.BackTime);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.GiveBack)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.BackTime), demodel.BackTime);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Allot)
                                    {
                                        filesu.Add(nameof(RB_Property_Info.BranchId), demodel.InBranchId);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Maintain)
                                    {
                                        //filesu.Add(nameof(RB_Property_Info.UseStatus), (int)PropertyUseStateEnum.Repair);
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Dispose) { 
                                    
                                    }
                                }
                                List<WhereHelper> wheresu = new List<WhereHelper>() {
                                    new WhereHelper(){
                                     FiledName=nameof(RB_Property_Info.Id),
                                      FiledValue=item.PropertyId,
                                       OperatorEnum=OperatorEnum.Equal
                                    }
                                };
                                property_InfoRepository.Update(filesu, wheresu, trans);
                                //如果是完成  需要写入资产日志
                                if (demodel.AuditStatus == OrderStateEnum.Complete) {
                                    //日志
                                    var emmodel = CacheManager.User.UserReidsCache.GetEmployee(demodel.EmployeeId);
                                    string ContentMsg = "";
                                    string TypeName = "";
                                    if (demodel.Source == PropertySourceEnum.Receive)
                                    {
                                        if (demodel.ChangePerson > 0)
                                        {
                                            ContentMsg = "领用人变更为：" + emmodel?.EmName;
                                            TypeName = "变更领用人";
                                        }
                                        else
                                        {
                                            ContentMsg = "领用人信息：" + emmodel?.EmName;
                                            TypeName = "领用";
                                        }
                                    }
                                    else if (demodel.Source == PropertySourceEnum.CancellingStocks)
                                    {
                                        ContentMsg = "领用退库";
                                        TypeName = "退库";
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Borrow)
                                    {
                                        ContentMsg = "借用人信息：" + emmodel?.EmName;
                                        TypeName = "借用";
                                    }
                                    else if (demodel.Source == PropertySourceEnum.GiveBack)
                                    {
                                        ContentMsg = "借用归还";
                                        TypeName = "归还";
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Allot)
                                    {
                                        ContentMsg = "调入 " + CacheManager.User.BranchReidsCache.GetBranch(demodel.InBranchId ?? 0)?.BName ?? "未查到";
                                        TypeName = "调拨";
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Maintain)
                                    {
                                        ContentMsg = "维修金额：" + (item.MendMoney ?? 0);
                                        TypeName = "维修";
                                    }
                                    else if (demodel.Source == PropertySourceEnum.Dispose)
                                    {
                                        ContentMsg = "处理类型：" + demodel.DisposeType.GetEnumName();
                                        TypeName = "处置";
                                    }
                                    property_LogRepository.Insert(new RB_Property_Log()
                                    {
                                        PropertyId = item.PropertyId,
                                        Content = ContentMsg,
                                        CreateBy = userInfo.EmployeeId,
                                        CreateDate = DateTime.Now,
                                        Id = 0,
                                        RB_Branch_Id = userInfo.RB_Branch_id,
                                        RB_Group_Id = userInfo.RB_Group_id,
                                        Status = 0,
                                        TypeName = TypeName
                                    }, trans);
                                }
                            }
                        }

                        if (demodel.AuditStatus == OrderStateEnum.Auditing)
                        {
                            //查询流程是否存在                            
                            if (tmodel == null) {
                                useReceiveRepository.DBSession.Rollback("SetPropertyReceive");
                                return ApiResult.Failed("未匹配到相关的流程信息,请联系管理员！");
                            }
                            //开始创建流程
                            List<EmAccoutIdModel> sendAccount = new List<EmAccoutIdModel>();
                            List<int> ApplyForList = new List<int>();
                            if (demodel.Source == PropertySourceEnum.Receive || demodel.Source == PropertySourceEnum.Borrow)
                            {
                                ApplyForList = new List<int>() { demodel.EmployeeId ?? 0 };
                            }
                            else if (demodel.Source == PropertySourceEnum.CancellingStocks || demodel.Source == PropertySourceEnum.GiveBack)
                            {
                                ApplyForList = PList.Select(x => x.EmployeeId ?? 0).ToList();
                            }
                            bool cflag = workFlowModule.InsertAuditRelevance(tmodel, demodel.Source, userInfo.EmployeeId, userInfo.EmployeeId, Id, ApplyForList, out sendAccount, 1, null, trans);
                            if (cflag == false) {
                                useReceiveRepository.DBSession.Rollback("SetPropertyReceive1");
                                return ApiResult.Failed("流程有误，请核实后再试");
                            }
                            //日志
                            RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                            {
                                LogId = 0,
                                RB_Branch_Id = userInfo.RB_Branch_id,
                                RB_Group_Id = userInfo.RB_Group_id,
                                UpdateBy = userInfo.EmployeeId,
                                UpdateDate = System.DateTime.Now,
                                ResourceId = Id,
                                Content = "创建流程",
                                Type = 1
                            };
                            workfolw_Change_LogRepository.Insert(logModel, trans);

                            //推送消息
                            if (sendAccount.Any())
                            {
                                PushAuditMessage(sendAccount, Id, "您有待审核的资产信息", "资产审核通知", userInfo.EmployeeId, SysTemPushTypeEnum.PropertyAudit);
                            }
                        }
                    }
                    useReceiveRepository.DBSession.Commit();
                    if (Id > 0)
                    {
                        return ApiResult.Success();
                    }
                    else {
                        return ApiResult.Failed();
                    }
                }
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "SetPropertyReceive");
                useReceiveRepository.DBSession.Rollback();
                return ApiResult.Failed();
            }

        }

        /// <summary>
        /// 推送资产审批消息
        /// </summary>
        /// <param name="account"></param>
        /// <param name="workFlowId"></param>
        /// <param name="content"></param>
        /// <param name="title"></param>
        /// <param name="empId"></param>
        /// <param name="type"></param>
        public void PushAuditMessage(List<EmAccoutIdModel> account, int workFlowId, string content, string title, int? empId, SysTemPushTypeEnum type)
        {
            //Dictionary<string, object> appExtras = new Dictionary<string, object>();
            Dictionary<string, object> webExtras = new Dictionary<string, object>
            {
                { "jumpUrl", "AssetsShenpi?Id=" + workFlowId + "&compType=shenpi" }
            };
            //appExtras.Add("jumpUrl", "vt://financeApprovalDetail/view?ID=" + workFlowId + "&Conditon=3&Source=message&Type=" + Type);

            //IMService.PushFinanceMessage(account, empId, content, title, type, SystemPushLogTypeEnum.XMApp, appExtras);
            IMService.PushMessage(account.RefMapperToList<Property.Common.Models.EmAccoutIdModel>(), empId, content, title, type, SystemPushLogTypeEnum.Web, webExtras);
        }

        /// <summary>
        /// 获取审批日志
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Workfolw_Change_Log> GetAuditChangeLogPageList(int pageIndex, int pageSize, RB_Workfolw_Change_Log demodel, out long count)
        {
            return workfolw_Change_LogRepository.GetPageList(pageIndex, pageSize, demodel, out count);
        }

        /// <summary>
        /// 获取审批详情
        /// </summary>
        /// <param name="useReceiveId"></param>
        /// <returns></returns>
        public RB_Property_UseReceive_Extend GetPropertyAuditDetail(int? useReceiveId,UserInfo userInfo)
        {
            var dmodel = useReceiveRepository.GetEntity(useReceiveId).RefMapperTo<RB_Property_UseReceive_Extend>();
            List<RB_Property_UseRelevance_Extend> urlist = new List<RB_Property_UseRelevance_Extend>();
            List<RB_Branch_Extend> blist = new List<RB_Branch_Extend>();
            List<RB_Department_Extend> dlist = new List<RB_Department_Extend>();
            if (dmodel!=null)
            {
                //获取流程模板
                var tempmodel = workflow_TemplateRepository.GetEntity(dmodel.TempleteId);
                dmodel.TemplateName = tempmodel.Name;
                urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = userInfo.RB_Group_id, ReceiveId = dmodel.Id });

                string bstr = (dmodel.BranchId ?? 0).ToString();
                string dstr = (dmodel.DepartmentId ?? 0).ToString();
                blist = branchRepository.GetBranchNameByIds(bstr);
                dlist = departmentRepository.GetDepartmentByDepartmentIds(dstr);

                //获取流程相关信息
                List<Rb_Workflow_AuditRelevance_Extend> warlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(dmodel.Id);
                List<Rb_Workflow_Auditrecord_Extend> walist = new List<Rb_Workflow_Auditrecord_Extend>();
                walist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { WorkFlowId = dmodel.Id });


                dmodel.DetailList = urlist.Where(x => x.ReceiveId == dmodel.Id).ToList();
                var bmodel = blist.Where(x => x.Id == dmodel.BranchId).FirstOrDefault();
                var depmodel = dlist.Where(x => x.DepartmentID == dmodel.DepartmentId).FirstOrDefault();
                dmodel.BranchName = bmodel?.BName ?? "";
                dmodel.DepartmentName = depmodel?.DepartmentName ?? "";
                var em2model = CacheManager.User.UserReidsCache.GetEmployee(dmodel.EmployeeId);
                dmodel.EmName = (em2model?.EmName ?? "") + (em2model?.IsLeave == 1 ? "(离职)" : "");
                //流程
                dmodel.AuditSteps = new List<Rb_Workflow_AuditRelevance_Extend>();
                #region 制单人信息
                Rb_Workflow_AuditRelevance_Extend rb_Workflow_AuditRelevance_Extend = new Rb_Workflow_AuditRelevance_Extend()
                {
                    AuditDescription = "发起人",
                    Sort = 0,
                    Stauts = WFRrocessStatus.AuditThrough,
                    SpecialNode = WFSpecialNodeEnum.Normal
                };
                rb_Workflow_AuditRelevance_Extend.AuditRecordList = new List<Rb_Workflow_Auditrecord_Extend>();
                var emmodel = CacheManager.User.UserReidsCache.GetEmployee(dmodel.CreateBy);
                Rb_Workflow_Auditrecord_Extend CreateauditInfo = new Rb_Workflow_Auditrecord_Extend()
                {
                    AuditEmName = (emmodel?.EmName ?? "") + (emmodel?.IsLeave == 1 ? "(离职)" : ""),
                    UpdateTime = dmodel.CreateDate.Value,
                    Description = "已提交",
                    Id = 0,
                    AuditStatus = WFRrocessStatus.AuditThrough
                };
                rb_Workflow_AuditRelevance_Extend.AuditRecordList.Add(CreateauditInfo);
                rb_Workflow_AuditRelevance_Extend.NextStep = 0;
                rb_Workflow_AuditRelevance_Extend.AuditWay = WFTAuditWayEnum.Successively;
                dmodel.AuditSteps.Add(rb_Workflow_AuditRelevance_Extend);
                #endregion

                #region 流程步骤信息
                dmodel.Is_AuditSelf = 0;
                dmodel.Is_CanAudit = 0;
                var auditSteps = warlist?.OrderBy(x => x.Sort).ToList();
                var NotAuditedList = auditSteps.Where(x => x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort).ToList();
                var NotAudited = NotAuditedList?.FirstOrDefault();
                foreach (var audititem in auditSteps)
                {
                    #region 审核流程 
                    audititem.AuditRecordList = new List<Rb_Workflow_Auditrecord_Extend>();
                    var record = walist.Where(x => x.AuditId == audititem.Id).ToList();
                    if (NotAudited != null && audititem.Id == NotAudited.Id && audititem.Stauts == WFRrocessStatus.NotAudit)
                    {
                        audititem.NextStep = 1;

                        #region 制单人审核人不能一样
                        if (("," + audititem.ToAuditId + ",").Contains("," + dmodel.CreateBy.Value + ",") && dmodel.CreateBy == userInfo.EmployeeId)
                        {
                            dmodel.Is_AuditSelf = 1;
                        }
                        if (audititem.SpecialNode == WFSpecialNodeEnum.Pay) {
                            dmodel.Is_AuditSelf = 0;
                        }
                        #endregion
                        //待我审批的
                        if (("," + audititem.ToAuditId + ",").Contains("," + userInfo.EmployeeId + ","))
                        {
                            if (dmodel.AuditStatus == OrderStateEnum.Auditing)
                            {
                                dmodel.Is_CanAudit = 1;
                            }
                        }
                        if (("," + audititem.AuditedId + ",").Contains("," + userInfo.EmployeeId + ","))
                        {
                            if (dmodel.AuditStatus == OrderStateEnum.Auditing)
                            {
                                dmodel.Is_CanAudit = 0;
                            }
                        }

                    }
                    foreach (var recorditem in record)
                    {
                        List<string> imgList = new List<string>();
                        if (recorditem.Image != "[]" && !string.IsNullOrWhiteSpace(recorditem.Image))
                        {
                            imgList = JsonConvert.DeserializeObject<List<string>>(recorditem.Image);
                        }
                        Rb_Workflow_Auditrecord_Extend auditInfo = new Rb_Workflow_Auditrecord_Extend()
                        {
                            AuditEmName = CacheManager.User.UserReidsCache.GetEmployee(recorditem.AuditEmId)?.EmName ?? "",
                            UpdateTime = recorditem.UpdateTime.Value,
                            Description = recorditem.Description != "" ? recorditem.Description : "",
                            Id = recorditem.Id,
                            CareOfRemarks = recorditem.CareOfRemarks ?? "",
                            AuditStatus = recorditem.AuditStatus,
                            imgList = imgList,
                            SignImage = recorditem.SignImage
                        };
                        audititem.AuditRecordList.Add(auditInfo);
                    }
                    #endregion
                    dmodel.AuditSteps.Add(audititem);
                }
                #endregion

                //维修图片
                if (dmodel.Images == "" || dmodel.Images == null)
                {
                    dmodel.Images = "[]";
                }
                var imglist = JsonConvert.DeserializeObject<List<string>>(dmodel.Images);
                dmodel.ImageList = new List<string>();
                foreach (var img in imglist)
                {
                    dmodel.ImageList.Add(Config.GetFileUrl(img));
                }

            }
            return dmodel;
        }

        /// <summary>
        /// 审批驳回
        /// </summary>
        /// <param name="model"></param>
        /// <param name="imageList"></param>
        /// <param name="auditDescription"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult AuditReject(RB_Property_UseReceive model, List<string> imageList, string auditDescription, UserInfo userInfo)
        {
            return workFlowModule.AuditReject(model, imageList, auditDescription, userInfo);
        }

        /// <summary>
        /// 审批通过
        /// </summary>
        /// <param name="model"></param>
        /// <param name="imageList"></param>
        /// <param name="auditDescription"></param>
        /// <param name="SignImage"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult AuditPass(RB_Property_UseReceive model, List<string> imageList, string auditDescription, string SignImage, UserInfo userInfo)
        {
            return workFlowModule.AuditPass(model, imageList, auditDescription, SignImage, userInfo);
        }

        /// <summary>
        /// 获取带我审批分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_UseReceive_Extend> GetPropertyWaitMyAuditPageList(int pageIndex, int pageSize, RB_Property_UseReceive_Extend demodel, out long count,int Type=1,UserInfo userInfo=null)
        {
            var list = useReceiveRepository.GetPropertyWaitMyAuditPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Property_UseRelevance_Extend> urlist = new List<RB_Property_UseRelevance_Extend>();
            List<RB_Branch_Extend> blist = new List<RB_Branch_Extend>();
            List<RB_Department_Extend> dlist = new List<RB_Department_Extend>();
            if (list.Any())
            {
                string rstr = string.Join(",", list.Select(x => x.Id));
                urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = demodel.RB_Group_Id, ReceiveIdStr = rstr });

                string bstr = string.Join(",", list.Select(x => x.BranchId ?? 0).Distinct());
                string dstr = string.Join(",", list.Select(x => x.DepartmentId ?? 0).Distinct());
                blist = branchRepository.GetBranchNameByIds(bstr);
                dlist = departmentRepository.GetDepartmentByDepartmentIds(dstr);

                //获取流程相关信息
                List<Rb_Workflow_AuditRelevance_Extend> warlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(0, rstr);
                List<Rb_Workflow_Auditrecord_Extend> walist = new List<Rb_Workflow_Auditrecord_Extend>();
                if (Type == 1)
                {
                    walist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { FrIdStr = rstr });
                }

                foreach (var item in list)
                {
                    item.DetailList = urlist.Where(x => x.ReceiveId == item.Id).ToList();
                    var bmodel = blist.Where(x => x.Id == item.BranchId).FirstOrDefault();
                    var dmodel = dlist.Where(x => x.DepartmentID == item.DepartmentId).FirstOrDefault();
                    item.BranchName = bmodel?.BName ?? "";
                    item.DepartmentName = dmodel?.DepartmentName ?? "";
                    item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                    //流程
                    //下一步审核节点描述
                    var NextModel = warlist.Where(x => x.WorkFlowId == item.Id && x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort)?.FirstOrDefault();
                    if (item.Status != 1)
                    {
                        item.AuditDescription = NextModel != null ? NextModel.AuditDescription : "";
                    }
                    if (Type==1)
                    {
                        if (item.Status != 1)
                        {
                            var data = NextModel;
                            if (data != null)
                            {
                                var record = new Rb_Workflow_Auditrecord_Extend();
                                var emModel = CacheManager.User.UserReidsCache.GetEmployee(userInfo.EmployeeId);
                                record = walist.Where(x => x.AuditId == data.Id)?.FirstOrDefault();
                                if (record != null)
                                {
                                    if (emModel.RB_Branch_id == item.RB_Branch_Id)
                                    {
                                        //审核人与制单公司为同一公司
                                        if (record.AuditEmId == item.CreateBy)
                                        {
                                            item.Is_AuditSelf = 1;
                                        }
                                        if (data.SpecialNode == WFSpecialNodeEnum.Pay) {
                                            item.Is_AuditSelf = 0;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 获取带我签名分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_UseReceive_Extend> GetPropertyWaitMySignPageList(int pageIndex, int pageSize, RB_Property_UseReceive_Extend demodel, out long count, int Type = 1, UserInfo userInfo = null)
        {
            var list = useReceiveRepository.GetPropertyWaitMySignPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Property_UseRelevance_Extend> urlist = new List<RB_Property_UseRelevance_Extend>();
            List<RB_Branch_Extend> blist = new List<RB_Branch_Extend>();
            List<RB_Department_Extend> dlist = new List<RB_Department_Extend>();
            if (list.Any())
            {
                string rstr = string.Join(",", list.Select(x => x.Id));
                urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = demodel.RB_Group_Id, ReceiveIdStr = rstr });

                string bstr = string.Join(",", list.Select(x => x.BranchId ?? 0).Distinct());
                string dstr = string.Join(",", list.Select(x => x.DepartmentId ?? 0).Distinct());
                blist = branchRepository.GetBranchNameByIds(bstr);
                dlist = departmentRepository.GetDepartmentByDepartmentIds(dstr);

                //获取流程相关信息
                List<Rb_Workflow_AuditRelevance_Extend> warlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(0, rstr);
                List<Rb_Workflow_Auditrecord_Extend> walist = new List<Rb_Workflow_Auditrecord_Extend>();
                if (Type == 1)
                {
                    walist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { FrIdStr = rstr });
                }

                foreach (var item in list)
                {
                    item.DetailList = urlist.Where(x => x.ReceiveId == item.Id).ToList();
                    var bmodel = blist.Where(x => x.Id == item.BranchId).FirstOrDefault();
                    var dmodel = dlist.Where(x => x.DepartmentID == item.DepartmentId).FirstOrDefault();
                    item.BranchName = bmodel?.BName ?? "";
                    item.DepartmentName = dmodel?.DepartmentName ?? "";
                    item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                    //流程
                    //下一步审核节点描述
                    var NextModel = warlist.Where(x => x.WorkFlowId == item.Id && x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort)?.FirstOrDefault();
                    if (item.Status != 1)
                    {
                        item.AuditDescription = NextModel != null ? NextModel.AuditDescription : "";
                    }
                    if (Type == 1)
                    {
                        if (item.Status != 1)
                        {
                            var data = NextModel;
                            if (data != null)
                            {
                                var record = new Rb_Workflow_Auditrecord_Extend();
                                var emModel = CacheManager.User.UserReidsCache.GetEmployee(userInfo.EmployeeId);
                                record = walist.Where(x => x.AuditId == data.Id)?.FirstOrDefault();
                                if (record != null)
                                {
                                    if (emModel.RB_Branch_id == item.RB_Branch_Id)
                                    {
                                        //审核人与制单公司为同一公司
                                        if (record.AuditEmId == item.CreateBy)
                                        {
                                            item.Is_AuditSelf = 1;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 获取流程模板
        /// </summary>
        /// <param name="audite"></param>
        /// <param name="BranchId"></param>
        /// <returns></returns>
        private Rb_Workflow_Template_Extend GetTempleteModel(PropertyFlowEnum audite, int BranchId)
        {
            var tempList = workflow_TemplateRepository.GetList(new Rb_Workflow_Template_Extend() { TemplateSorce = 2, PropertyType = audite, Status = FinanceDataEnum.Normal });
            List<RB_FinanceFlowConnect_Extend> fcList = new List<RB_FinanceFlowConnect_Extend>();
            //再验证公司别
            if (tempList.Any())
            {
                fcList = financeFlowConnectRepository.GetExtendList(new RB_FinanceFlowConnect_Extend() { FlowtemplateIds = string.Join(",", tempList.Select(x => x.Id)) });
            }
            foreach (var item in tempList) {
                var fc2list = fcList.Where(x => x.FlowtemplateId == item.Id).ToList();
                if (fc2list.Where(x => x.Type == FinanceFlowConnectEnum.Company).Any())
                {
                    //集团通用
                    return item;
                }
                else if (fc2list.Where(x => x.Type == FinanceFlowConnectEnum.Branch && x.SuitableObjectId == BranchId).Any())
                {
                    //该公司在使用该流程
                    return item;
                }
            }
            return null;
        }
        #endregion

        #region 资产退库
        /// <summary>
        /// 获取资产领取单分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_UseReceive_Extend> GetPropertyCancellingStocksPageList(int pageIndex, int pageSize, RB_Property_UseReceive_Extend demodel, out long count)
        {
            var list = useReceiveRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            List<RB_Property_UseRelevance_Extend> urlist = new List<RB_Property_UseRelevance_Extend>();
            List<RB_Branch_Extend> blist = new List<RB_Branch_Extend>();
            List<RB_Department_Extend> dlist = new List<RB_Department_Extend>();
            if (list.Any())
            {
                string rstr = string.Join(",", list.Select(x => x.Id));
                urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = demodel.RB_Group_Id, ReceiveIdStr = rstr });
                List<Rb_Workflow_AuditRelevance_Extend> arlist = new List<Rb_Workflow_AuditRelevance_Extend>();
                if (demodel.IsSelfApplication == 1) {
                    //自助申请的查询
                    //查询所有的签名流程
                    arlist = workflow_AuditRelevanceRepository.GetAuditRelevanceList(0, rstr, WFRrocessStatus.NotAudit);
                }

                foreach (var item in list)
                {
                    item.DetailList = urlist.Where(x => x.ReceiveId == item.Id).ToList();

                    foreach (var item2 in item.DetailList) {
                        item2.CancelStockEmployeeName = CacheManager.User.UserReidsCache.GetEmployee(item2.CancelStockEmployeeId)?.EmName ?? "";
                    }
                    item.IsApplyForSign = 0;
                    if (demodel.IsSelfApplication == 1)
                    {
                        var arModel = arlist.Where(x => x.WorkFlowId == item.Id).OrderBy(x => x.Sort).FirstOrDefault();
                        if (arModel != null && arModel.SpecialNode == WFSpecialNodeEnum.Pay)
                        {
                            item.IsApplyForSign = 1;
                        }
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 资产折旧分页类别
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Depreciation_Extend> GetPropertyDepreciationPageList(int pageIndex, int pageSize, RB_Property_Depreciation_Extend demodel, out long count)
        {
            var list= property_DepreciationRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            //获取所有的分类名称
            if (list.Any()) {
                string CategoryIsStr = string.Join(",", list.Select(x => x.CategoryIdString));
                var clist = property_CategoryRepository.GetList(new RB_Property_Category_Extend() { RB_Group_Id = demodel.RB_Group_Id, CategoryIdStr = CategoryIsStr });
                foreach (var item in list) {
                    item.CategoryList = clist.Where(x => ("," + item.CategoryIdString + ",").Contains("," + x.Id + ",")).ToList();
                }
            }
            return list;
        }
        #endregion

        /// <summary>
        /// 转交
        /// </summary>
        /// <returns></returns>
        public ApiResult Transfer(List<Rb_Workflow_Auditrecord_Extend> list, UserInfo userInfo)
        {
            bool flag = true;
            foreach (var item in list)
            {
                int WorkFlowId = item.WorkFlowId.Value; int OldEmId = userInfo.EmployeeId; int NewEmId = item.AuditEmId.Value;
                if ((item.TransferEmpId ?? 0) > 0)
                {
                    OldEmId = item.TransferEmpId ?? 0;
                }
                var auditModel = workflow_AuditRelevanceRepository.GetAuditRelevanceList(WorkFlowId).Where(x => x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort).FirstOrDefault();
                if (auditModel == null)
                {
                    return ApiResult.Failed("财务单据：" + WorkFlowId + "审核流程已完毕");
                }
                int AuditId = auditModel.Id;
                if (AuditId > 0)
                {
                    //验证  是否有已审批通过的  再转交给审批通过者
                    var alist = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = AuditId });
                    if (alist != null && alist.Any())
                    {
                        //AuditStatus
                        if (alist.Where(x => x.AuditStatus == WFRrocessStatus.AuditThrough && x.AuditEmId == NewEmId).Count() > 0)
                        {
                            return ApiResult.Failed("转交人已参与审批通过,无法转交");
                        }
                    }
                }
                var useModel = useReceiveRepository.GetEntity(WorkFlowId);
                if (useModel == null)
                {
                    return ApiResult.Failed("该申请单无效");
                }
                var trans = workflow_AuditrecordRepository.DbTransaction;
                try
                {
                    var OldEmodel = employeeRepository.GetEntity(OldEmId);
                    var NewEmodel = employeeRepository.GetEntity(NewEmId);
                    if (OldEmodel == null || NewEmodel == null)
                    {
                        return ApiResult.Failed("转交人或者当前审核人不存在，请联系管理员");
                    }
                    var amodel = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = AuditId, AuditEmId = OldEmId })?.FirstOrDefault();
                    if (amodel == null) { return ApiResult.Failed("审核步骤不存在，请联系技术人员"); }
                    var coModelList = new List<SetCareOfModel>();
                    if (!string.IsNullOrWhiteSpace(amodel.CareOfRemarks))
                    {
                        coModelList = JsonConvert.DeserializeObject<List<SetCareOfModel>>(amodel.CareOfRemarks);
                    }
                    SetCareOfModel comodel = new SetCareOfModel()
                    {
                        BeFrom = OldEmodel.EmName,
                        Target = NewEmodel.EmName,
                        Remarks = item.Description
                    };
                    coModelList.Add(comodel);
                    flag = UpdateAuditEmId(AuditId, OldEmId, NewEmId, coModelList, trans);
                    //var EmNameList = new List<Model.Extend.Finance.EmAccoutIdModel>() { new Model.Extend.Finance.EmAccoutIdModel() { EmAccount = OldEmodel.EmAccount, EmployeeId = OldEmodel.EmployeeId } };
                    //PushAuditMessage(EmNameList, WorkFlowId, $@"您成功转交财务审核任务给{NewEmodel.EmName}", "转交成功", OldEmId, SysTemPushTypeEnum.Audit, 2);
                    //EmNameList = new List<Model.Extend.Finance.EmAccoutIdModel>() { new Model.Extend.Finance.EmAccoutIdModel() { EmAccount = NewEmodel.EmAccount, EmployeeId = NewEmodel.EmployeeId } };
                    //PushAuditMessage(EmNameList, WorkFlowId, $@"您有来自{OldEmodel.EmName}的转交财务审核任务", "转交审核", NewEmId, SysTemPushTypeEnum.Audit, 1);
                    //日志
                    RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                    {
                        LogId = 0,
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        UpdateBy = userInfo.EmployeeId,
                        UpdateDate = DateTime.Now,
                        ResourceId = WorkFlowId,
                        Type = 1,
                        Content = "由" + OldEmodel.EmName + "转交给" + NewEmodel.EmName
                    };
                    workfolw_Change_LogRepository.Insert(logModel, trans);

                }
                catch (Exception ex)
                {
                    LogHelper.Write(ex, "Transfer");
                    workflow_AuditrecordRepository.DBSession.Rollback("Transfer：1，异常信息：" + ex.Message);
                    return ApiResult.Failed("转交失败");
                }
            }
            if (flag)
            {
                workflow_AuditrecordRepository.DBSession.Commit();
                return ApiResult.Success("转交成功");
            }
            else
            {
                workflow_AuditrecordRepository.DBSession.Rollback("Transfer：2");
                return ApiResult.Failed("转交失败");
            }
        }

        /// <summary>
        /// 删除折旧
        /// </summary>
        /// <param name="depreciationId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelPropertyDepreciationInfo(int depreciationId, UserInfo userInfo)
        {
            Dictionary<string, object> files = new Dictionary<string, object>() {
                { nameof(RB_Property_Depreciation_Extend.Status),(int)DateStateEnum.Delete},
                { nameof(RB_Property_Depreciation_Extend.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Property_Depreciation_Extend.UpdateDate),DateTime.Now}
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                     FiledName=nameof(RB_Property_Depreciation_Extend.Id),
                      FiledValue=depreciationId,
                       OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = property_DepreciationRepository.Update(files, wheres);
            return flag;
        }

        /// <summary>
        /// 设置资产折旧
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetPropertyDepreciationInfo(RB_Property_Depreciation_Extend demodel)
        {
            if (demodel.Id > 0)
            {
                var model = property_DepreciationRepository.GetEntity(demodel.Id);
                model.Name = demodel.Name;
                model.Type = demodel.Type;
                model.ResidualsRate = demodel.ResidualsRate;
                model.CategoryIdString = demodel.CategoryIdString;
                model.UpdateBy = demodel.UpdateBy;
                model.UpdateDate = DateTime.Now;
                return property_DepreciationRepository.Update(model);
            }
            else {
                return property_DepreciationRepository.Insert(demodel) > 0;
            }
        }

        /// <summary>
        /// 更新审核人
        /// </summary>
        /// <param name="AuditId"></param>
        /// <param name="OldEmId"></param>
        /// <param name="NewEmId"></param>
        /// <param name="coModelList"></param>
        /// <param name="trans"></param>
        /// <returns></returns>
        public bool UpdateAuditEmId(int AuditId, int OldEmId, int NewEmId, List<SetCareOfModel> coModelList, System.Data.IDbTransaction trans = null)
        {
            bool flag = true, recordflag = true;
            //获取审核步骤
            var auditModel = workflow_AuditRelevanceRepository.GetEntity(AuditId);
            if (auditModel == null) { return false; }
            auditModel.ToAuditId = GetNewToAuditId(auditModel.ToAuditId, NewEmId, OldEmId, out int IsExist);
            if (string.IsNullOrEmpty(auditModel.ToAuditId)) { return false; }
            //更新审核步骤表
            IDictionary<string, object> fileds = new Dictionary<string, object>()
            {
                { nameof(Rb_Workflow_AuditRelevance.ToAuditId),auditModel.ToAuditId }
            };
            IList<WhereHelper> whereHelpers = new List<WhereHelper>()
            {
                new WhereHelper (){ FiledName=nameof(Rb_Workflow_AuditRelevance.Id),FiledValue=auditModel.Id,OperatorEnum=OperatorEnum.Equal}
            };            
            try
            {
                flag = workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans);
                #region 审核记录
                if (flag)
                {
                    var record = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = auditModel.Id, AuditEmId = OldEmId, AuditStatus = WFRrocessStatus.NotAudit })?.FirstOrDefault();
                    if (record != null)
                    {
                        //新审核人不在审核记录中
                        if (IsExist == 0)
                        {
                            IDictionary<string, object> filed = new Dictionary<string, object>()
                            {
                                { nameof(Rb_Workflow_Auditrecord.AuditEmId),NewEmId},
                                { nameof(Rb_Workflow_Auditrecord.CareOfRemarks),JsonConvert.SerializeObject(coModelList)}
                            };
                            IList<WhereHelper> whereHelper = new List<WhereHelper>()
                            {
                                new WhereHelper (){ FiledName=nameof(Rb_Workflow_Auditrecord.Id),FiledValue=record.Id,OperatorEnum=OperatorEnum.Equal}
                            };
                            recordflag = workflow_AuditrecordRepository.Update(filed, whereHelper, trans);
                        }
                        //新审核人在审核记录中
                        else
                        {
                            recordflag = workflow_AuditrecordRepository.Delete(record.Id, trans) > 0;
                        }
                    }
                    else
                    {
                        return false;
                    }
                }
                #endregion
                if (flag && recordflag)
                {
                    return true;
                }
                else
                {
                    return false;
                }
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "UpdateAuditEmId");
                return false;
            }
        }

        /// <summary>
        /// 获取新的待审核人
        /// </summary>
        /// <param name="ToAuditId"></param>
        /// <param name="NewEmId"></param>
        /// <param name="OldEmId"></param>
        /// <returns></returns>
        public string GetNewToAuditId(string ToAuditId, int NewEmId, int OldEmId, out int IsExist)
        {
            string AuditId = "";
            IsExist = 0;
            List<string> list = new List<string>(ToAuditId.Split(new string[] { "," }, StringSplitOptions.RemoveEmptyEntries));
            foreach (var item in list)
            {
                if (!string.IsNullOrEmpty(item))
                {
                    if (Convert.ToInt32(item) != NewEmId)
                    {
                        if (Convert.ToInt32(item) == OldEmId)
                        {
                            AuditId += NewEmId + ",";
                        }
                        else
                        {

                            AuditId += item + ",";
                        }
                    }
                    //原审核人集合中存在新审核人，则直接去掉旧审核人
                    else
                    {
                        IsExist = 1;
                    }
                }
            }
            if (!string.IsNullOrEmpty(AuditId))
            {
                AuditId = ("," + AuditId);
                AuditId = AuditId[1..^1];
            }
            return AuditId;
        }


        #region 资产盘点
        /// <summary>
        /// 获取资产盘点分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Check_Extend> GetPropertyCheckPageList(int pageIndex, int pageSize, RB_Property_Check_Extend demodel, out long count)
        {
            var list = property_CheckRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            foreach (var item in list) {
                item.CategoryIdList = new List<int>();
                if (!string.IsNullOrEmpty(item.CategoryIds)) {
                    item.CategoryIdList = JsonConvert.DeserializeObject<List<int>>("[" + item.CategoryIds + "]");
                }
            }
            return list;
        }

        /// <summary>
        /// 设置盘点
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public bool SetPropertyCheckInfo(RB_Property_Check_Extend demodel)
        {
            var trans = property_CheckRepository.DbTransaction;
            try
            {
                if (demodel.Id > 0)
                {
                    bool IsUpdate = false;
                    var model = property_CheckRepository.GetEntity(demodel.Id);
                    if (model.BranchId != demodel.BranchId || model.CategoryIds != demodel.CategoryIds) {
                        IsUpdate = true;
                    }
                    model.Name = demodel.Name;
                    model.StartDate = demodel.StartDate;
                    model.EndDate = demodel.EndDate;
                    model.BranchId = demodel.BranchId;
                    model.CategoryIds = demodel.CategoryIds;
                    model.UpdateBy = demodel.UpdateBy;
                    model.UpdateDate = demodel.UpdateDate;
                    var flag = property_CheckRepository.Update(model, trans);
                    if (flag) {
                        if (IsUpdate) {
                            var list = property_CheckDetailRepository.GetList(new RB_Property_CheckDetail_Extend() { RB_Group_Id = demodel.RB_Group_Id, CheckId = demodel.Id });
                            foreach (var item in list)
                            {
                                property_CheckDetailRepository.Delete(item, trans);
                            }
                            //根据公司  类型查找所有的资产  创建明细
                            var list2 = property_InfoRepository.GetList(new RB_Property_Info_Extend() { RB_Group_Id = demodel.RB_Group_Id, CategoryIds = demodel.CategoryIds, BranchId = demodel.BranchId });
                            foreach (var item in list2)
                            {
                                property_CheckDetailRepository.Insert(new RB_Property_CheckDetail()
                                {
                                    AuditDate = null,
                                    AuditEmpId = 0,
                                    CheckStatus = PropertyCheckStatusEnum.NoInventory,
                                    CheckDate = null,
                                    CheckEmpId = 0,
                                    CheckId = demodel.Id,
                                    Id = 0,
                                    AuditStatus = 1,
                                    CreateBy = demodel.CreateBy,
                                    CreateDate = demodel.CreateDate,
                                    PropertyId = item.Id,
                                    RB_Branch_Id = demodel.RB_Branch_Id,
                                    RB_Group_Id = demodel.RB_Group_Id,
                                    Remark = "",
                                    Status = 0,
                                    UpdateBy = demodel.UpdateBy,
                                    UpdateDate = demodel.UpdateDate
                                }, trans);
                            }
                        }
                    }
                    property_CheckRepository.DBSession.Commit();
                    return true;
                }
                else
                {

                    int Id = property_CheckRepository.Insert(demodel, trans);
                    if (Id > 0)
                    {
                        //根据公司  类型查找所有的资产  创建明细
                        var list = property_InfoRepository.GetList(new RB_Property_Info_Extend() { RB_Group_Id = demodel.RB_Group_Id, CategoryIds = demodel.CategoryIds, BranchId = demodel.BranchId });
                        foreach (var item in list)
                        {
                            property_CheckDetailRepository.Insert(new RB_Property_CheckDetail()
                            {
                                AuditDate = null,
                                AuditEmpId = 0,
                                CheckStatus = PropertyCheckStatusEnum.NoInventory,
                                CheckDate = null,
                                CheckEmpId = 0,
                                CheckId = Id,
                                Id = 0,
                                AuditStatus = 1,
                                CreateBy = demodel.CreateBy,
                                CreateDate = demodel.CreateDate,
                                PropertyId = item.Id,
                                RB_Branch_Id = demodel.RB_Branch_Id,
                                RB_Group_Id = demodel.RB_Group_Id,
                                Remark = "",
                                Status = 0,
                                UpdateBy = demodel.UpdateBy,
                                UpdateDate = demodel.UpdateDate
                            }, trans);
                        }
                    }
                    property_CheckRepository.DBSession.Commit();
                    return true;
                }
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "SetPropertyCheckInfo");
                property_CheckRepository.DBSession.Rollback();
                return false;
            }
        }

        /// <summary>
        /// 删除盘点
        /// </summary>
        /// <param name="checkId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool DelPropertyCheckInfo(int checkId, UserInfo userInfo)
        {
            var trans = property_CheckRepository.DbTransaction;
            try
            {
                Dictionary<string, object> flies = new Dictionary<string, object>() {
                    { nameof(RB_Property_Check_Extend.Status),1}
                };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                    new WhereHelper(){
                         FiledName=nameof(RB_Property_Check_Extend.Id),
                          FiledValue=checkId,
                           OperatorEnum=OperatorEnum.Equal
                    }
                };
                bool flag = property_CheckRepository.Update(flies, wheres, trans);
                if (flag) {
                    var list = property_CheckDetailRepository.GetList(new RB_Property_CheckDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, CheckId = checkId });
                    foreach (var item in list)
                    {
                        property_CheckDetailRepository.Delete(item, trans);
                    }
                }
                property_CheckRepository.DBSession.Commit();
                return flag;
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "DelPropertyCheckInfo");
                property_CheckRepository.DBSession.Rollback();
                return false;
            }
            

        }

        /// <summary>
        /// 获取资产盘点详情分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_CheckDetail_Extend> GetPropertyCheckDetailPageList(int pageIndex, int pageSize, RB_Property_CheckDetail_Extend demodel, out long count)
        {
            var list = property_CheckDetailRepository.GetPageList(pageIndex, pageSize, demodel, out count);
            if (list.Any()) {
                foreach (var item in list) {
                    item.ImageList = new List<string>();
                    if (!string.IsNullOrEmpty(item.Images) && item.Images != "[]") {
                        item.ImageList = JsonConvert.DeserializeObject<List<string>>(item.Images);
                    }
                }
            }
            return list;
        }
        /// <summary>
        /// 获取盘点详情列表
        /// </summary>
        /// <param name="demodel"></param>
        /// <returns></returns>
        public List<RB_Property_CheckDetail_Extend> GetPropertyCheckDetailList( RB_Property_CheckDetail_Extend demodel)
        {
            return property_CheckDetailRepository.GetList(demodel);
        }

        /// <summary>
        /// 盘点单下是否已处理盘亏
        /// </summary>
        /// <param name="checkId"></param>
        /// <param name="GroupId"></param>
        /// <returns></returns>
        public bool IsPropertyCheckDeal(int checkId,int GroupId) 
        {
            var list = property_CheckDetailRepository.GetList(new RB_Property_CheckDetail_Extend() { RB_Group_Id = GroupId, CheckId = checkId, DealStatus = 1 });
            if (list.Any()) {
                return true;
            }
            return false;
        }

        /// <summary>
        /// 设置盘点单状态
        /// </summary>
        /// <param name="checkId"></param>
        /// <returns></returns>
        public bool SetPropertyCheckStatus(int checkId,int Type, UserInfo userInfo)
        {
            Dictionary<string, object> flies = new Dictionary<string, object>() {
                { nameof(RB_Property_Check_Extend.CheckState),Type==1?1: 2},
                { nameof(RB_Property_Check_Extend.UpdateBy),userInfo.EmployeeId},
                { nameof(RB_Property_Check_Extend.UpdateDate),DateTime.Now}
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Property_Check_Extend.Id),
                        FiledValue=checkId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = property_CheckRepository.Update(flies, wheres);
            if (flag) {
                //查询所有未盘点的  默认设置为盘亏
                if (Type != 1)
                {
                    var list = property_CheckDetailRepository.GetList(new RB_Property_CheckDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, CheckId = checkId, CheckStatus = PropertyCheckStatusEnum.NoInventory });
                    foreach (var item in list)
                    {
                        Dictionary<string, object> flies1 = new Dictionary<string, object>() {
                            { nameof(RB_Property_CheckDetail_Extend.CheckStatus),PropertyCheckStatusEnum.InventoryLosses}
                        };
                        List<WhereHelper> wheres1 = new List<WhereHelper>() {
                            new WhereHelper(){
                                    FiledName=nameof(RB_Property_CheckDetail_Extend.Id),
                                    FiledValue=item.Id,
                                    OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        property_CheckDetailRepository.Update(flies1, wheres1);
                    }
                }
            }
            return flag;
        }

        /// <summary>
        /// 设置盘点单明细状态
        /// </summary>
        /// <param name="checkDetailId"></param>
        /// <param name="Type"></param>
        /// <param name="Remark"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetPropertyCheckDetailStatus(int checkDetailId, int Type,string Remark, UserInfo userInfo)
        {
            Dictionary<string, object> flies = new Dictionary<string, object>();
            if (Type == 1)//盘点
            {
                flies.Add(nameof(RB_Property_CheckDetail.CheckEmpId), userInfo.EmployeeId);
                flies.Add(nameof(RB_Property_CheckDetail.CheckDate), DateTime.Now);
                flies.Add(nameof(RB_Property_CheckDetail.CheckStatus), PropertyCheckStatusEnum.HaveInventory);
                flies.Add(nameof(RB_Property_CheckDetail.Remark), Remark);
            }
            if (Type == 2)//盘亏
            {
                flies.Add(nameof(RB_Property_CheckDetail.CheckEmpId), userInfo.EmployeeId);
                flies.Add(nameof(RB_Property_CheckDetail.CheckDate), DateTime.Now);
                flies.Add(nameof(RB_Property_CheckDetail.CheckStatus), PropertyCheckStatusEnum.InventoryLosses);
                flies.Add(nameof(RB_Property_CheckDetail.Remark), Remark);
            }
            else if (Type == 3)//盘点并通过
            {
                flies.Add(nameof(RB_Property_CheckDetail.CheckEmpId), userInfo.EmployeeId);
                flies.Add(nameof(RB_Property_CheckDetail.CheckDate), DateTime.Now);
                flies.Add(nameof(RB_Property_CheckDetail.CheckStatus), PropertyCheckStatusEnum.HaveInventory);
                flies.Add(nameof(RB_Property_CheckDetail.AuditEmpId), userInfo.EmployeeId);
                flies.Add(nameof(RB_Property_CheckDetail.AuditDate), DateTime.Now);
                flies.Add(nameof(RB_Property_CheckDetail.AuditStatus), 2);
                flies.Add(nameof(RB_Property_CheckDetail.Remark), Remark);
            }
            else if (Type == 4) //通过
            {
                flies.Add(nameof(RB_Property_CheckDetail.AuditEmpId), userInfo.EmployeeId);
                flies.Add(nameof(RB_Property_CheckDetail.AuditDate), DateTime.Now);
                flies.Add(nameof(RB_Property_CheckDetail.AuditStatus), 2);
            }
            else if (Type == 5)//驳回
            {
                flies.Add(nameof(RB_Property_CheckDetail.AuditEmpId), userInfo.EmployeeId);
                flies.Add(nameof(RB_Property_CheckDetail.AuditDate), DateTime.Now);
                flies.Add(nameof(RB_Property_CheckDetail.AuditStatus), 3);
            }
            else if (Type == 6)//取消盘亏
            {
                flies.Add(nameof(RB_Property_CheckDetail.CheckEmpId), 0);
                flies.Add(nameof(RB_Property_CheckDetail.CheckDate), null);
                flies.Add(nameof(RB_Property_CheckDetail.CheckStatus), PropertyCheckStatusEnum.NoInventory);
            }
            else if (Type == 7) {//处理 
                flies.Add(nameof(RB_Property_CheckDetail.CheckEmpId), userInfo.EmployeeId);
                flies.Add(nameof(RB_Property_CheckDetail.CheckDate), DateTime.Now);
                flies.Add(nameof(RB_Property_CheckDetail.DealStatus), 1);
            }
            
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Property_CheckDetail.Id),
                        FiledValue=checkDetailId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag= property_CheckDetailRepository.Update(flies, wheres);
            if (flag) {
                if (Type == 7) {
                    //盘亏 修改资产为删除状态 
                    var model= property_CheckDetailRepository.GetEntity(checkDetailId);
                    if (model.CheckStatus == PropertyCheckStatusEnum.InventoryLosses)
                    {
                        Dictionary<string, object> flies1 = new Dictionary<string, object>() {
                            { nameof(RB_Property_Info.PropertyStatus),PropertyStatusEnum.Dispose}
                        };
                        List<WhereHelper> wheres1 = new List<WhereHelper>() {
                            new WhereHelper(){
                                    FiledName=nameof(RB_Property_Info.Id),
                                    FiledValue=model.PropertyId,
                                    OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        property_InfoRepository.Update(flies1, wheres1);
                        //写入日志
                        property_LogRepository.Insert(new RB_Property_Log()
                        {
                            PropertyId = model.PropertyId,
                            Status = 0,
                            Content = "处置资产为盘亏",
                            TypeName = "处置",
                            RB_Branch_Id = userInfo.RB_Branch_id,
                            RB_Group_Id = userInfo.RB_Group_id,
                            CreateBy = userInfo.EmployeeId,
                            CreateDate = DateTime.Now
                        });
                    }
                }
            }
            return flag;
        }

        /// <summary>
        /// 设置盘点图片
        /// </summary>
        /// <param name="checkDetailId"></param>
        /// <param name="imagesList"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetPropertyCheckImage(int checkDetailId, List<string> imagesList, UserInfo userInfo)
        {
            Dictionary<string, object> flies = new Dictionary<string, object>
            {
                { nameof(RB_Property_CheckDetail.CheckEmpId), userInfo.EmployeeId },
                { nameof(RB_Property_CheckDetail.CheckDate), DateTime.Now },
                { nameof(RB_Property_CheckDetail.Images), JsonConvert.SerializeObject(imagesList) }
            };
            List<WhereHelper> wheres = new List<WhereHelper>() {
                new WhereHelper(){
                        FiledName=nameof(RB_Property_CheckDetail.Id),
                        FiledValue=checkDetailId,
                        OperatorEnum=OperatorEnum.Equal
                }
            };
            bool flag = property_CheckDetailRepository.Update(flies, wheres);
            return flag;
        }

        /// <summary>
        /// 设置app盘点状态
        /// </summary>
        /// <param name="propertyId"></param>
        /// <param name="type"></param>
        /// <param name="remark"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult SetPropertyAPPCheckDetailStatus(int propertyId, int Type, string Remark, UserInfo userInfo)
        {
            var list = property_CheckDetailRepository.GetList(new RB_Property_CheckDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, PropertyId = propertyId, CheckStatus = PropertyCheckStatusEnum.NoInventory });
            if (!list.Any()) {
                return ApiResult.Failed("该资产不存在待盘点，请核实后再试");
            }
            var trans = property_CheckDetailRepository.DbTransaction;
            try
            {
                foreach (var item in list) {
                    Dictionary<string, object> flies = new Dictionary<string, object>();
                    if (Type == 1)//盘点
                    {
                        flies.Add(nameof(RB_Property_CheckDetail.CheckEmpId), userInfo.EmployeeId);
                        flies.Add(nameof(RB_Property_CheckDetail.CheckDate), DateTime.Now);
                        flies.Add(nameof(RB_Property_CheckDetail.CheckStatus), PropertyCheckStatusEnum.HaveInventory);
                        flies.Add(nameof(RB_Property_CheckDetail.Remark), Remark);
                    }
                    if (Type == 2)//盘亏
                    {
                        flies.Add(nameof(RB_Property_CheckDetail.CheckEmpId), userInfo.EmployeeId);
                        flies.Add(nameof(RB_Property_CheckDetail.CheckDate), DateTime.Now);
                        flies.Add(nameof(RB_Property_CheckDetail.CheckStatus), PropertyCheckStatusEnum.InventoryLosses);
                        flies.Add(nameof(RB_Property_CheckDetail.Remark), Remark);
                    }
                    else if (Type == 3)//盘点并通过
                    {
                        flies.Add(nameof(RB_Property_CheckDetail.CheckEmpId), userInfo.EmployeeId);
                        flies.Add(nameof(RB_Property_CheckDetail.CheckDate), DateTime.Now);
                        flies.Add(nameof(RB_Property_CheckDetail.CheckStatus), PropertyCheckStatusEnum.HaveInventory);
                        flies.Add(nameof(RB_Property_CheckDetail.AuditEmpId), userInfo.EmployeeId);
                        flies.Add(nameof(RB_Property_CheckDetail.AuditDate), DateTime.Now);
                        flies.Add(nameof(RB_Property_CheckDetail.AuditStatus), 2);
                        flies.Add(nameof(RB_Property_CheckDetail.Remark), Remark);
                    }
                    

                    List<WhereHelper> wheres = new List<WhereHelper>() {
                        new WhereHelper(){
                                FiledName=nameof(RB_Property_CheckDetail.Id),
                                FiledValue=item.Id,
                                OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    bool flag = property_CheckDetailRepository.Update(flies, wheres);
                    if (!flag)
                    {
                        property_CheckDetailRepository.DBSession.Rollback();
                        return ApiResult.Failed();
                    }
                }
                property_CheckDetailRepository.DBSession.Commit();
                return ApiResult.Success();
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "SetPropertyAPPCheckDetailStatus");
                property_CheckDetailRepository.DBSession.Rollback();
                return ApiResult.Failed();
            }
        }

        /// <summary>
        /// 验证盘点单状态
        /// </summary>
        /// <param name="checkDetailId"></param>
        /// <returns></returns>
        public bool ValidataPropertyCheckDetail(int checkDetailId)
        {
            var model = property_CheckDetailRepository.GetEntity(checkDetailId);
            var cmodel = property_CheckRepository.GetEntity(model?.CheckId ?? 0);
            if (cmodel != null && cmodel.CheckState == 1)
            {
                return false;
            }
            return true;
        }

        /// <summary>
        /// 获取资产是否在盘点
        /// </summary>
        /// <param name="propertyId"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool GetPropertyIsHaveCheck(int propertyId, UserInfo userInfo)
        {
            var list= property_CheckDetailRepository.GetList(new RB_Property_CheckDetail_Extend() { RB_Group_Id = userInfo.RB_Group_id, PropertyId = propertyId, CheckStatus = PropertyCheckStatusEnum.NoInventory });
            if (list.Any())
            {
                return true;
            }
            else {
                return false;
            }
        }

        #endregion


        #region 资产统计

        /// <summary>
        /// 获取资产分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetDepreciationStatisticsPageList(int pageIndex, int pageSize, RB_Property_Info_Extend demodel, out long count)
        {
            var list = property_InfoRepository.GetPageList(pageIndex, pageSize, demodel, out count);

            if (list.Any())
            {
                //获取折旧列表
                var dlist = property_DepreciationRepository.GetList(new RB_Property_Depreciation_Extend() { RB_Group_Id = demodel.RB_Group_Id });
                foreach (var item in list)
                {
                    if (item.EmployeeId > 0)
                    {
                        item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                    }
                    else
                    {
                        item.EmName = "";
                    }

                    #region 图片
                    if (item.Images == "" || item.Images == null)
                    {
                        item.Images = "[]";
                    }
                    var imglist = JsonConvert.DeserializeObject<List<string>>(item.Images);
                    item.ImageList = new List<string>();
                    foreach (var img in imglist)
                    {
                        item.ImageList.Add(Config.GetFileUrl(img));
                    }
                    #endregion

                    //查询折旧
                    var dmodel = dlist.Where(x => ("," + x.CategoryIdString + ",").Contains("," + item.CategoryId + ",")).FirstOrDefault();
                    if (dmodel != null)
                    {
                        item.DepreciationType = dmodel.Type;
                        item.ResidualsRate = dmodel.ResidualsRate;
                        if (item.UseMonths > 0)
                        {
                            if (dmodel.Type == 1)
                            {
                                item.MonthDepreciation = ((item.Money ?? 0) - (item.Money ?? 0) * (dmodel.ResidualsRate ?? 0) / 100) / (Convert.ToDecimal(item.UseMonths ?? 1));
                                //已使用的月份数量
                                DateTime dt1 = Convert.ToDateTime(item.BuyDate.Value.ToString("yyyy-MM") + "-01");
                                DateTime dt2 = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM") + "-01");
                                int Month = (dt2.Year - dt1.Year) * 12 + (dt2.Month - dt1.Month);
                                item.TotalDepreciation = (item.MonthDepreciation ?? 0) * Month;
                                item.UsedMonth = Month;
                            }
                            else {
                                //已使用的月份数量
                                DateTime dt1 = Convert.ToDateTime(item.BuyDate.Value.ToString("yyyy-MM") + "-01");
                                DateTime dt2 = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM") + "-01");
                                int Month = (dt2.Year - dt1.Year) * 12 + (dt2.Month - dt1.Month);
                                item.UsedMonth = Month;
                                if (Month > 1)
                                {
                                    item.MonthDepreciation = 0;
                                    item.TotalDepreciation = 0;
                                }
                                else
                                {
                                    item.MonthDepreciation = ((item.Money ?? 0) - (item.Money ?? 0) * (dmodel.ResidualsRate ?? 0) / 100) / ((item.UseMonths ?? 1));
                                    item.TotalDepreciation = (item.MonthDepreciation ?? 0) * Month;
                                }
                            }
                        }
                        else {
                            item.MonthDepreciation = 0;
                            item.TotalDepreciation = 0;
                            //已使用的月份数量
                            DateTime dt1 = Convert.ToDateTime(item.BuyDate.Value.ToString("yyyy-MM") + "-01");
                            DateTime dt2 = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM") + "-01");
                            int Month = (dt2.Year - dt1.Year) * 12 + (dt2.Month - dt1.Month);
                            item.UsedMonth = Month;
                        }
                    }
                }
            }
            return list;
        }

        /// <summary>
        /// 获取资产分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetDepreciationStatisticsList(RB_Property_Info_Extend demodel)
        {
            var list = property_InfoRepository.GetList(demodel);

            if (list.Any())
            {
                //获取折旧列表
                var dlist = property_DepreciationRepository.GetList(new RB_Property_Depreciation_Extend() { RB_Group_Id = demodel.RB_Group_Id });
                foreach (var item in list)
                {
                    if (item.EmployeeId > 0)
                    {
                        item.EmName = CacheManager.User.UserReidsCache.GetEmployee(item.EmployeeId)?.EmName ?? "";
                    }
                    else
                    {
                        item.EmName = "";
                    }

                    #region 图片
                    if (item.Images == "" || item.Images == null)
                    {
                        item.Images = "[]";
                    }
                    var imglist = JsonConvert.DeserializeObject<List<string>>(item.Images);
                    item.ImageList = new List<string>();
                    foreach (var img in imglist)
                    {
                        item.ImageList.Add(Config.GetFileUrl(img));
                    }
                    #endregion

                    //查询折旧
                    var dmodel = dlist.Where(x => ("," + x.CategoryIdString + ",").Contains("," + item.CategoryId + ",")).FirstOrDefault();
                    if (dmodel != null)
                    {
                        item.DepreciationType = dmodel.Type;
                        item.ResidualsRate = dmodel.ResidualsRate;
                        if (item.UseMonths > 0)
                        {
                            if (dmodel.Type == 1)
                            {
                                item.MonthDepreciation = ((item.Money ?? 0) - (item.Money ?? 0) * (dmodel.ResidualsRate ?? 0) / 100) / (Convert.ToDecimal(item.UseMonths ?? 1) / 12);
                                //已使用的月份数量
                                DateTime dt1 = Convert.ToDateTime(item.BuyDate.Value.ToString("yyyy-MM") + "-01");
                                DateTime dt2 = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM") + "-01");
                                int Month = (dt2.Year - dt1.Year) * 12 + (dt2.Month - dt1.Month);
                                item.TotalDepreciation = (item.MonthDepreciation ?? 0) * Month;
                                item.UsedMonth = Month;
                            }
                            else
                            {
                                //已使用的月份数量
                                DateTime dt1 = Convert.ToDateTime(item.BuyDate.Value.ToString("yyyy-MM") + "-01");
                                DateTime dt2 = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM") + "-01");
                                int Month = (dt2.Year - dt1.Year) * 12 + (dt2.Month - dt1.Month);
                                item.UsedMonth = Month;
                                if (Month > 1)
                                {
                                    item.MonthDepreciation = 0;
                                    item.TotalDepreciation = 0;
                                }
                                else
                                {
                                    item.MonthDepreciation = ((item.Money ?? 0) - (item.Money ?? 0) * (dmodel.ResidualsRate ?? 0) / 100) / ((item.UseMonths ?? 1) / 12);
                                    item.TotalDepreciation = (item.MonthDepreciation ?? 0) * Month;
                                }
                            }
                        }
                        else
                        {
                            item.MonthDepreciation = 0;
                            item.TotalDepreciation = 0;
                            //已使用的月份数量
                            DateTime dt1 = Convert.ToDateTime(item.BuyDate.Value.ToString("yyyy-MM") + "-01");
                            DateTime dt2 = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM") + "-01");
                            int Month = (dt2.Year - dt1.Year) * 12 + (dt2.Month - dt1.Month);
                            item.UsedMonth = Month;
                        }
                    }
                }
            }
            return list;
        }
        #endregion

        #region 首页统计
        /// <summary>
        /// 首页任务
        /// </summary>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetPropertyIndexTask(UserInfo userInfo)
        {
            object Robj = new object();
            //待我签字
            int SignCount = useReceiveRepository.GetPropertyWaitMySignCount(new RB_Property_UseReceive_Extend() { RB_Group_Id = userInfo.RB_Group_id, AuditEmId = userInfo.EmployeeId });
            //待我审核
            int WaitCount = useReceiveRepository.GetPropertyWaitMyAuditCount(new RB_Property_UseReceive_Extend() { RB_Group_Id = userInfo.RB_Group_id, AuditEmId = userInfo.EmployeeId });
            //审核驳回
            int RejectCount = useReceiveRepository.GetPropertyWaitMyAuditCount(new RB_Property_UseReceive_Extend() { RB_Group_Id = userInfo.RB_Group_id, CreateBy = userInfo.EmployeeId, AuditStatus = OrderStateEnum.Reject });
            //当月到期资产
            int MaturityCount = property_InfoRepository.GetPropertyMaturityCount(new RB_Property_Info_Extend() { RB_Group_Id = userInfo.RB_Group_id, EndTime = Convert.ToDateTime(DateTime.Now.ToString("yyyy-MM") + "-01").AddMonths(1).AddDays(-1).ToString("yyyy-MM-dd") });
            //耗材库存预警
            int SafeCount = supplies_InventoryRepository.GetSafetyStockWarningCount(new RB_Supplies_Inventory_Extend() { RB_Group_Id = userInfo.RB_Group_id });
            //我的资产

            //查询所有领用借用待确认的
            RB_Property_Info_Extend demodel = new RB_Property_Info_Extend
            {
                RB_Group_Id = userInfo.RB_Group_id,
                IsSelectMyProperty = 1,
                CreateBy = userInfo.EmployeeId
            };
            var plist = useRelevanceRepository.GetPropertySureList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = userInfo.RB_Group_id, EmployeeId = userInfo.EmployeeId });
            demodel.PropertyIdStr = string.Join(",", plist.Select(x => x.PropertyId ?? 0).Distinct());
            int MyProperty = property_InfoRepository.GetPropertyToMyCount(demodel);

            return new
            {
                SignCount,
                WaitCount,
                RejectCount,
                MyProperty,
                MaturityCount,
                SafeCount
            };
        }

        /// <summary>
        /// 首页资产概况
        /// </summary>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetPropertyIndexGeneralSituation(UserInfo userInfo)
        {
            var ZYModel = property_InfoRepository.GetPropertyIndexGeneralSituation(new RB_Property_Info_Extend() { RB_Group_Id = userInfo.RB_Group_id, LogType = "1" });
            var KXModel = property_InfoRepository.GetPropertyIndexGeneralSituation(new RB_Property_Info_Extend() { RB_Group_Id = userInfo.RB_Group_id, LogType = "2" });

            return new
            {
                TotalCount= (ZYModel?.PropertyNumber??0)+(KXModel?.PropertyNumber??0),
                NorCount= (ZYModel?.PropertyNumber ?? 0),
                IdleCount= (KXModel?.PropertyNumber ?? 0),
                NorMoney= (ZYModel?.Money ?? 0),
                IdleMoney = (KXModel?.Money ?? 0),
            };
        }

        /// <summary>
        /// 首页资产状态占比
        /// </summary>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetPropertyIndexPropertyStatusRatio(UserInfo userInfo)
        {
            List<object> rObj = new List<object>();
            var List = property_InfoRepository.GetPropertyIndexPropertyStatusRatio(new RB_Property_Info_Extend() { RB_Group_Id = userInfo.RB_Group_id, LogType = "1" });
            rObj.Add(new
            {
                Name = PropertyStatusEnum.Receive.GetEnumName(),
                Count = List.Where(x => x.PropertyStatus == PropertyStatusEnum.Receive || x.PropertyStatus == PropertyStatusEnum.CancellingStocksW || x.PropertyStatus == PropertyStatusEnum.ReceiveW).Sum(x => x.PropertyNumber ?? 0)
            });
            rObj.Add(new
            {
                Name = PropertyStatusEnum.Leisure.GetEnumName(),
                Count = List.Where(x => x.PropertyStatus == PropertyStatusEnum.Leisure).Sum(x => x.PropertyNumber ?? 0)
            });
            rObj.Add(new
            {
                Name = PropertyStatusEnum.Borrow.GetEnumName(),
                Count = List.Where(x => x.PropertyStatus == PropertyStatusEnum.Borrow || x.PropertyStatus == PropertyStatusEnum.GiveBackW || x.PropertyStatus == PropertyStatusEnum.BorrowW).Sum(x => x.PropertyNumber ?? 0)
            });
            rObj.Add(new
            {
                Name = PropertyStatusEnum.AllotW.GetEnumName(),
                Count = List.Where(x => x.PropertyStatus == PropertyStatusEnum.AllotW).Sum(x => x.PropertyNumber ?? 0)
            });
            rObj.Add(new
            {
                Name = PropertyStatusEnum.Dispose.GetEnumName(),
                Count = List.Where(x => x.PropertyStatus == PropertyStatusEnum.Dispose || x.PropertyStatus == PropertyStatusEnum.DisposeW).Sum(x => x.PropertyNumber ?? 0)
            });
            var List2 = property_InfoRepository.GetPropertyIndexPropertyStatusRatio(new RB_Property_Info_Extend() { RB_Group_Id = userInfo.RB_Group_id, LogType = "2" });
            rObj.Add(new
            {
                Name ="维修",
                Count = List2.Sum(x => x.PropertyNumber ?? 0)
            });
            return rObj;
        }

        /// <summary>
        /// 首页资产入库领用情况
        /// </summary>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetPropertyIndexPropertyInStock(RB_Property_Info_Extend demodel)
        {
            List<object> Robj = new List<object>();
            var list = property_InfoRepository.GetPropertyIndexPropertyInStock(demodel);
            List<string> MonthList = new List<string>();
            //获取所有的日期
            if (Convert.ToDateTime(demodel.StartTime) < Convert.ToDateTime(demodel.EndTime))
            {
                while (true)
                {
                    if (Convert.ToDateTime(demodel.StartTime).ToString("yyyy-MM") == Convert.ToDateTime(demodel.EndTime).ToString("yyyy-MM"))
                    {
                        MonthList.Add(Convert.ToDateTime(demodel.StartTime).ToString("yyyy-MM"));
                        break;
                    }
                    MonthList.Add(Convert.ToDateTime(demodel.StartTime).ToString("yyyy-MM"));
                    demodel.StartTime = Convert.ToDateTime(demodel.StartTime).AddMonths(1).ToString("yyyy-MM-dd");
                }
            }
            else {
                MonthList.Add(Convert.ToDateTime(demodel.StartTime).ToString("yyyy-MM"));
            }
            List<int> categoryList = new List<int>();
            if (!string.IsNullOrEmpty(demodel.CategoryIds))
            {
                categoryList = JsonConvert.DeserializeObject<List<int>>("[" + demodel.CategoryIds + "]");
            }
            else {
                categoryList = list.Select(x => x.CategoryId ?? 0).Distinct().ToList();
            }
            List<RB_Property_Category_Extend> cateList = new List<RB_Property_Category_Extend>();
            if (categoryList.Any()) {
                cateList = property_CategoryRepository.GetList(new RB_Property_Category_Extend() { RB_Group_Id = demodel.RB_Group_Id, CategoryIdStr = string.Join(",", categoryList), Type = 1 });
            }
            foreach (var categoryIdstr in categoryList) {
                List<object> CRobj = new List<object>();
                //遍历所有的月份
                foreach (var month in MonthList) {
                    var clist = list.Where(x => x.StartTime == month && x.CategoryId == Convert.ToInt32(categoryIdstr)).ToList();
                    if (clist.Any())
                    {
                        CRobj.Add(new
                        {
                            Month = month,
                            Number = clist.Sum(x => x.PropertyNumber ?? 0)
                        });
                    }
                    else {
                        CRobj.Add(new
                        {
                            Month = month,
                            Number = 0
                        });
                    }
                }
                var cateModel = cateList.Where(x => x.Id == categoryIdstr).FirstOrDefault();
                Robj.Add(new
                {
                    CategoryId = Convert.ToInt32(categoryIdstr),
                    CategoryName = cateModel.Name,
                    List = CRobj
                });
            }
            return Robj;
        }

        /// <summary>
        /// 首页物料入库领用情况
        /// </summary>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public object GetPropertyIndexSuppliesInStock(RB_Supplies_StockIn_Extend demodel)
        {
            List<object> Robj = new List<object>();
            var list = supplies_StockInRepository.GetPropertyIndexSuppliesInStock(demodel);
            List<string> MonthList = new List<string>();
            //获取所有的日期
            if (Convert.ToDateTime(demodel.StartTime) < Convert.ToDateTime(demodel.EndTime))
            {
                while (true)
                {
                    if (Convert.ToDateTime(demodel.StartTime).ToString("yyyy-MM") == Convert.ToDateTime(demodel.EndTime).ToString("yyyy-MM"))
                    {
                        MonthList.Add(Convert.ToDateTime(demodel.StartTime).ToString("yyyy-MM"));
                        break;
                    }
                    MonthList.Add(Convert.ToDateTime(demodel.StartTime).ToString("yyyy-MM"));
                    demodel.StartTime = Convert.ToDateTime(demodel.StartTime).AddMonths(1).ToString("yyyy-MM-dd");
                }
            }
            else
            {
                MonthList.Add(Convert.ToDateTime(demodel.StartTime).ToString("yyyy-MM"));
            }

            List<int> suppliesIdList = new List<int>();
            if (!string.IsNullOrEmpty(demodel.SuppliesIds))
            {
                suppliesIdList = JsonConvert.DeserializeObject<List<int>>("[" + demodel.SuppliesIds + "]");
            }
            else
            {
                suppliesIdList = list.Select(x => x.SuppliesId ?? 0).Distinct().ToList();
            }
            List<RB_Supplies_Material_Extend> MaterialList = new List<RB_Supplies_Material_Extend>();
            if (suppliesIdList.Any()) 
            {
                MaterialList = supplies_MaterialRepository.GetList(new RB_Supplies_Material_Extend() { RB_Group_Id = demodel.RB_Group_Id, SuppliesIdStr = string.Join(",", suppliesIdList) }, true);
            }
            foreach (var suppliesId in suppliesIdList)
            {
                List<object> CRobj = new List<object>();
                //遍历所有的月份
                foreach (var month in MonthList)
                {
                    var clist = list.Where(x => x.StartTime == month && x.SuppliesId == suppliesId).ToList();
                    if (clist.Any())
                    {
                        CRobj.Add(new
                        {
                            Month = month,
                            Number = clist.Sum(x => x.SuppliesNumber ?? 0)
                        });
                    }
                    else
                    {
                        CRobj.Add(new
                        {
                            Month = month,
                            Number = 0
                        });
                    }
                }
                var MaterialModel = MaterialList.Where(x => x.Id == suppliesId).FirstOrDefault();
                Robj.Add(new
                {
                    SuppliesId = Convert.ToInt32(suppliesId),
                    SuppliesName = MaterialModel.Name,
                    List = CRobj
                });
            }
            return Robj;
        }
        #endregion

        #region 请购单
        /// <summary>
        /// 获取请购单分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_BuyingRequisition_Extend> GetBuyingRequisitionPageList(int pageIndex, int pageSize, RB_Property_BuyingRequisition_Extend demodel, out long count)
        {
            return property_BuyingRequisitionRepository.GetPageList(pageIndex, pageSize, demodel, out count);
        }

        /// <summary>
        /// 新增修改请购单
        /// </summary>
        /// <param name="demodel"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetBuyingRequisitionInfo(RB_Property_BuyingRequisition_Extend demodel, UserInfo userInfo)
        {
            if (demodel.Id > 0)
            {
                var model = property_BuyingRequisitionRepository.GetEntity(demodel.Id);
                if (model.BuyStatus != BuyingRequisitionStatusEnum.Pending)
                {
                    return false;
                }
                model.Name = demodel.Name;
                model.Type = demodel.Type;
                model.CategoryId = demodel.CategoryId;
                model.Content = demodel.Content;
                model.UseTime = demodel.UseTime;
                model.UpdateBy = demodel.UpdateBy;
                model.UpdateDate = demodel.UpdateDate;
                return property_BuyingRequisitionRepository.Update(model);
            }
            else
            {
                demodel.BuyStatus = BuyingRequisitionStatusEnum.Pending;
                return property_BuyingRequisitionRepository.Insert(demodel) > 0;
            }
        }

        /// <summary>
        /// 设置请购单状态
        /// </summary>
        /// <param name="buyingRequisitionId"></param>
        /// <param name="type"></param>
        /// <param name="buyTime"></param>
        /// <param name="rejectRemark"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public bool SetBuyingRequisitionStatus(int buyingRequisitionId, int type, string buyTime, string rejectRemark, UserInfo userInfo)
        {
            var model = property_BuyingRequisitionRepository.GetEntity(buyingRequisitionId);
            if (model == null)
            {
                return false;
            }
            if (type == 1)
            {//购买中
                model.BuyStatus = BuyingRequisitionStatusEnum.DuringPurchase;
                model.BuyTime = Convert.ToDateTime(buyTime);
            }
            else if (type == 2)
            {//驳回
                model.BuyStatus = BuyingRequisitionStatusEnum.Reject;
                model.RejectRemark = rejectRemark;

            }
            else if (type == 3)
            {
                //已购买
                model.BuyStatus = BuyingRequisitionStatusEnum.Purchased;
                model.BuyTime = Convert.ToDateTime(buyTime);
            }
            else if (type == 4) 
            {
                if (model.CreateBy == userInfo.EmployeeId)
                {
                    model.BuyStatus = BuyingRequisitionStatusEnum.Withdraw;
                }
                else {
                    return false;
                }
            }
            model.UpdateBy = userInfo.EmployeeId;
            model.UpdateDate = DateTime.Now;
            bool flag = property_BuyingRequisitionRepository.Update(model);
            if (flag)
            {
                List<EmAccoutIdModel> account = new List<EmAccoutIdModel>();
                var emodel = CacheManager.User.UserReidsCache.GetEmployee(model.CreateBy);
                if (emodel != null) {
                    account.Add(new EmAccoutIdModel()
                    {
                        EmployeeId = emodel.EmployeeId,
                        EmAccount = emodel.LoginMobile
                    });
                }
                //发送通知
                PushBuyingMessage(account, 0, "您有资产请购信息已购买，请往资产管理系统查看", "请购单通知", userInfo.EmployeeId, SysTemPushTypeEnum.PropertyAudit);
            }
            return flag;
        }

        /// <summary>
        /// 推送资产购买消息
        /// </summary>
        /// <param name="account"></param>
        /// <param name="workFlowId"></param>
        /// <param name="content"></param>
        /// <param name="title"></param>
        /// <param name="empId"></param>
        /// <param name="type"></param>
        public void PushBuyingMessage(List<EmAccoutIdModel> account, int workFlowId, string content, string title, int? empId, SysTemPushTypeEnum type)
        {
            //Dictionary<string, object> appExtras = new Dictionary<string, object>();
            Dictionary<string, object> webExtras = new Dictionary<string, object>
            {
                { "jumpUrl", "" }
            };
            //appExtras.Add("jumpUrl", "vt://financeApprovalDetail/view?ID=" + workFlowId + "&Conditon=3&Source=message&Type=" + Type);

            //IMService.PushFinanceMessage(account, empId, content, title, type, SystemPushLogTypeEnum.XMApp, appExtras);
            IMService.PushMessage(account.RefMapperToList<Property.Common.Models.EmAccoutIdModel>(), empId, content, title, type, SystemPushLogTypeEnum.Web, webExtras);
        }
        #endregion
    }
}
