﻿using REBORN.Common;
using REBORN.Common.Enum;
using REBORN.Common.Plugin;
using Property.Model.Entity;
using Property.Model.Extend;
using Property.Repository;
using System;
using System.Collections.Generic;
using System.Linq;
using Newtonsoft.Json;
using REBORN.Commom.Plugin;
using REBORN.Common.API;
using System.Data;
using REBORN.IM.Service;

namespace Property.Module.FixedAssets
{
    /// <summary>
    /// 流程模块
    /// </summary>
    public class WorkFlowModule
    {
        private readonly Rb_departmentRepository departmentRepository = new Rb_departmentRepository();
        private readonly Rb_employeeRepository employeeRepository = new Rb_employeeRepository();
        private readonly Rb_branchRepository branchRepository = new Rb_branchRepository();

        //流程
        private readonly Rb_Workflow_TemplateRepository workflow_TemplateRepository = new Rb_Workflow_TemplateRepository();
        private readonly Rb_Workflow_ConditionRepository workflow_ConditionRepository = new Rb_Workflow_ConditionRepository();
        private readonly Rb_Workflow_AuditRepository workflow_AuditRepository = new Rb_Workflow_AuditRepository();
        private readonly Rb_Workflow_AuditUserRepository workflow_AuditUserRepository = new Rb_Workflow_AuditUserRepository();
        private readonly Rb_Workflow_AuditrecordRepository workflow_AuditrecordRepository = new Rb_Workflow_AuditrecordRepository();
        private readonly Rb_Workflow_AuditRelevanceRepository workflow_AuditRelevanceRepository = new Rb_Workflow_AuditRelevanceRepository();
        private readonly Rb_Workflow_AuditUserRelevanceRepository workflow_AuditUserRelevanceRepository = new Rb_Workflow_AuditUserRelevanceRepository();
        private readonly RB_Audit_DelegateRepository audit_DelegateRepository = new RB_Audit_DelegateRepository();
        private readonly Rb_Workflow_CopyToPeopleRepository workflow_CopyToPeopleRepository = new Rb_Workflow_CopyToPeopleRepository();
        private readonly RB_Workfolw_Change_LogRepository workfolw_Change_LogRepository = new RB_Workfolw_Change_LogRepository();


        /// <summary>
        /// 资产信息
        /// </summary>
        private readonly RB_Property_InfoRepository property_InfoRepository = new RB_Property_InfoRepository();
        /// <summary>
        /// 资产日志
        /// </summary>
        private readonly RB_Property_LogRepository property_LogRepository = new RB_Property_LogRepository();
        /// <summary>
        /// 资产使用
        /// </summary>
        private readonly RB_Property_UseReceiveRepository useReceiveRepository = new RB_Property_UseReceiveRepository();
        /// <summary>
        /// 资产使用关联
        /// </summary>
        private readonly RB_Property_UseRelevanceRepository useRelevanceRepository = new RB_Property_UseRelevanceRepository();



        /// <summary>
        /// 初始化审批流程
        /// </summary>
        /// <returns></returns>
        public bool InsertAuditRelevance(Rb_Workflow_Template_Extend tmodel, PropertySourceEnum? Source, int CreateBy, int AuditEmId, int useReceiveId,List<int> ApplyForList, out List<EmAccoutIdModel> sendAccount, int Sort=1,List<Rb_Workflow_AuditRelevance> auditRelevanceList = null, IDbTransaction trans=null)
        {
            sendAccount = new List<EmAccoutIdModel>();
            var conditionModel = workflow_ConditionRepository.GetConditionByTemplateId(tmodel.Id).FirstOrDefault();
            if (conditionModel == null) {
                return false;
            }

            int BranchId = 0;
            //获取模板审批流程
            var auditList = workflow_AuditRepository.GetDefaultAudit(conditionModel.Id);
            List<Rb_Workflow_AuditUserRelevance> audituserRelevanceListAll = new List<Rb_Workflow_AuditUserRelevance>();
            if (auditRelevanceList == null || auditRelevanceList.Count == 0)
            {
                auditRelevanceList = new List<Rb_Workflow_AuditRelevance>();
                #region 拷贝审核节点
                if (auditList.Count > 0)
                {
                    //首先查询出来 是否是部门负责人
                    var empModel = CacheManager.User.UserReidsCache.GetEmployee(CreateBy);
                    if (empModel == null)
                    {
                        return false;
                    }
                    BranchId = empModel.RB_Branch_id;
                    var depModel = departmentRepository.GetEntity(empModel.RB_Department_Id);
                    if (depModel == null)
                    {
                        return false;
                    }
                    string ManageerIds = depModel.ManagerIds;
                    if (("," + depModel.ManagerIds + ",").Contains("," + CreateBy + ","))
                    {//说明他是部门的负责人   需要遍历出所有直属主管审核  改成第二级 ，如果有第二级  就干掉，
                     //找出直属主管审批
                        int roleinNum = 2;
                        //查询第二级主管是否制单人  是的话  找第三级主管
                        var dep2 = departmentRepository.GetEntity(depModel.ParentId ?? 0);
                        ManageerIds = dep2?.ManagerIds ?? "";
                        if (dep2 != null && ("," + dep2.ManagerIds + ",").Contains("," + CreateBy + ","))
                        {
                            roleinNum = 3;
                            //查询第三级主管是否制单人   是的话  找第四级主管
                            var dep3 = departmentRepository.GetEntity(dep2.ParentId ?? 0);
                            ManageerIds = dep3?.ManagerIds ?? "";
                            if (dep3 != null && ("," + dep3.ManagerIds + ",").Contains("," + CreateBy + ","))
                            {
                                roleinNum = 4;
                                var dep4 = departmentRepository.GetEntity(dep3.ParentId ?? 0);
                                ManageerIds = dep4?.ManagerIds ?? "";
                                if (dep4 != null && ("," + dep4.ManagerIds + ",").Contains("," + CreateBy + ","))
                                {
                                    roleinNum = 5;
                                    var dep5 = departmentRepository.GetEntity(dep4.ParentId ?? 0);
                                    ManageerIds = dep5?.ManagerIds ?? "";
                                    if (dep5 != null && ("," + dep5.ManagerIds + ",").Contains("," + CreateBy + ","))
                                    {
                                        roleinNum = 6;
                                    }
                                }
                            }
                        }

                        var AuditDirectorList = auditList.Where(x => x.AuditType == (int)FinanceAuditTypeEnum.Director && x.RoleOrInitiator == 1).ToList();
                        if (AuditDirectorList.Count > 0)
                        {
                            //需要 直属主管审核  改成第二级 ，如果有第二级  就干掉，
                            var AuditDirectorTwoList = auditList.Where(x => x.AuditType == (int)FinanceAuditTypeEnum.Director && x.RoleOrInitiator > 1 && x.RoleOrInitiator <= roleinNum).ToList();
                            if (AuditDirectorTwoList.Count > 0)
                            {
                                //有下级部门审批  直接删除直接主管审批
                                List<int> AIDArr = AuditDirectorList.Select(x => x.Id).ToList();
                                auditList = auditList.Where(x => !AIDArr.Contains(x.Id)).ToList();
                            }

                            //需要只留一条数据
                            var auditModel = AuditDirectorList[0];
                            auditModel.RoleOrInitiator = roleinNum;
                            if (AuditDirectorList.Count > 1)
                            {
                                List<int> AIDArr = AuditDirectorList.Where(x => x.Id != auditModel.Id).Select(x => x.Id).ToList();
                                auditList = auditList.Where(x => !AIDArr.Contains(x.Id)).ToList();
                            }

                        }
                    }
                    

                    auditList = auditList.OrderBy(x => x.Sort).ToList();

                    //添加拷贝审核节点
                    foreach (var item in auditList)
                    {
                        Rb_Workflow_AuditRelevance auditRelevance = item.RefMapperTo<Rb_Workflow_AuditRelevance>();
                        auditRelevance.WorkFlowId = useReceiveId;
                        auditRelevance.AuditType = (FinanceAuditTypeEnum)item.AuditType.Value;
                        auditRelevance.TemplateType = 0;
                        auditRelevance.OriginalAuditId = item.Id;
                        auditRelevance.Stauts = WFRrocessStatus.NotAudit;
                        auditRelevance.AuditWay = (FinanceAuditTypeEnum)item.AuditType.Value == FinanceAuditTypeEnum.Director ? WFTAuditWayEnum.OrSign : (WFTAuditWayEnum)item.AuditWay;
                        if (item.SpecialNode == WFSpecialNodeEnum.Pay) {
                            auditRelevance.AuditWay = WFTAuditWayEnum.Countersign;
                        }
                        auditRelevance.Id = workflow_AuditRelevanceRepository.Insert(auditRelevance, trans);
                        auditRelevanceList.Add(auditRelevance);
                        //添加审核节点指定审核成员
                        if (auditRelevance.AuditType == FinanceAuditTypeEnum.SpecifiedMember)
                        {
                            List<Rb_Workflow_Audituser_Extend> audituserList = workflow_AuditUserRepository.GetConditionAuditUser(item.Id);
                            if (audituserList.Count > 0)
                            {
                                var audituserRelevanceList = new List<Rb_Workflow_AuditUserRelevance>();
                                foreach (var audituser in audituserList)
                                {
                                    Rb_Workflow_AuditUserRelevance auditUserRelevance = audituser.RefMapperTo<Rb_Workflow_AuditUserRelevance>();
                                    auditUserRelevance.AuditRelevanceId = auditRelevance.Id;
                                    audituserRelevanceList.Add(auditUserRelevance);
                                    audituserRelevanceListAll.Add(auditUserRelevance);
                                }
                                workflow_AuditUserRelevanceRepository.InsertBatch(audituserRelevanceList, trans);
                            }
                        }
                    }
                }
                else//申请拒绝
                {
                    return false;
                }
                #endregion
            }
            #region 添加初始审核人
            if (auditRelevanceList.Count > 0)
            {
                var newList = new List<int>();
                var auditRelevance = auditRelevanceList.OrderBy(t => t.Sort).FirstOrDefault();
                if (Sort > 1)
                {
                    auditRelevance = auditRelevanceList.Where(x => x.Sort == Sort).OrderBy(t => t.Sort).FirstOrDefault();
                }

                if (auditRelevance.SpecialNode == WFSpecialNodeEnum.Pay)
                {
                    if (!ApplyForList.Any()) {
                        return false;
                    }
                    newList = ApplyForList;
                    var emp2List = employeeRepository.GetEmpInfoByIds(string.Join(",", newList?.Select(x => x).ToList()));
                    sendAccount = emp2List.Select(t => new EmAccoutIdModel() { EmAccount = t.EmLoginMobile, EmployeeId = t.EmployeeId }).ToList();//推送
                }
                else
                {
                    //部门负责人审核
                    if (auditRelevance.AuditType == FinanceAuditTypeEnum.Director)
                    {
                        //员工当前所在部门
                        RB_Department currentDepartment = departmentRepository.GetDepartmentByEmpId(CreateBy);
                        //获取部门分组所有部门
                        List<RB_Department_Extend> departmentList = departmentRepository.GetDepartmentGroupByEmpId(CreateBy);
                        if (currentDepartment != null)
                        {
                            //目标部门
                            RB_Department targetDepartment = GetTargetByParentDepartment(currentDepartment, departmentList, currentDepartment.Tier.Value - (auditRelevance.RoleOrInitiator.Value - 1));
                            if (targetDepartment == null)
                            {
                                return false;
                            }
                            if (string.IsNullOrEmpty(targetDepartment.ManagerIds))
                            {
                                return false;
                            }
                            var emp = employeeRepository.GetEmpInfoByIds(targetDepartment.ManagerIds);
                            //审核主管
                            //部门负责人在职状态
                            if (emp != null && emp.Count > 0)
                            {
                                #region 转交人
                                newList = new List<int>();
                                newList = emp.Select(x => x.EmployeeId).ToList();
                                newList = GetNewEmList(newList);
                                #endregion
                                var empList = employeeRepository.GetEmpInfoByIds(string.Join(",", newList?.Select(x => x).ToList()));
                                sendAccount = empList.Select(t => new EmAccoutIdModel() { EmAccount = t.EmLoginMobile, EmployeeId = t.EmployeeId }).ToList();//推送
                            }
                            else
                            {
                                return false;
                            }
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else if (auditRelevance.AuditType == FinanceAuditTypeEnum.Role)//角色审核
                    {
                        List<RB_Employee_Extend> empList = employeeRepository.GetList(new RB_Employee_Extend() { RB_Post_Id = auditRelevance.RoleOrInitiator.Value });

                        empList = GetSameEmList(empList?.Select(x => x.EmployeeId).ToList(), BranchId);
                        if (empList != null && empList.Count > 0)
                        {
                            newList = empList.Select(x => x.EmployeeId).ToList();
                            sendAccount = empList.Select(t => new EmAccoutIdModel() { EmAccount = t.EmLoginMobile, EmployeeId = t.EmployeeId }).ToList();//推送
                        }
                        else
                        {
                            return false;
                        }

                    }
                    else if (auditRelevance.AuditType == FinanceAuditTypeEnum.SpecifiedMember)//指定人审核
                    {
                        List<int> empList = new List<int>();

                        List<Rb_Workflow_Audituser_Extend> audituserList = workflow_AuditUserRepository.GetConditionAuditUser(auditRelevance.OriginalAuditId.Value);
                        empList = audituserList?.Select(x => x.EmployeeId ?? 0).ToList();
                        if (empList != null && empList.Count > 0)
                        {
                            newList = empList;
                            var emp2List = employeeRepository.GetEmpInfoByIds(string.Join(",", newList?.Select(x => x).ToList()));
                            sendAccount = emp2List.Select(t => new EmAccoutIdModel() { EmAccount = t.EmLoginMobile, EmployeeId = t.EmployeeId }).ToList();//推送
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else
                    {
                        return false;
                    }
                }
                
                if (newList != null && newList.Count > 0)
                {
                    //制单人
                    var AuditEmIds = new List<int>
                    {
                        CreateBy
                    };
                    #region 判断是否有已审核的人，有的话直接跳过
                    if (true)
                    {
                        if (AuditEmIds.Where(x => newList.Exists(y => y == x)).Count() == newList.Count()&& auditRelevance.SpecialNode != WFSpecialNodeEnum.Pay)
                        {
                            //审批人在已审批人里  判断是否是最后一步  不是的话  需要创建下一步审批
                            foreach (var item in newList)
                            {
                                AuditEmIds.Add(item);
                            }
                            AuditEmIds = AuditEmIds.Distinct().ToList();
                            InsertBatcheAuditRecord2(newList, useReceiveId, trans, auditRelevance);
                            if (auditRelevanceList.LastOrDefault().Id == auditRelevance.Id)
                            {
                                //最后一步了  执行操作
                                //判断是否需要签字 
                                //更新资产状态

                            }
                            else
                            {
                                Sort = auditRelevance.Sort.Value + 1;
                                InsertAuditRelevanceNext(tmodel, auditRelevanceList.Where(x => x.Sort == Sort).FirstOrDefault().RefMapperTo<Rb_Workflow_AuditRelevance_Extend>(), CreateBy, AuditEmId, useReceiveId, ApplyForList, trans, out sendAccount, AuditEmIds, audituserRelevanceListAll);
                            }
                        }
                        else if (AuditEmIds.Where(x => newList.Exists(y => y == x)).Count() > 0 && auditRelevance.SpecialNode != WFSpecialNodeEnum.Pay)
                        {
                            List<int> oldAuditEmIds = new List<int>();
                            AuditEmIds.ForEach(x =>
                            {
                                oldAuditEmIds.Add(x);
                            });
                            //可能是会签   可能是或签
                            if (auditRelevance.AuditWay == WFTAuditWayEnum.Countersign)
                            {
                                //会签
                                InsertBatcheAuditRecord3(newList, AuditEmId, 1, useReceiveId, trans, auditRelevance, oldAuditEmIds);
                                #region 添加抄送人
                                List<Rb_Workflow_Audituser_Extend> aduitUserList = workflow_AuditUserRepository.GetDefaultAuditUser(conditionModel.Id);
                                if (aduitUserList.Count > 0)
                                {
                                    List<Rb_Workflow_CopyToPeople> copyToPeopleList = new List<Rb_Workflow_CopyToPeople>();
                                    foreach (var item in aduitUserList)
                                    {
                                        if (item.EmployeeId != CreateBy)
                                        {
                                            Rb_Workflow_CopyToPeople copyToPeople = new Rb_Workflow_CopyToPeople
                                            {
                                                EmployeeId = item.EmployeeId,
                                                ReadStauts = 1,
                                                Stauts = WFRrocessStatus.NotAudit,
                                                WorkFlowId = useReceiveId,
                                                TemplateType = 0
                                            };
                                            copyToPeopleList.Add(copyToPeople);
                                        }
                                    }
                                    workflow_CopyToPeopleRepository.InsertBatch(copyToPeopleList, trans);
                                }
                                #endregion
                            }
                            else if (auditRelevance.AuditWay == WFTAuditWayEnum.OrSign)
                            {
                                //或签
                                foreach (var item in newList)
                                {
                                    AuditEmIds.Add(item);
                                }
                                AuditEmIds = AuditEmIds.Distinct().ToList();
                                InsertBatcheAuditRecord3(newList, AuditEmId, 2, useReceiveId, trans, auditRelevance, oldAuditEmIds);
                                if (auditRelevanceList.LastOrDefault().Id == auditRelevance.Id)
                                {
                                    //通过了 需要更新资产状态
                                    //查询是否需要签名  
                                }
                                else
                                {
                                    Sort = auditRelevance.Sort.Value + 1;
                                    InsertAuditRelevanceNext(tmodel, auditRelevanceList.Where(x => x.Sort == Sort).FirstOrDefault().RefMapperTo<Rb_Workflow_AuditRelevance_Extend>(), CreateBy, AuditEmId, useReceiveId, ApplyForList, trans, out sendAccount, AuditEmIds, audituserRelevanceListAll);
                                }
                            }
                            else
                            {
                                InsertBatcheAuditRecord(newList, useReceiveId, trans, auditRelevance);
                                #region 添加抄送人
                                List<Rb_Workflow_Audituser_Extend> aduitUserList = workflow_AuditUserRepository.GetDefaultAuditUser(conditionModel.Id);
                                if (aduitUserList.Count > 0)
                                {
                                    List<Rb_Workflow_CopyToPeople> copyToPeopleList = new List<Rb_Workflow_CopyToPeople>();
                                    foreach (var item in aduitUserList)
                                    {
                                        Rb_Workflow_CopyToPeople copyToPeople = new Rb_Workflow_CopyToPeople
                                        {
                                            EmployeeId = item.EmployeeId,
                                            ReadStauts = 1,
                                            Stauts = WFRrocessStatus.NotAudit,
                                            WorkFlowId = useReceiveId,
                                            TemplateType = 0
                                        };
                                        copyToPeopleList.Add(copyToPeople);
                                    }
                                    workflow_CopyToPeopleRepository.InsertBatch(copyToPeopleList, trans);
                                }
                                #endregion
                            }

                        }
                        else
                        {
                            InsertBatcheAuditRecord(newList, useReceiveId, trans, auditRelevance);
                            #region 添加抄送人
                            List<Rb_Workflow_Audituser_Extend> aduitUserList = workflow_AuditUserRepository.GetDefaultAuditUser(conditionModel.Id);
                            if (aduitUserList.Count > 0)
                            {
                                List<Rb_Workflow_CopyToPeople> copyToPeopleList = new List<Rb_Workflow_CopyToPeople>();
                                foreach (var item in aduitUserList)
                                {
                                    Rb_Workflow_CopyToPeople copyToPeople = new Rb_Workflow_CopyToPeople
                                    {
                                        EmployeeId = item.EmployeeId,
                                        ReadStauts = 1,
                                        Stauts = WFRrocessStatus.NotAudit,
                                        WorkFlowId = useReceiveId,
                                        TemplateType = 0
                                    };
                                    copyToPeopleList.Add(copyToPeople);
                                }
                                workflow_CopyToPeopleRepository.InsertBatch(copyToPeopleList, trans);
                            }
                            #endregion
                        }
                    }
                    else
                    {
                        //暂时只有常规
                    }
                    #endregion
                }
            }
            #endregion

            return true;
        }
        /// <summary>
        /// 获取公司审批角色
        /// </summary>
        /// <param name="emList"></param>
        /// <param name="RB_Branch_Id"></param>
        /// <param name="BId"></param>
        /// <returns></returns>
        public List<RB_Employee_Extend> GetSameEmList(List<int> emList, int RB_Branch_Id, int BId = 0)
        {
            if (emList == null || emList.Count == 0)
            {
                return null;
            }
            var empList = employeeRepository.GetEmpInfoByIds(string.Join(",", emList?.Select(x => x)));
            List<RB_Employee_Extend> IsExist = new List<RB_Employee_Extend>();
            if (BId > 0)
            {
                IsExist = empList?.Where(x => x.RB_Branch_id == BId).ToList();
            }
            else
            {
                IsExist = empList?.Where(x => x.RB_Branch_id == RB_Branch_Id).ToList();
            }
            if (IsExist != null && IsExist.Count > 0)
            {
                empList = IsExist;
            }
            else
            {
                var company = branchRepository.GetList(new RB_Branch_Extend() { IsParentCompany = 1 })?.FirstOrDefault();
                if (company == null)
                {
                    return null;
                }
                empList = empList?.Where(x => x.RB_Branch_id == company.Id).ToList();
            }
            #region 查看是否有转交人
            var newList = GetNewEmList(empList?.Select(x => x.EmployeeId).ToList());
            if (newList != null && newList.Count > 0)
            {
                empList = employeeRepository.GetEmpInfoByIds(string.Join(",", newList?.Select(x => x)));
            }
            #endregion
            return empList;
        }

        /// <summary>
        /// 审批通过后创建下一步审批
        /// </summary>
        public bool InsertAuditRelevanceNext(Rb_Workflow_Template_Extend tmodel, Rb_Workflow_AuditRelevance_Extend modelNext, int CreateBy, int AuditEmId, int useReceiveId, List<int> ApplyForList, IDbTransaction financetrans, out List<EmAccoutIdModel> AuditAccountList, List<int> AuditEmIds = null, List<Rb_Workflow_AuditUserRelevance> audituserRelevanceList = null)
        {
            var newList = new List<int>();
            #region 添加初始审核人
            AuditAccountList = new List<EmAccoutIdModel>();
            int wfId = useReceiveId;
            var emModel = CacheManager.User.UserReidsCache.GetEmployee(CreateBy);
            int BranchId = emModel.RB_Branch_id;
            int PostId = emModel.RB_Post_Id;
            var emList = new List<int>();
            var auditRelevance = modelNext.RefMapperTo<Rb_Workflow_AuditRelevance>();
            var recordList = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { AuditId = modelNext.Id });
            if (recordList != null && recordList.Count > 0)
            {
                workflow_AuditrecordRepository.DeleteBatch(recordList, financetrans);
            }
            if (AuditEmId <= 0)
            {
                return false;
            }
            #region 制单人+当前审核人+历史审核人
            if (AuditEmIds == null || AuditEmIds.Count == 0)
            {
                AuditEmIds = new List<int>();
                //历史审批人
                AuditEmIds = workflow_AuditrecordRepository.GetFinaceAuditRecordList(new Rb_Workflow_Auditrecord_Extend() { WorkFlowId = wfId, AuditStatus = WFRrocessStatus.AuditThrough })?.Select(x => x.AuditEmId.Value).ToList();
                //制单人
                AuditEmIds.Add(CreateBy);
                AuditEmIds.Add(AuditEmId);
            }
            #endregion
            if (emList != null && emList.Count > 0)
            {
                #region 判断下一步是否有转交人
                newList = new List<int>();
                newList = GetNewEmList(emList);
                #endregion
                List<RB_Employee_Extend> empList = employeeRepository.GetEmpInfoByIds(string.Join(",", newList.Select(x => x).ToList()));
                if (empList.Count > 0)
                {
                    AuditAccountList = empList.Select(t => new EmAccoutIdModel() { EmAccount = t.EmAccount, EmployeeId = t.EmployeeId }).Distinct().ToList();
                    newList = empList.Select(t => t.EmployeeId).ToList();
                }
                else
                {
                    return false;
                }
            }
            else
            {
                if (auditRelevance.SpecialNode == WFSpecialNodeEnum.Pay)
                {
                    if (!ApplyForList.Any())
                    {
                        return false;
                    }
                    newList = ApplyForList;
                    var emp2List = employeeRepository.GetEmpInfoByIds(string.Join(",", newList?.Select(x => x).ToList()));
                    AuditAccountList = emp2List.Select(t => new EmAccoutIdModel() { EmAccount = t.EmLoginMobile, EmployeeId = t.EmployeeId }).ToList();//推送
                }
                else
                {
                    //部门负责人审核
                    if (auditRelevance.AuditType == FinanceAuditTypeEnum.Director)
                    {
                        //员工当前所在部门
                        RB_Department currentDepartment = departmentRepository.GetDepartmentByEmpId(CreateBy);
                        //获取部门分组所有部门
                        List<RB_Department_Extend> departmentList = departmentRepository.GetDepartmentGroupByEmpId(CreateBy);
                        if (currentDepartment != null)
                        {
                            //目标部门
                            RB_Department targetDepartment = GetTargetByParentDepartment(currentDepartment, departmentList, currentDepartment.Tier.Value - (auditRelevance.RoleOrInitiator.Value - 1));
                            if (targetDepartment == null)
                            {
                                return false;
                            }
                            if (string.IsNullOrEmpty(targetDepartment.ManagerIds))
                            {
                                return false;
                            }
                            var emp = employeeRepository.GetEmpInfoByIds(targetDepartment.ManagerIds).Where(x => x.IsLeave == 0).ToList();
                            //审核主管
                            //部门负责人在职状态
                            if (emp != null && emp.Count > 0)
                            {
                                #region 判断下一步是否有转交人
                                newList = new List<int>();
                                newList = emp.Select(x => x.EmployeeId).ToList();
                                newList = GetNewEmList(newList);
                                #endregion
                                var empList = employeeRepository.GetEmpInfoByIds(string.Join(",", newList?.Select(x => x).ToList()));
                                AuditAccountList = empList.Select(t => new EmAccoutIdModel() { EmAccount = t.EmLoginMobile, EmployeeId = t.EmployeeId }).Distinct().ToList();
                            }
                            else
                            {
                                return false;
                            }
                        }
                        else
                        {
                            return false;
                        }
                    }
                    else if (auditRelevance.AuditType == FinanceAuditTypeEnum.Role)//角色审核
                    {

                        var empList = employeeRepository.GetList(new RB_Employee_Extend() { RB_Post_Id = auditRelevance.RoleOrInitiator.Value });
                        if (empList != null && empList.Count > 0)
                        {
                            newList = empList?.Select(x => x.EmployeeId).ToList();
                            AuditAccountList = empList.Select(t => new EmAccoutIdModel() { EmAccount = t.EmLoginMobile, EmployeeId = t.EmployeeId }).Distinct().ToList();
                        }
                        else
                        {
                            return false;
                        }

                    }
                    else if (auditRelevance.AuditType == FinanceAuditTypeEnum.SpecifiedMember)//指定人审核
                    {
                        List<Rb_Workflow_AuditUserRelevance_Extend> audituserList = new List<Rb_Workflow_AuditUserRelevance_Extend>();
                        if (audituserRelevanceList != null)
                        {
                            audituserList = audituserRelevanceList.Where(x => x.AuditRelevanceId == auditRelevance.Id).ToList().RefMapperToList<Rb_Workflow_AuditUserRelevance_Extend>();
                            foreach (var item in audituserList)
                            {
                                if (item.EmployeeId > 0)
                                {
                                    var emList2 = employeeRepository.GetEntity(item.EmployeeId);
                                    item.EmName = emList2 != null ? emList2.EmName : "";
                                    item.EmAccount = emList2 != null ? emList2.EmAccount : "";
                                    item.EmLoginMobile = emList2 != null ? emList2.EmLoginMobile : "";
                                }
                            }
                        }
                        else
                        {
                            audituserList = GetAuditUserRelevanceByAuditRelevanceId(auditRelevance.Id);
                        }
                        if (audituserList.Count > 0)
                        {
                            AuditAccountList = audituserList.Select(x => new EmAccoutIdModel() { EmAccount = x.EmLoginMobile, EmployeeId = x.EmployeeId ?? 0 }).Distinct().ToList();
                            List<int> empIds = audituserList.Select(t => t.EmployeeId.Value).ToList();
                            #region 判断下一步是否有转交人
                            newList = new List<int>();
                            newList = GetNewEmList(empIds);
                            #endregion
                        }
                        else
                        {
                            return false;
                        }

                    }
                    else
                    {
                        return false;
                    }
                }
            }
            if (newList != null && newList.Count() > 0)
            {
                #region 判断下一步是否有已经审核过的人，如果有则跳过
                if (true)
                {
                    if (AuditEmIds.Where(x => newList.Exists(y => y == x)).Count() == newList.Count() && auditRelevance.SpecialNode != WFSpecialNodeEnum.Pay)
                    {
                        foreach (var item in newList)
                        {
                            AuditEmIds.Add(item);
                        }
                        AuditEmIds = AuditEmIds.Distinct().ToList();
                        var auditRelevanceList = GetAuditRelevanceList(wfId).OrderBy(x => x.Sort).ToList();
                        InsertBatcheAuditRecord2(newList, wfId, financetrans, auditRelevance);
                        if (auditRelevanceList != null && auditRelevanceList.Count > 0)
                        {
                            if (auditRelevanceList?.LastOrDefault().Id == auditRelevance.Id)
                            {
                                //更新资产状态信息
                                return false;
                            }
                            else
                            {
                                InsertAuditRelevanceNext(tmodel, auditRelevanceList.Where(x => x.Sort == auditRelevance.Sort + 1)?.FirstOrDefault(), CreateBy, AuditEmId, useReceiveId, ApplyForList, financetrans, out AuditAccountList, AuditEmIds);
                            }
                        }
                    }
                    else if (AuditEmIds.Where(x => newList.Exists(y => y == x)).Count() > 0 && auditRelevance.SpecialNode != WFSpecialNodeEnum.Pay)
                    {
                        List<int> oldAuditEmIds = new List<int>();
                        AuditEmIds.ForEach(x =>
                        {
                            oldAuditEmIds.Add(x);
                        });
                        //可能是会签   可能是或签
                        if (auditRelevance.AuditWay == WFTAuditWayEnum.Countersign)
                        {
                            //会签
                            InsertBatcheAuditRecord3(newList, AuditEmId, 1, wfId, financetrans, auditRelevance, oldAuditEmIds);
                        }
                        else if (auditRelevance.AuditWay == WFTAuditWayEnum.OrSign)
                        {
                            //或签
                            foreach (var item in newList)
                            {
                                AuditEmIds.Add(item);
                            }
                            AuditEmIds = AuditEmIds.Distinct().ToList();
                            var auditRelevanceList = GetAuditRelevanceList(wfId).OrderBy(x => x.Sort).ToList();
                            InsertBatcheAuditRecord3(newList, AuditEmId, 2, wfId, financetrans, auditRelevance, oldAuditEmIds);
                            if (auditRelevanceList.LastOrDefault().Id == auditRelevance.Id)
                            {
                                //更新资产状态信息
                                return false;
                            }
                            else
                            {
                                InsertAuditRelevanceNext(tmodel, auditRelevanceList.Where(x => x.Sort == auditRelevance.Sort + 1).FirstOrDefault(), CreateBy, AuditEmId, useReceiveId, ApplyForList, financetrans, out AuditAccountList, AuditEmIds, audituserRelevanceList);
                            }
                        }
                        else
                        {
                            InsertBatcheAuditRecord(newList, wfId, financetrans, auditRelevance);
                        }

                    }
                    else
                    {
                        InsertBatcheAuditRecord(newList, wfId, financetrans, auditRelevance);
                    }
                }
                //else
                //{
                //    InsertBatcheAuditRecord(newList, wfId, financetrans, auditRelevance);
                //}
                #endregion
            }
            #endregion
            return true;
        }

        /// <summary>
        /// 删除审批关联
        /// </summary>
        /// <param name="workFlowId"></param>
        /// <param name="trans"></param>
        public void ModifyAuditDeleteAllInfo(int workFlowId, IDbTransaction trans)
        {
            List<Rb_Workflow_AuditRelevance_Extend> auditRelevanceList = GetAuditRelevanceList(workFlowId);

            #region 删除所有审核节点
            {
                IList<WhereHelper> whereHelpers = new List<WhereHelper>
                {
                    new WhereHelper()
                    {
                        FiledName = nameof(Rb_Workflow_AuditRelevance.WorkFlowId),
                        FiledValue = workFlowId,
                        OperatorEnum = OperatorEnum.Equal
                    }
                };
                workflow_AuditRelevanceRepository.Delete(whereHelpers, trans);
            }
            #endregion

            #region 删除审核人记录
            {
                #region 删除审核资源文件
                List<Rb_Workflow_Auditrecord_Extend> auditRecordList = GetAuditRecordInfoList(workFlowId);
                foreach (var item in auditRecordList)
                {
                    List<string> imgList = new List<string>();
                    if (!string.IsNullOrWhiteSpace(item.Image))
                    {
                        imgList = imgList.Union(JsonConvert.DeserializeObject<List<string>>(item.Image)).ToList();
                    }
                    //IOssService ossService = OssService.Get();
                    //ossService.DeleteFile(imgList);  // 删除图片
                }
                #endregion
                #region 删除审核人
                IList<WhereHelper> whereHelpers = new List<WhereHelper>
                {
                    new WhereHelper()
                    {
                        FiledName = nameof(Rb_Workflow_Auditrecord.WorkFlowId),
                        FiledValue = workFlowId,
                        OperatorEnum = OperatorEnum.Equal
                    }
                };
                workflow_AuditrecordRepository.Delete(whereHelpers, trans);
                #endregion

            }
            #endregion

            #region 删除指定成员关联信息
            foreach (var item in auditRelevanceList)
            {
                IList<WhereHelper> whereHelpers = new List<WhereHelper>
                {
                    new WhereHelper()
                    {
                        FiledName = nameof(Rb_Workflow_AuditUserRelevance.AuditRelevanceId),
                        FiledValue = item.Id,
                        OperatorEnum = OperatorEnum.Equal
                    }
                };
                workflow_AuditUserRelevanceRepository.Delete(whereHelpers, trans);
            }
            #endregion

            #region 删除抄送人
            {
                IList<WhereHelper> whereHelpers = new List<WhereHelper>
                {
                    new WhereHelper()
                    {
                        FiledName = nameof(Rb_Workflow_AuditRelevance.WorkFlowId),
                        FiledValue = workFlowId,
                        OperatorEnum = OperatorEnum.Equal
                    }
                };
                workflow_CopyToPeopleRepository.Delete(whereHelpers, trans);
            }
            #endregion
        }


        /// <summary>
        /// 获取审批关联
        /// </summary>
        /// <param name="WorkFlowId"></param>
        /// <returns></returns>
        public List<Rb_Workflow_AuditRelevance_Extend> GetAuditRelevanceList(int WorkFlowId)
        {
            var list = workflow_AuditRelevanceRepository.GetAuditRelevanceList(WorkFlowId);
            foreach (var item in list)
            {
                if (!string.IsNullOrEmpty(item.ToAuditId))
                {
                    var emList = employeeRepository.GetEmpInfoByIds(item.ToAuditId);
                    item.ToAuditName = emList != null ? string.Join(",", emList?.Select(x => x.EmName)) : "";
                }
            }
            return list;
        }

        /// <summary>
        /// 获取审批人关联
        /// </summary>
        /// <param name="ID"></param>
        /// <returns></returns>
        public List<Rb_Workflow_AuditUserRelevance_Extend> GetAuditUserRelevanceByAuditRelevanceId(int ID)
        {
            var list = workflow_AuditUserRelevanceRepository.GetAuditUserRelevanceByAuditRelevanceId(ID);
            foreach (var item in list)
            {
                if (item.EmployeeId > 0)
                {
                    var emList = employeeRepository.GetEntity(item.EmployeeId);
                    item.EmName = emList != null ? emList.EmName : "";
                    item.EmAccount = emList != null ? emList.EmAccount : "";
                    item.EmLoginMobile = emList != null ? emList.EmLoginMobile : "";
                }
            }
            return list;
        }

        /// <summary>
        /// 插入记录
        /// </summary>
        /// <param name="empIds"></param>
        /// <param name="wfId"></param>
        /// <param name="trans"></param>
        /// <param name="auditRelevance"></param>
        private void InsertBatcheAuditRecord(List<int> empIds, int wfId, System.Data.IDbTransaction trans, Rb_Workflow_AuditRelevance auditRelevance)
        {
            List<Rb_Workflow_Auditrecord> auditrecordList = new List<Rb_Workflow_Auditrecord>();
            var recordlist = GetAuditRecordInfoList(wfId);
            if (recordlist != null && recordlist.Count() > 0 && recordlist.Where(x => x.AuditId == auditRelevance.Id).ToList().Count() > 0)
            {
                workflow_AuditrecordRepository.DeleteBatch(recordlist.Where(x => x.AuditId == auditRelevance.Id).ToList(), trans);
            }
            foreach (var item in empIds)
            {
                Rb_Workflow_Auditrecord auditrecord = new Rb_Workflow_Auditrecord
                {
                    AuditEmId = item,
                    AuditId = auditRelevance.Id,
                    AuditStatus = WFRrocessStatus.NotAudit,
                    CreateBy = item,
                    CreateTime = DateTime.Now,
                    UpdateBy = item,
                    UpdateTime = DateTime.Now,
                    TemplateType = 0,
                    WorkFlowId = wfId
                };
                auditrecordList.Add(auditrecord);
            }
            workflow_AuditrecordRepository.InsertBatch(auditrecordList, trans);
            auditRelevance.ToAuditId = string.Join(",", empIds);
            workflow_AuditRelevanceRepository.Update(auditRelevance, trans);
        }

        /// <summary>
        /// 插入审批记录
        /// </summary>
        /// <param name="empIds"></param>
        /// <param name="wfId"></param>
        /// <param name="trans"></param>
        /// <param name="auditRelevance"></param>
        private void InsertBatcheAuditRecord2(List<int> empIds, int wfId, System.Data.IDbTransaction trans, Rb_Workflow_AuditRelevance auditRelevance)
        {
            List<Rb_Workflow_Auditrecord> auditrecordList = new List<Rb_Workflow_Auditrecord>();
            foreach (var item in empIds)
            {
                Rb_Workflow_Auditrecord auditrecord = new Rb_Workflow_Auditrecord
                {
                    AuditEmId = item,
                    AuditId = auditRelevance.Id,
                    AuditStatus = WFRrocessStatus.AuditThrough,
                    CreateBy = item,
                    CreateTime = DateTime.Now,
                    UpdateBy = item,
                    UpdateTime = DateTime.Now,
                    TemplateType = 0,
                    WorkFlowId = wfId
                };
                auditrecordList.Add(auditrecord);
            }
            workflow_AuditrecordRepository.InsertBatch(auditrecordList, trans);
            auditRelevance.AuditedId = string.Join(",", empIds);
            auditRelevance.ToAuditId = string.Join(",", empIds);
            auditRelevance.Stauts = WFRrocessStatus.AuditThrough;
            workflow_AuditRelevanceRepository.Update(auditRelevance, trans);
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="empIds"></param>
        /// <param name="AuditEmpId">当前审批人</param>
        /// <param name="Type">或签还是会签  1会签   2或签</param>
        /// <param name="wfId"></param>
        /// <param name="trans"></param>
        /// <param name="auditRelevance"></param>
        private void InsertBatcheAuditRecord3(List<int> empIds, int AuditEmpId, int Type, int wfId, System.Data.IDbTransaction trans, Rb_Workflow_AuditRelevance auditRelevance, List<int> oldAuditEmIds)
        {
            List<Rb_Workflow_Auditrecord> auditrecordList = new List<Rb_Workflow_Auditrecord>();
            var recordlist = GetAuditRecordInfoList(wfId);
            if (recordlist != null && recordlist.Count() > 0 && recordlist.Where(x => x.AuditId == auditRelevance.Id).ToList().Count() > 0)
            {
                workflow_AuditrecordRepository.DeleteBatch(recordlist.Where(x => x.AuditId == auditRelevance.Id).ToList(), trans);
            }

            List<int> NowAudit = new List<int>();
            if (!empIds.Contains(AuditEmpId))
            {
                empIds.ForEach(x =>
                {
                    if (oldAuditEmIds.Contains(x))
                    {
                        NowAudit.Add(x);
                    }
                });
            }
            foreach (var item in empIds)
            {
                Rb_Workflow_Auditrecord auditrecord = new Rb_Workflow_Auditrecord
                {
                    AuditEmId = item,
                    AuditId = auditRelevance.Id,
                    CreateBy = item,
                    CreateTime = DateTime.Now,
                    UpdateBy = item,
                    UpdateTime = DateTime.Now,
                    TemplateType = 0,
                    WorkFlowId = wfId
                };
                if (item == AuditEmpId || NowAudit.Contains(item))
                {
                    auditrecord.AuditStatus = WFRrocessStatus.AuditThrough;
                }
                else
                {
                    if (Type == 1)//会签
                    {
                        auditrecord.AuditStatus = WFRrocessStatus.NotAudit;
                    }
                    else
                    {//或签
                        auditrecord.AuditStatus = WFRrocessStatus.OtherHaveAudit;
                    }
                }
                auditrecordList.Add(auditrecord);
            }
            workflow_AuditrecordRepository.InsertBatch(auditrecordList, trans);
            auditRelevance.ToAuditId = string.Join(",", empIds);
            auditRelevance.AuditedId = AuditEmpId.ToString();
            if (Type == 2)
            {
                //或签
                auditRelevance.Stauts = WFRrocessStatus.AuditThrough;
            }
            workflow_AuditRelevanceRepository.Update(auditRelevance, trans);
        }

        /// <summary>
        /// 获取审批记录
        /// </summary>
        /// <param name="workFlowId"></param>
        /// <returns></returns>
        public List<Rb_Workflow_Auditrecord_Extend> GetAuditRecordInfoList(int workFlowId)
        {
            var list = workflow_AuditrecordRepository.GetAuditRecordList(workFlowId);
            foreach (var item in list)
            {
                var emList = employeeRepository.GetEntity(item.AuditEmId);
                item.AuditEmName = emList != null ? emList.EmName : "";
                item.AuditEmAccout = emList != null ? emList.EmAccount : "";
                item.AuditEmPhoto = emList != null ? emList.EmPhoto : "";
            }
            return list;
        }


        /// <summary>
        /// 获取申请人当前部门的选择层级主管，如果没有则继续找上级，如果有则返回
        /// </summary>
        /// <param name="currentDepartment"></param>
        /// <param name="departmentList"></param>
        /// <param name="upTargetTire"></param>
        /// <returns></returns>
        public RB_Department GetTargetByParentDepartment(RB_Department currentDepartment, List<RB_Department_Extend> departmentList, int upTargetTire)
        {
            if (currentDepartment.Tier.Value <= upTargetTire)
            {
                if (currentDepartment.DepartmentManager > 0)
                {
                    return currentDepartment;
                }
                else
                {
                    currentDepartment = departmentList.Where(t => t.DepartmentID == currentDepartment.ParentId).FirstOrDefault();
                    if ((currentDepartment != null && currentDepartment.DepartmentManager > 0) || (currentDepartment != null && (currentDepartment.ParentId == 0 || currentDepartment.ParentId == null)))
                    {
                        return currentDepartment;
                    }
                    else
                    {
                        if (currentDepartment != null)
                        {
                            return GetTargetDepartment(currentDepartment, departmentList, upTargetTire);
                        }
                        else
                        {
                            return null;
                        }
                    }
                }
            }
            else
            {
                currentDepartment = departmentList.Where(t => t.DepartmentID == currentDepartment.ParentId).FirstOrDefault();
                if (currentDepartment != null)
                {
                    return GetTargetDepartment(currentDepartment, departmentList, upTargetTire);
                }
                else
                {
                    return null;
                }
            }
        }

        /// <summary>
        /// 获取部门信息
        /// </summary>
        /// <param name="currentDepartment">审批人所在当前部门</param>
        /// <param name="departmentList">申请人所在全部部门</param>
        /// <param name="upTargetTire">审核人所在层级</param>
        /// <returns></returns>
        public RB_Department GetTargetDepartment(RB_Department currentDepartment, List<RB_Department_Extend> departmentList, int upTargetTire)
        {
            if (currentDepartment.Tier.Value == upTargetTire)
            {
                return currentDepartment;
            }
            else
            {
                currentDepartment = departmentList.Where(t => t.DepartmentID == currentDepartment.ParentId).FirstOrDefault();
                if (currentDepartment != null)
                {
                    return GetTargetDepartment(currentDepartment, departmentList, upTargetTire);
                }
                else
                {
                    return null;
                }
            }
        }

        /// <summary>
        /// 获取转交人
        /// </summary>
        /// <param name="emList"></param>
        /// <returns></returns>
        public List<int> GetNewEmList(List<int> emList)
        {
            List<int> newList = new List<int>();
            //判断是否有转交人
            if (emList != null && emList.Count > 0)
            {
                foreach (var item in emList)
                {
                    if (item > 0)
                    {
                        var emModel = GetAuditEmp(Convert.ToInt32(item), DateTime.Now.ToString(), DelegateContentEnum.PropertyAudit);
                        if (emModel != null && emModel.EmployeeId != item)
                        {
                            newList.Add(emModel.EmployeeId);
                        }
                        else if (emModel != null && emModel.EmployeeId == item)
                        {
                            newList.Add(item);
                        }
                        else
                        {
                            break;
                        }
                    }
                    else
                    {
                        break;
                    }
                }
                return newList;
            }
            else
            {
                return null;
            }
        }

        /// <summary>
        /// 获取审批对象
        /// </summary>
        /// <param name="nodeAuditEmpId">节点审核员工id</param>
        /// <param name="dateTime">审核时间</param>
        /// <param name="delegateContent">审核内容</param>
        /// <param name="auditDelegate">审批委托</param>
        /// <returns></returns>
        public RB_Employee GetAuditEmp(int nodeAuditEmpId, string dateTime, DelegateContentEnum delegateContent, RB_Audit_Delegate auditDelegate = null)
        {
            RB_Audit_Delegate childAuditDelegate = audit_DelegateRepository.GetDelegateByInitiatorEmpId(nodeAuditEmpId, dateTime, delegateContent);
            if (childAuditDelegate != null)
            {
                return GetAuditEmp(childAuditDelegate.ReciveEmpId, dateTime, delegateContent, childAuditDelegate);
            }
            else
            {
                int empId = nodeAuditEmpId;
                if (auditDelegate != null)
                {
                    empId = auditDelegate.ReciveEmpId;
                }
                return new Rb_employeeRepository().GetEntity(empId);
            }
        }


        /// <summary>
        /// 审批通过
        /// </summary>
        /// <param name="model"></param>
        /// <param name="imageList"></param>
        /// <param name="auditDescription"></param>
        /// <param name="SignImage"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        public ApiResult AuditPass(RB_Property_UseReceive usemodel, List<string> imageList, string auditDescription, string SignImage, UserInfo userInfo)
        {
            int empId = userInfo.EmployeeId;
            int WorkFlowId = usemodel.Id;
            string Description = auditDescription;
            int RecordId = 0;
            bool IsSign = false;

            var trans = workflow_AuditRelevanceRepository.DbTransaction;
            try
            {
                var AuditAccountList = new List<EmAccoutIdModel>();
                var CopyAccountList = new List<EmAccoutIdModel>();
                // 审核记录
                var aurList = workflow_AuditrecordRepository.GetAuditRecordList(WorkFlowId);
                string ImageStr = "";
                //图片处理
                if (imageList.Any())
                {
                    List<string> imgList = new List<string>();
                    ImageOperation(imageList, out imgList);
                    ImageStr = JsonConvert.SerializeObject(imgList);
                }
                //首先更改 审核关联 
                List<Rb_Workflow_AuditRelevance_Extend> arList = GetAuditRelevanceList(WorkFlowId);
                //找出当前审核
                int Notcount = arList.Where(x => x.Stauts == WFRrocessStatus.AuditNotThrough || x.Stauts == WFRrocessStatus.Rejected).Count();
                if (Notcount > 0)
                {
                    workflow_AuditRelevanceRepository.DBSession.Commit();
                    return ApiResult.Failed("该申请单已被拒绝");
                }
                var ToAuditFlow = arList.Where(x => x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort).ToList();
                if (ToAuditFlow.Count <= 0)
                {
                    workflow_AuditRelevanceRepository.DBSession.Commit();
                    return ApiResult.Failed("该申请单审核已经完结");
                }
                
                if (ToAuditFlow.Count == 1)//目前审核为最后一步  
                {
                    bool financeFlag = false;
                    var model = ToAuditFlow?.FirstOrDefault();
                    // 验证签名
                    if (model.SpecialNode != WFSpecialNodeEnum.Normal)
                    {
                        if (string.IsNullOrEmpty(SignImage))
                        {
                            return ApiResult.Failed("请传递签名信息");
                        }
                        if (model.SpecialNode == WFSpecialNodeEnum.Pay)
                        {
                            IsSign = true;
                        }
                    }
                    else {
                        if (usemodel.CreateBy == userInfo.EmployeeId)
                        {
                            return ApiResult.Failed("单据操作人不能审核，请转交审核");
                        }
                        SignImage = "";
                    }

                    var RecordList = aurList.Where(x => x.AuditId == model.Id).ToList();
                    if (model.AuditWay == WFTAuditWayEnum.Countersign)
                    {//会签  所有人必须审核完该流程才算完成
                        var amodel = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId == empId).FirstOrDefault();
                        if (amodel == null)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("AuditTemporary：74");
                            return new ApiResult { resultCode = (int)ResultCode.NoPeople, message = "尚未匹配到审核相关信息，请联系管理员", data = new { AuditId = model.Id } };
                        }
                        RecordId = amodel.Id;
                        #region 更新审核记录表状态
                        IDictionary<string, object> fileds = new Dictionary<string, object>
                        {
                            { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.AuditThrough },
                            { nameof(Rb_Workflow_Auditrecord.Description),Description}
                            ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                            ,{ nameof(Rb_Workflow_Auditrecord.SignImage),SignImage}
                            ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                        };
                        IList<WhereHelper> whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                FiledValue = amodel.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败1，单号：" + WorkFlowId);
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion
                        int AuditCount = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId != empId).Count();
                        if (AuditCount <= 0)//表示最后一个人就是子集审核   申请单 通过
                        {
                            //同时  修改  审核记录状态 审核流程 
                            #region 更新审核关联表状态
                            model.Stauts = WFRrocessStatus.AuditThrough;
                            if (!string.IsNullOrWhiteSpace(model.AuditedId))
                            {
                                model.AuditedId += "," + empId;
                            }
                            else
                            {
                                model.AuditedId = empId.ToString();
                            }
                            fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_AuditRelevance.Stauts), model.Stauts },
                                { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                            };
                            whereHelpers = new List<WhereHelper>
                            {
                                new WhereHelper()
                                {
                                    FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                                    FiledValue = model.Id,
                                    OperatorEnum = OperatorEnum.Equal
                                }
                            };
                            if (!workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans))
                            {
                                workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败2，单号：" + WorkFlowId);
                                return ApiResult.Failed("审核失败");
                            }
                            #endregion
                            financeFlag = true;
                        }
                        else
                        {
                            #region 更新审核关联表状态
                            model.Stauts = WFRrocessStatus.AuditThrough;
                            if (!string.IsNullOrWhiteSpace(model.AuditedId))
                            {
                                model.AuditedId += "," + empId;
                            }
                            else
                            {
                                model.AuditedId = empId.ToString();
                            }
                            fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                            };
                            whereHelpers = new List<WhereHelper>
                            {
                                new WhereHelper()
                                {
                                    FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                                    FiledValue = model.Id,
                                    OperatorEnum = OperatorEnum.Equal
                                }
                            };
                            if (!workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans))
                            {
                                workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败3，单号：" + WorkFlowId);
                                return ApiResult.Failed("审核失败");
                            }
                            #endregion
                        }
                    }
                    else if (model.AuditWay == WFTAuditWayEnum.OrSign)
                    {
                        var amodel = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId == empId).FirstOrDefault();
                        if (amodel == null)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("AuditTemporary：73");
                            return new ApiResult { resultCode = (int)ResultCode.NoPeople, message = "尚未匹配到审核相关信息，请联系管理员", data = new { AuditId = model.Id } };
                        }
                        RecordId = amodel.Id;
                        //同时  修改  审核记录状态 审核流程 
                        #region 更新审核记录表状态
                        model.Stauts = WFRrocessStatus.AuditThrough;
                        if (!string.IsNullOrWhiteSpace(model.AuditedId))
                        {
                            model.AuditedId += "," + empId;
                        }
                        else
                        {
                            model.AuditedId = empId.ToString();
                        }
                        IDictionary<string, object> fileds = new Dictionary<string, object>
                        {
                            { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.AuditThrough },
                            { nameof(Rb_Workflow_Auditrecord.Description),Description}
                            ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                            ,{ nameof(Rb_Workflow_Auditrecord.SignImage),SignImage}
                            ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                        };
                        IList<WhereHelper> whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                FiledValue = amodel.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败4，单号：" + WorkFlowId);
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion
                        #region 更新审核关联表状态
                        fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_AuditRelevance.Stauts), model.Stauts },
                                { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                            };
                        whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                                FiledValue = model.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败5，单号：" + WorkFlowId);
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion
                        #region 更新其他的审核记录
                        var list = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId != empId).ToList();
                        int AuditCount = list.Count();
                        if (AuditCount > 0)//表示最后一个人就是子集审核   申请单 通过
                        {
                            foreach (var item in list)
                            {
                                fileds = new Dictionary<string, object>
                                    {
                                        { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.OtherHaveAudit },
                                        { nameof(Rb_Workflow_Auditrecord.Description),Description}
                                        ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                                        ,{ nameof(Rb_Workflow_Auditrecord.SignImage),SignImage}
                                        ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                                    };
                                whereHelpers = new List<WhereHelper>
                                {
                                    new WhereHelper()
                                    {
                                        FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                        FiledValue = item.Id,
                                        OperatorEnum = OperatorEnum.Equal
                                    }
                                };
                                if (!workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans))
                                {
                                    workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败6，单号：" + WorkFlowId);
                                    return ApiResult.Failed("审核失败");
                                }
                            }
                        }
                        #endregion

                        financeFlag = true;
                    }
                    else
                    {
                        var amodel = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId == empId).FirstOrDefault();
                        if (amodel == null)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败61，单号：" + WorkFlowId);
                            return new ApiResult { resultCode = (int)ResultCode.NoPeople, message = "尚未匹配到审核相关信息，请联系管理员", data = new { AuditId = model.Id } };
                        }
                        RecordId = amodel.Id;
                        var list = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId != empId).ToList();
                        int AuditCount = list.Count();
                        if (AuditCount > 0)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败61下面,单号：" + WorkFlowId);
                            return ApiResult.Failed("流程配置出错啦！非会签，或签 都只能有一个审核人");
                        }
                        //同时  修改  审核记录状态 审核流程 
                        #region 更新审核记录表状态
                        model.Stauts = WFRrocessStatus.AuditThrough;
                        if (!string.IsNullOrWhiteSpace(model.AuditedId))
                        {
                            model.AuditedId += "," + empId;
                        }
                        else
                        {
                            model.AuditedId = empId.ToString();
                        }
                        IDictionary<string, object> fileds = new Dictionary<string, object>
                        {
                            { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.AuditThrough },
                            { nameof(Rb_Workflow_Auditrecord.Description),Description}
                            ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                            ,{ nameof(Rb_Workflow_Auditrecord.SignImage),SignImage}
                            ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                        };
                        IList<WhereHelper> whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                FiledValue = amodel.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败7，单号：" + WorkFlowId);
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion
                        #region 更新审核关联表状态
                        fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_AuditRelevance.Stauts), model.Stauts },
                                { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                            };
                        whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                                FiledValue = model.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败8，单号：" + WorkFlowId);
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion

                        financeFlag = true;
                    }

                    if (financeFlag)
                    {
                        //流程最终的Ok  
                        Dictionary<string, object> usefiles = new Dictionary<string, object>() {
                            { nameof(RB_Property_UseReceive.AuditStatus),OrderStateEnum.Complete}
                        };
                        List<WhereHelper> usewheres = new List<WhereHelper>() {
                            new WhereHelper(){
                                 FiledName=nameof(RB_Property_UseReceive.Id),
                                  FiledValue=usemodel.Id,
                                   OperatorEnum=OperatorEnum.Equal
                            }
                        };
                        useReceiveRepository.Update(usefiles, usewheres, trans);
                        //更新资产使用状态
                        var list = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = usemodel.RB_Group_Id, ReceiveId = usemodel.Id });
                        foreach (var item in list)
                        {
                            PropertyStatusEnum propertyStatus = PropertyStatusEnum.Receive;
                            switch (usemodel.Source) {
                                case PropertySourceEnum.Receive:
                                    propertyStatus = PropertyStatusEnum.Receive;
                                    break;
                                case PropertySourceEnum.CancellingStocks:
                                    propertyStatus = PropertyStatusEnum.Leisure;
                                    break;
                                case PropertySourceEnum.Borrow:
                                    propertyStatus = PropertyStatusEnum.Borrow;
                                    break;
                                case PropertySourceEnum.GiveBack:
                                    propertyStatus = PropertyStatusEnum.Leisure;
                                    break;
                                case PropertySourceEnum.Allot:
                                    propertyStatus = PropertyStatusEnum.Leisure;
                                    break;
                                case PropertySourceEnum.Dispose:
                                    propertyStatus = PropertyStatusEnum.Dispose;
                                    break;
                            }

                            //修改领用人
                            Dictionary<string, object> pflies = new Dictionary<string, object>();
                            //维修 不需要修改资产状态
                            if (usemodel.Source != PropertySourceEnum.Maintain)
                            {
                                pflies.Add(nameof(RB_Property_Info.PropertyStatus), propertyStatus);
                            }
                            if (usemodel.Source == PropertySourceEnum.Receive)
                            {
                                pflies.Add(nameof(RB_Property_Info.EmployeeId), usemodel.EmployeeId ?? 0);
                                pflies.Add(nameof(RB_Property_Info.GetTime), usemodel.Time);
                            }
                            else if (usemodel.Source == PropertySourceEnum.CancellingStocks) {
                                pflies.Add(nameof(RB_Property_Info.BackTime), usemodel.BackTime);
                                pflies.Add(nameof(RB_Property_Info.EmployeeId), 0);
                                pflies.Add(nameof(RB_Property_Info.GetTime), null);
                            }
                            else if (usemodel.Source == PropertySourceEnum.Borrow)
                            {
                                pflies.Add(nameof(RB_Property_Info.EmployeeId), usemodel.EmployeeId ?? 0);
                                pflies.Add(nameof(RB_Property_Info.GetTime), usemodel.Time);
                                pflies.Add(nameof(RB_Property_Info.BackTime), usemodel.BackTime);
                            }
                            else if (usemodel.Source == PropertySourceEnum.GiveBack)
                            {
                                pflies.Add(nameof(RB_Property_Info.BackTime), usemodel.BackTime);
                                pflies.Add(nameof(RB_Property_Info.EmployeeId), 0);
                                pflies.Add(nameof(RB_Property_Info.GetTime), null);
                            }
                            else if (usemodel.Source == PropertySourceEnum.Allot)
                            {
                                pflies.Add(nameof(RB_Property_Info.BranchId), usemodel.InBranchId);
                            }
                            else if (usemodel.Source == PropertySourceEnum.Maintain)
                            {
                                //pflies.Add(nameof(RB_Property_Info.UseStatus), (int)PropertyUseStateEnum.Repair);
                            }
                            else if (usemodel.Source == PropertySourceEnum.Dispose)
                            {

                            }
                            List<WhereHelper> pwheres = new List<WhereHelper>() {
                                new WhereHelper(){
                                 FiledName=nameof(RB_Property_Info.Id),
                                  FiledValue=item.PropertyId
                                }
                            };
                            property_InfoRepository.Update(pflies, pwheres, trans);
                            //日志
                            var emmodel = CacheManager.User.UserReidsCache.GetEmployee(usemodel.EmployeeId);
                            string ContentMsg = "";
                            string TypeName = "";
                            if (usemodel.Source == PropertySourceEnum.Receive)
                            {
                                ContentMsg = "领用人信息：" + emmodel?.EmName;
                                TypeName = "领用";
                            }
                            else if (usemodel.Source == PropertySourceEnum.CancellingStocks) {
                                ContentMsg = "领用退库";
                                TypeName = "退库";
                            }
                            else if (usemodel.Source == PropertySourceEnum.Borrow)
                            {
                                ContentMsg = "借用人信息：" + emmodel?.EmName;
                                TypeName = "借用";
                            }
                            else if (usemodel.Source == PropertySourceEnum.GiveBack)
                            {
                                ContentMsg = "借用归还";
                                TypeName = "归还";
                            }
                            else if (usemodel.Source == PropertySourceEnum.Allot)
                            {
                                ContentMsg = "调入 " + CacheManager.User.BranchReidsCache.GetBranch(usemodel.InBranchId ?? 0)?.BName ?? "未查到";
                                TypeName = "调拨";
                            }
                            else if (usemodel.Source == PropertySourceEnum.Maintain)
                            {
                                ContentMsg = "维修金额：" + (item.MendMoney ?? 0);
                                TypeName = "维修";
                            }
                            else if (usemodel.Source == PropertySourceEnum.Dispose)
                            {
                                ContentMsg = "处理类型："+ usemodel.DisposeType.GetEnumName();
                                TypeName = "处置";
                            }
                            property_LogRepository.Insert(new RB_Property_Log()
                            {
                                PropertyId = item.PropertyId,
                                Content = ContentMsg,
                                CreateBy = userInfo.EmployeeId,
                                CreateDate = DateTime.Now,
                                Id = 0,
                                RB_Branch_Id = userInfo.RB_Branch_id,
                                RB_Group_Id = userInfo.RB_Group_id,
                                Status = 0,
                                TypeName = TypeName
                            }, trans);

                            if (model.SpecialNode != WFSpecialNodeEnum.Normal) {
                                string Content = "审核人签字";
                                if (model.SpecialNode == WFSpecialNodeEnum.In)
                                {
                                    Content = "审核人签字";
                                }
                                else if (model.SpecialNode == WFSpecialNodeEnum.Pay)
                                {
                                    Content = "使用人签字";
                                }
                                //有签字
                                property_LogRepository.Insert(new RB_Property_Log()
                                {
                                    PropertyId = item.PropertyId,
                                    Content = Content,
                                    CreateBy = userInfo.EmployeeId,
                                    CreateDate = DateTime.Now,
                                    Id = 0,
                                    RB_Branch_Id = userInfo.RB_Branch_id,
                                    RB_Group_Id = userInfo.RB_Group_id,
                                    Status = 0,
                                    TypeName = "签字",
                                    IsSignature = 1,
                                    RecordId = RecordId
                                }, trans);
                            }
                        }
                       
                    }
                    //更新抄送人状态
                    var CopyToPeopleList = GetCopyToPeopleList(WorkFlowId);
                    foreach (var item in CopyToPeopleList)
                    {
                        item.Stauts = WFRrocessStatus.AuditThrough;
                    }
                    CopyAccountList = CopyToPeopleList.Select(x => new EmAccoutIdModel { EmAccount = x.EmAccount, EmployeeId = x.EmployeeId ?? 0 }).Distinct().ToList();
                    if (!workflow_CopyToPeopleRepository.UpdateBatch(CopyToPeopleList))
                    {
                        workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败11，单号：" + WorkFlowId);
                        return ApiResult.Failed("审核失败");
                    }
                }
                else//同时创建下一步审核  复制审核人到审核关联表   创建审核记录表
                {
                    var model = ToAuditFlow?.FirstOrDefault();
                    // 验证签名
                    if (model.SpecialNode != WFSpecialNodeEnum.Normal)
                    {
                        if (string.IsNullOrEmpty(SignImage))
                        {
                            return ApiResult.Failed("请传递签名信息");
                        }
                        if (model.SpecialNode == WFSpecialNodeEnum.Pay)
                        {
                            IsSign = true;
                        }
                    }
                    else
                    {
                        if (usemodel.CreateBy == userInfo.EmployeeId)
                        {
                            return ApiResult.Failed("单据操作人不能审核，请转交审核");
                        }
                        SignImage = "";
                    }

                    var RecordList = aurList.Where(x => x.AuditId == model.Id).ToList();
                    if (model.AuditWay == WFTAuditWayEnum.Countersign)
                    {//会签  所有人必须审核完该流程才算完成
                        var amodel = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId == empId).FirstOrDefault();
                        if (RecordList.Count > 1)
                        {
                            if (amodel == null)
                            {
                                workflow_AuditrecordRepository.DBSession.Commit();
                                return new ApiResult() { resultCode = (int)ResultCode.NoPeople, message = "尚未匹配到审核相关信息，请联系管理员", data = new { AuditId = model.Id } };
                            }
                        }
                        else if (RecordList.Count == 1 && RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId == empId).Count() == 0)
                        {
                            workflow_AuditrecordRepository.DBSession.Commit();
                            return new ApiResult() { resultCode = (int)ResultCode.NoPeople, message = "尚未匹配到审核相关信息，请联系管理员", data = new { AuditId = model.Id } };
                        }
                        RecordId = amodel?.Id ?? 0;
                        //审核记录状态
                        #region 更新审核记录表状态
                        IDictionary<string, object> fileds = new Dictionary<string, object>
                        {
                            { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.AuditThrough },
                            { nameof(Rb_Workflow_Auditrecord.Description),Description}
                            ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                            ,{ nameof(Rb_Workflow_Auditrecord.SignImage),SignImage}
                            ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                        };
                        IList<WhereHelper> whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                FiledValue = amodel.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback();
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion
                        int AuditCount = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId != empId).Count();
                        if (AuditCount <= 0)//表示最后一个人就是子集审核   申请单 通过
                        {
                            //同时  修改  审核流程 
                            model.Stauts = WFRrocessStatus.AuditThrough;
                            if (!string.IsNullOrWhiteSpace(model.AuditedId))
                            {
                                model.AuditedId += "," + empId;
                            }
                            else
                            {
                                model.AuditedId = empId.ToString();
                            }
                            #region 更新审核关联表状态
                            fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_AuditRelevance.Stauts), model.Stauts },
                                { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                            };
                            whereHelpers = new List<WhereHelper>
                            {
                                new WhereHelper()
                                {
                                    FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                                    FiledValue = model.Id,
                                    OperatorEnum = OperatorEnum.Equal
                                }
                            };
                            if (!workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans))
                            {
                                workflow_AuditRelevanceRepository.DBSession.Rollback();
                                return ApiResult.Failed("审核失败");
                            }
                            #endregion
                            //赋值下一步到审核记录中  并更新这一步的待审核人
                            var modelNext = ToAuditFlow[1];

                            var tempModel = workflow_TemplateRepository.GetEntity(usemodel.TempleteId ?? 0).RefMapperTo<Rb_Workflow_Template_Extend>();
                            List<int> ApplyForList = new List<int>();
                            if (modelNext.SpecialNode == WFSpecialNodeEnum.Pay) {
                                if (usemodel.Source == PropertySourceEnum.Receive || usemodel.Source == PropertySourceEnum.Borrow)
                                {
                                    ApplyForList = new List<int>() { usemodel.EmployeeId ?? 0 };
                                }
                                else if (usemodel.Source == PropertySourceEnum.CancellingStocks || usemodel.Source == PropertySourceEnum.GiveBack)
                                {
                                    var urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = usemodel.RB_Group_Id, ReceiveId = usemodel.Id });
                                    //查询出所有的资产
                                    if (urlist.Any())
                                    {
                                        var plist = property_InfoRepository.GetList(new RB_Property_Info_Extend() { RB_Group_Id = usemodel.RB_Group_Id, PropertyIdStr = string.Join(",", urlist.Select(x => x.PropertyId)) });
                                        ApplyForList = plist.Select(x => x.EmployeeId ?? 0).ToList();
                                    }
                                }
                            }
                            var flag = InsertAuditRelevanceNext(tempModel, modelNext, usemodel.CreateBy ?? 0, userInfo.EmployeeId, usemodel.Id, ApplyForList, trans, out AuditAccountList);
                            if (flag == false)
                            {
                                workflow_AuditRelevanceRepository.DBSession.Rollback();
                                return ApiResult.Failed();
                            }
                        }
                        else
                        {
                            //同时  修改  审核流程 
                            if (!string.IsNullOrWhiteSpace(model.AuditedId))
                            {
                                model.AuditedId += "," + empId;
                            }
                            else
                            {
                                model.AuditedId = empId.ToString();
                            }
                            #region 更新审核关联表状态
                            fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                            };
                            whereHelpers = new List<WhereHelper>
                            {
                                new WhereHelper()
                                {
                                    FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                                    FiledValue = model.Id,
                                    OperatorEnum = OperatorEnum.Equal
                                }
                            };
                            if (!workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans))
                            {
                                workflow_AuditRelevanceRepository.DBSession.Rollback();
                                return ApiResult.Failed("审核失败");
                            }
                            #endregion
                        }
                    }
                    else if (model.AuditWay == WFTAuditWayEnum.OrSign)
                    {
                        var amodel = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId == empId).FirstOrDefault();
                        if (amodel == null)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback();
                            return new ApiResult { resultCode = (int)ResultCode.NoPeople, message = "尚未匹配到审核相关信息，请联系管理员", data = new { AuditId = model.Id } };
                        }
                        RecordId = amodel.Id;
                        //同时  修改  审核记录状态 审核流程 
                        model.Stauts = WFRrocessStatus.AuditThrough;
                        if (!string.IsNullOrWhiteSpace(model.AuditedId))
                        {
                            model.AuditedId += "," + empId;
                        }
                        else
                        {
                            model.AuditedId = empId.ToString();
                        }
                        #region 更新审核记录表状态
                        IDictionary<string, object> fileds = new Dictionary<string, object>
                        {
                            { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.AuditThrough },
                            { nameof(Rb_Workflow_Auditrecord.Description),Description}
                            ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                            ,{ nameof(Rb_Workflow_Auditrecord.SignImage),SignImage}
                            ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                        };
                        IList<WhereHelper> whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                FiledValue = amodel.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback();
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion
                        #region 更新审核关联表状态
                        fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_AuditRelevance.Stauts), model.Stauts },
                                { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                            };
                        whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                                FiledValue = model.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback();
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion

                        var list = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId != empId).ToList();
                        int AuditCount = list.Count();
                        if (AuditCount > 0)//表示最后一个人就是子集审核   申请单 通过
                        {
                            foreach (var item in list)
                            {
                                fileds = new Dictionary<string, object>
                                {
                                   { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.OtherHaveAudit },
                                   { nameof(Rb_Workflow_Auditrecord.Description),Description}
                                    ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                                    ,{ nameof(Rb_Workflow_Auditrecord.SignImage),SignImage}
                                    ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                                };
                                whereHelpers = new List<WhereHelper>
                                {
                                    new WhereHelper()
                                    {
                                        FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                        FiledValue = item.Id,
                                        OperatorEnum = OperatorEnum.Equal
                                    }
                                };
                                if (!workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans))
                                {
                                    workflow_AuditRelevanceRepository.DBSession.Rollback();
                                    return ApiResult.Failed("审核失败");
                                }
                            }
                        }
                        //赋值下一步到审核记录中  并更新这一步的待审核人
                        var modelNext = ToAuditFlow[1];

                        var tempModel = workflow_TemplateRepository.GetEntity(usemodel.TempleteId ?? 0).RefMapperTo<Rb_Workflow_Template_Extend>();
                        List<int> ApplyForList = new List<int>();
                        if (modelNext.SpecialNode == WFSpecialNodeEnum.Pay)
                        {
                            if (usemodel.Source == PropertySourceEnum.Receive || usemodel.Source == PropertySourceEnum.Borrow)
                            {
                                ApplyForList = new List<int>() { usemodel.EmployeeId ?? 0 };
                            }
                            else if (usemodel.Source == PropertySourceEnum.CancellingStocks || usemodel.Source == PropertySourceEnum.GiveBack)
                            {
                                var urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = usemodel.RB_Group_Id, ReceiveId = usemodel.Id });
                                //查询出所有的资产
                                if (urlist.Any())
                                {
                                    var plist = property_InfoRepository.GetList(new RB_Property_Info_Extend() { RB_Group_Id = usemodel.RB_Group_Id, PropertyIdStr = string.Join(",", urlist.Select(x => x.PropertyId)) });
                                    ApplyForList = plist.Select(x => x.EmployeeId ?? 0).ToList();
                                }
                            }
                        }
                        var flag = InsertAuditRelevanceNext(tempModel, modelNext, usemodel.CreateBy ?? 0, userInfo.EmployeeId, usemodel.Id, ApplyForList, trans, out AuditAccountList);
                        if (flag == false)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback();
                            return new ApiResult { resultCode = (int)ResultCode.NoPeople, message = "审核流程不完整无法审核，请联系相关负责人", data = new { AuditId = modelNext.Id } };
                        }
                    }
                    else
                    {
                        var amodel = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId == empId).FirstOrDefault();
                        if (amodel == null)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback();
                            return new ApiResult { resultCode = (int)ResultCode.NoPeople, message = "尚未匹配到审核相关信息，请联系管理员", data = new { AuditId = model.Id } };
                        }
                        RecordId = amodel.Id;
                        var list = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId != empId).ToList();
                        int AuditCount = list.Count();
                        if (AuditCount > 0)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("AuditTemporary：81");
                            return ApiResult.Failed("流程配置出错啦！非会签、或签 都只能有一个审核人");
                        }
                        //同时  修改  审核记录状态 审核流程 
                        model.Stauts = WFRrocessStatus.AuditThrough;
                        if (!string.IsNullOrWhiteSpace(model.AuditedId))
                        {
                            model.AuditedId += "," + empId;
                        }
                        else
                        {
                            model.AuditedId = empId.ToString();
                        }
                        #region 更新审核记录表状态
                        IDictionary<string, object> fileds = new Dictionary<string, object>
                        {
                            { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.AuditThrough },
                            { nameof(Rb_Workflow_Auditrecord.Description),Description}
                            ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                            ,{ nameof(Rb_Workflow_Auditrecord.SignImage),SignImage}
                            ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                        };
                        IList<WhereHelper> whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                FiledValue = amodel.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败20，单号：" + WorkFlowId);
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion
                        #region 更新审核关联表状态
                        fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_AuditRelevance.Stauts), model.Stauts },
                                { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                            };
                        whereHelpers = new List<WhereHelper>
                        {
                            new WhereHelper()
                            {
                                FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                                FiledValue = model.Id,
                                OperatorEnum = OperatorEnum.Equal
                            }
                        };
                        if (!workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans))
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败21，单号：" + WorkFlowId);
                            return ApiResult.Failed("审核失败");
                        }
                        #endregion
                        //赋值下一步到审核记录中  并更新这一步的待审核人
                        var modelNext = ToAuditFlow[1];

                        var tempModel = workflow_TemplateRepository.GetEntity(usemodel.TempleteId ?? 0).RefMapperTo<Rb_Workflow_Template_Extend>();
                        List<int> ApplyForList = new List<int>();
                        if (modelNext.SpecialNode == WFSpecialNodeEnum.Pay)
                        {
                            if (usemodel.Source == PropertySourceEnum.Receive || usemodel.Source == PropertySourceEnum.Borrow)
                            {
                                ApplyForList = new List<int>() { usemodel.EmployeeId ?? 0 };
                            }
                            else if (usemodel.Source == PropertySourceEnum.CancellingStocks || usemodel.Source == PropertySourceEnum.GiveBack)
                            {
                                var urlist = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = usemodel.RB_Group_Id, ReceiveId = usemodel.Id });
                                //查询出所有的资产
                                if (urlist.Any())
                                {
                                    var plist = property_InfoRepository.GetList(new RB_Property_Info_Extend() { RB_Group_Id = usemodel.RB_Group_Id, PropertyIdStr = string.Join(",", urlist.Select(x => x.PropertyId)) });
                                    ApplyForList = plist.Select(x => x.EmployeeId ?? 0).ToList();
                                }
                            }
                        }
                        var flag = InsertAuditRelevanceNext(tempModel, modelNext, usemodel.CreateBy ?? 0, userInfo.EmployeeId, usemodel.Id, ApplyForList, trans, out AuditAccountList);
                        if (flag == false)
                        {
                            workflow_AuditRelevanceRepository.DBSession.Rollback("Audit审核失败22，单号：" + WorkFlowId);
                            return new ApiResult { resultCode = (int)ResultCode.NoPeople, message = "未匹配到相关审核人", data = new { AuditId = modelNext.Id } };
                        }
                    }
                    if (model.SpecialNode != WFSpecialNodeEnum.Normal) {
                        //更新资产签字日志
                        var list = useRelevanceRepository.GetList(new RB_Property_UseRelevance_Extend() { RB_Group_Id = usemodel.RB_Group_Id, ReceiveId = usemodel.Id });
                        string Content = "审核人签字";
                        if (model.SpecialNode == WFSpecialNodeEnum.In)
                        {
                            Content = "审核人签字";
                        }
                        else if (model.SpecialNode == WFSpecialNodeEnum.Pay) {
                            Content = "使用人签字";
                        }
                        foreach (var item in list)
                        {
                            //有签字
                            property_LogRepository.Insert(new RB_Property_Log()
                            {
                                PropertyId = item.PropertyId,
                                Content = Content,
                                CreateBy = userInfo.EmployeeId,
                                CreateDate = DateTime.Now,
                                Id = 0,
                                RB_Branch_Id = userInfo.RB_Branch_id,
                                RB_Group_Id = userInfo.RB_Group_id,
                                Status = 0,
                                TypeName = "签字",
                                IsSignature = 1,
                                RecordId = RecordId
                            }, trans);
                        }
                    }
                }
                //发送推送信息                
                string EmAccout = "";
                int EmId = 0;
                var CreateModel = employeeRepository.GetEntity(usemodel.CreateBy.Value);
                if (CreateModel != null)
                {
                    EmAccout = CreateModel.EmAccount;
                    EmId = CreateModel.EmployeeId;
                }
                List<EmAccoutIdModel> EmNameList = new List<EmAccoutIdModel>() { new EmAccoutIdModel { EmAccount = EmAccout, EmployeeId = EmId } };
                
                if (ToAuditFlow.Count == 1)
                {//审批完成
                    PushAuditMessage(EmNameList, WorkFlowId, $@"您的资产申请已完成！", "资产审批完成", empId, SysTemPushTypeEnum.PropertyAudit);
                    //抄送人通知
                    PushAuditMessage(CopyAccountList, WorkFlowId, $@"有审核完成的资产抄送通知！", "资产抄送通知", empId, SysTemPushTypeEnum.PropertyAudit);
                    //所有审核人
                    //AuditAccountList = aurList.Where(x => x.AuditStatus == WFRrocessStatus.AuditThrough && x.AuditEmId != empId).Select(x => new EmAccoutIdModel() { EmAccount = x.AuditEmAccout, EmployeeId = x.AuditEmId ?? 0 }).Distinct().ToList();
                }
                else
                {
                    //审批通过
                    PushAuditMessage(AuditAccountList, WorkFlowId, $@"你有待审核的资产消息！", "资产审核通知", empId, SysTemPushTypeEnum.PropertyAudit);
                }
               
                //日志
                RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                {
                    LogId = 0,
                    RB_Branch_Id = userInfo.RB_Branch_id,
                    RB_Group_Id = userInfo.RB_Group_id,
                    UpdateBy = empId,
                    UpdateDate = System.DateTime.Now,
                    ResourceId = WorkFlowId,
                    Content = "审批通过",
                    Type = 1
                };
                workfolw_Change_LogRepository.Insert(logModel, trans);

                workflow_AuditRelevanceRepository.DBSession.Commit();
                string rmsg = "审核成功";
                if (IsSign) {
                    rmsg = "签名成功";
                }
                return ApiResult.Success(rmsg);
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "审核失败:Audit");
                workflow_AuditRelevanceRepository.DBSession.Rollback("审核失败26，单号：" + WorkFlowId);
                return ApiResult.Failed("Audit审核失败");
            }
        }

        /// <summary>
        /// 审批驳回
        /// </summary>
        /// <param name="usemodel"></param>
        /// <param name="imageList"></param>
        /// <param name="auditDescription"></param>
        /// <param name="userInfo"></param>
        /// <returns></returns>
        internal ApiResult AuditReject(RB_Property_UseReceive usemodel, List<string> imageList, string auditDescription, UserInfo userInfo)
        {
            bool flag = true;
            int empId = userInfo.EmployeeId;
            int WorkFlowId = usemodel.Id;
            string Description = auditDescription;

            var trans = workflow_AuditRelevanceRepository.DbTransaction;
            try
            {
                var aurList = workflow_AuditrecordRepository.GetAuditRecordList(WorkFlowId);
                string ImageStr = "";
                //图片处理
                if (imageList.Any())
                {
                    List<string> imgList = new List<string>();
                    ImageOperation(imageList, out imgList);
                    ImageStr = JsonConvert.SerializeObject(imgList);
                }
                //首先更改 审核关联  审核记录
                var arList = GetAuditRelevanceList(WorkFlowId);
                //找出当前审核
                int Notcount = arList.Where(x => x.Stauts == WFRrocessStatus.Rejected).Count();
                if (Notcount > 0)
                {
                    workflow_AuditRelevanceRepository.DBSession.Commit();
                    return ApiResult.Failed("该申请单已被拒绝");
                }
                var ToAuditFlow = arList.Where(x => x.Stauts == WFRrocessStatus.NotAudit).OrderBy(x => x.Sort).ToList();
                if (ToAuditFlow.Count <= 0)
                {
                    workflow_AuditRelevanceRepository.DBSession.Commit();
                    return ApiResult.Failed("该申请单审核已经完结");
                }
                if (ToAuditFlow.Count > 0)
                {
                    var model = ToAuditFlow[0];
                    var RecordList = aurList.Where(x => x.AuditId == model.Id).ToList();

                    var amodel = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId == empId).FirstOrDefault();
                    if (amodel == null)
                    {
                        workflow_AuditRelevanceRepository.DBSession.Commit();
                        return ApiResult.Failed("尚未匹配到审核相关信息，请联系管理员");
                    }
                    //同时 修改  审核记录状态 审核流程
                    model.Stauts = WFRrocessStatus.Rejected;
                    if (!string.IsNullOrWhiteSpace(model.AuditedId))
                    {
                        model.AuditedId += "," + empId;
                    }
                    else
                    {
                        model.AuditedId = empId.ToString();
                    }
                    #region 更新审核记录表状态
                    IDictionary<string, object> fileds = new Dictionary<string, object>
                    {
                        { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.Rejected },
                        { nameof(Rb_Workflow_Auditrecord.Description),Description}
                        ,{ nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                    ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                    };
                    IList<WhereHelper> whereHelpers = new List<WhereHelper>
                    {
                        new WhereHelper()
                        {
                            FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                            FiledValue = amodel.Id,
                            OperatorEnum = OperatorEnum.Equal
                        }
                    };
                    workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans);
                    #endregion
                    #region 更新审核关联表状态
                    fileds = new Dictionary<string, object>
                    {
                        { nameof(Rb_Workflow_AuditRelevance.Stauts), model.Stauts },
                        { nameof(Rb_Workflow_AuditRelevance.AuditedId), model.AuditedId },
                    };
                    whereHelpers = new List<WhereHelper>
                    {
                        new WhereHelper()
                        {
                            FiledName = nameof(Rb_Workflow_AuditRelevance.Id),
                            FiledValue = model.Id,
                            OperatorEnum = OperatorEnum.Equal
                        }
                    };
                    workflow_AuditRelevanceRepository.Update(fileds, whereHelpers, trans);
                    #endregion
                    var list = RecordList.Where(x => x.AuditStatus == WFRrocessStatus.NotAudit && x.AuditEmId != empId).ToList();
                    int AuditCount = list.Count();
                    if (AuditCount > 0)//表示最后一个人就是子集审核   申请单 通过
                    {
                        foreach (var item in list)
                        {
                            fileds = new Dictionary<string, object>
                            {
                                { nameof(Rb_Workflow_Auditrecord.AuditStatus), WFRrocessStatus.OtherHaveAudit },
                                { nameof(Rb_Workflow_Auditrecord.Description),Description},
                                { nameof(Rb_Workflow_Auditrecord.Image),ImageStr}
                            ,{ nameof(Rb_Workflow_Auditrecord.UpdateTime),DateTime.Now}
                            };
                            whereHelpers = new List<WhereHelper>
                            {
                                new WhereHelper()
                                {
                                    FiledName = nameof(Rb_Workflow_Auditrecord.Id),
                                    FiledValue = item.Id,
                                    OperatorEnum = OperatorEnum.Equal
                                }
                            };
                            workflow_AuditrecordRepository.Update(fileds, whereHelpers, trans);
                        }
                    }
                }
                if (flag)
                {
                    //更新资产状态
                    //更新领用状态
                    Dictionary<string, object> uflies = new Dictionary<string, object>() {
                        { nameof(RB_Property_UseReceive.AuditStatus),OrderStateEnum.Reject}
                    };
                    List<WhereHelper> uwheres = new List<WhereHelper>() {
                        new WhereHelper(){
                         FiledName=nameof(RB_Property_UseReceive.Id),
                          FiledValue=usemodel.Id,
                           OperatorEnum=OperatorEnum.Equal
                        }
                    };
                    useReceiveRepository.Update(uflies, uwheres, trans);

                    //日志
                    RB_Workfolw_Change_Log logModel = new RB_Workfolw_Change_Log
                    {
                        LogId = 0,
                        RB_Branch_Id = userInfo.RB_Branch_id,
                        RB_Group_Id = userInfo.RB_Group_id,
                        UpdateBy = empId,
                        UpdateDate = System.DateTime.Now,
                        ResourceId = WorkFlowId,
                        Content = "审批驳回,内容："+ Description,
                        Type = 1
                    };
                    workfolw_Change_LogRepository.Insert(logModel, trans);

                    //发送推送信息
                    string EmAccout = "";
                    int EmId = 0;
                    var CreateModel = employeeRepository.GetEntity(usemodel.CreateBy.Value);
                    if (CreateModel != null)
                    {
                        EmAccout = CreateModel.EmAccount;
                        EmId = CreateModel.EmployeeId;
                    }
                    var EmNameList = new List<EmAccoutIdModel>() { new EmAccoutIdModel() { EmAccount = EmAccout, EmployeeId = EmId } };
                    PushAuditMessage(EmNameList, WorkFlowId, $@"您有资产申请已被驳回！", "审核不通过", empId, SysTemPushTypeEnum.PropertyAudit);
                    //var ThroughList = aurList.Where(x => x.AuditStatus == WFRrocessStatus.AuditThrough).ToList();
                    //EmNameList = ThroughList.Select(x => new Model.Extend.Finance.EmAccoutIdModel() { EmAccount = x.AuditEmAccout, EmployeeId = x.AuditEmId ?? 0 }).Distinct().ToList();
                    //PushAuditMessage(EmNameList, WorkFlowId, $@"您的审核通过已被上级驳回！", "审核不通过", empId, SysTemPushTypeEnum.Audit, 3);

                    workflow_AuditRelevanceRepository.DBSession.Commit();
                    return ApiResult.Success("驳回成功");
                }
                else
                {
                    workflow_AuditRelevanceRepository.DBSession.Rollback("Refund：1，单号：" + WorkFlowId);
                    return ApiResult.Failed("驳回失败");
                }
            }
            catch (Exception ex)
            {
                LogHelper.Write(ex, "Refund");
                workflow_AuditRelevanceRepository.DBSession.Rollback("Refund：2，单号：" + WorkFlowId + "，异常信息：" + ex.Message);
                return ApiResult.Failed("驳回失败");
            }
        }

        /// <summary>
        /// 处理图片
        /// </summary>
        /// <param name="images"></param>
        /// <param name="imgList"></param>
        private static void ImageOperation(List<string> images, out List<string> imgList)
        {
            imgList = new List<string>();
            if (images != null && images.Count() > 0)
            {
                for (int i = 0; i < images.Count(); i++)
                {
                    string userFile = "/New/Upload/Property/";
                    string NewFileUrl;
                    if (Config.GetFilePath(images[i]).Contains("/New/"))
                    {
                        NewFileUrl = Config.GetFilePath(images[i]).Replace("Temporary", "Property");
                    }
                    else
                    {
                        NewFileUrl = "/New" + Config.GetFilePath(images[i]).Replace("Temporary", "Property");
                    }
                    FileCommonHelper.OssFileMove(Config.GetFilePath(images[i]), userFile);
                    imgList.Add(NewFileUrl);
                }
            }
        }

        /// <summary>
        /// 获取抄送人
        /// </summary>
        /// <param name="WorkFlowId"></param>
        /// <returns></returns>
        public List<Rb_Workflow_CopyToPeople_Extend> GetCopyToPeopleList(int WorkFlowId)
        {
            var list = workflow_CopyToPeopleRepository.GetCopyToPeopleList(WorkFlowId);
            foreach (var item in list)
            {
                var emList = employeeRepository.GetEntity(item.EmployeeId);
                item.EmName = emList != null ? emList.EmName : "";
                item.EmAccount = emList != null ? emList.EmAccount : "";
                item.EmPhoto = emList != null ? emList.EmPhoto : "";
            }
            return list;
        }

        /// <summary>
        /// 推送资产审批消息
        /// </summary>
        /// <param name="account"></param>
        /// <param name="workFlowId"></param>
        /// <param name="content"></param>
        /// <param name="title"></param>
        /// <param name="empId"></param>
        /// <param name="type"></param>
        public void PushAuditMessage(List<EmAccoutIdModel> account, int workFlowId, string content, string title, int? empId, SysTemPushTypeEnum type)
        {
            //Dictionary<string, object> appExtras = new Dictionary<string, object>();
            Dictionary<string, object> webExtras = new Dictionary<string, object>
            {
                { "jumpUrl", "AssetsShenpi?Id=" + workFlowId + "&compType=shenpi" }
            };
            //appExtras.Add("jumpUrl", "vt://financeApprovalDetail/view?ID=" + workFlowId + "&Conditon=3&Source=message&Type=" + Type);

            //IMService.PushFinanceMessage(account, empId, content, title, type, SystemPushLogTypeEnum.XMApp, appExtras);
            IMService.PushMessage(account.RefMapperToList<Property.Common.Models.EmAccoutIdModel>(), empId, content, title, type, SystemPushLogTypeEnum.Web, webExtras);
        }

    }
}
