﻿using NPOI.SS.Formula.Functions;
using Property.Model.Entity.Mall;
using Property.Model.Extend.Mall;
using Property.Repository;
using Property.Repository.Mall;
using System;
using System.Collections.Generic;

namespace Property.Module.Mall
{
    public class AuthorizeModule
    {


        /// <summary>
        /// 授权仓储层
        /// </summary>
        private readonly RB_ERP_AuthorizeRepository authorizeRepository = new RB_ERP_AuthorizeRepository();


        #region 用户/集团授权
        /// <summary>
        /// 授权分页列表
        /// </summary>
        /// <param name="pageIndex">页码</param>
        /// <param name="pageSize">每页显示条数</param>
        /// <param name="rowCount">总条数</param>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_ERP_Authorize_Extend> GetAuthorizePageList(int pageIndex, int pageSize, out long rowCount, RB_ERP_Authorize_Extend query)
        {
            return authorizeRepository.GetAuthorizePageList(pageIndex, pageSize, out rowCount, query);
        }


        /// <summary>
        /// 授权列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_ERP_Authorize_Extend> GetAuthorizeList(RB_ERP_Authorize_Extend query)
        {
            return authorizeRepository.GetAuthorizeList(query);
        }

        public bool AddERPAuthorize(RB_ERP_Authorize model)
        {
            if (model.ID == 0)
            {
                return authorizeRepository.Insert(model) > 0;
            }
            else if (model.ID > 0)
            {
                return authorizeRepository.Update(model);

            }
            return false;
        }


        /// <summary>
        /// 审核权限
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public bool UpdateERPAuthorize(RB_ERP_Authorize model)
        {
            if (model.ID > 0)
            {
                Dictionary<string, object> files = new Dictionary<string, object>() {
                        { nameof(RB_ERP_Authorize.Status),model.Status},
                       { nameof(RB_ERP_Authorize.UpdateDate),model.UpdateDate}
            };
                List<WhereHelper> wheres = new List<WhereHelper>() {
                        new WhereHelper(){
                             FiledName=nameof(RB_ERP_Authorize.ID),
                              FiledValue=model.ID,
                               OperatorEnum=OperatorEnum.Equal
                        }
                    };
                return authorizeRepository.Update(files, wheres);
            }
            return false;
        }

        #endregion

    }
}
