﻿using Property.Model.Entity.Mall;
using Property.Model.Extend.Mall;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository.Mall
{
    public class RB_WarehouseOut_FinanceRepository : RepositoryBase<RB_WarehouseOut_Finance>
    {
        /// <summary>
        /// 表名称
        /// </summary>
        public string TableName { get { return nameof(RB_WarehouseOut_Finance); } }
        /// <summary>
        /// 出库申请列表
        /// </summary>
        /// <param name="pageIndex">页码</param>
        /// <param name="pageSize">每页显示条数</param>
        /// <param name="rowCount">总条数</param>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_WarehouseOut_Finance> GetApplyPageList(int pageIndex, int pageSize, out long rowCount, RB_WarehouseOut_Finance query)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append(@$" select a.* from {TableName} as a where a.Status=0 ");
            if (query != null)
            {
                if (query.ID > 0)
                {
                    builder.Append($" AND a.{nameof(RB_WarehouseOut_Finance.ID)}={query.ID}");
                }
                if (query.TenantId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_WarehouseOut_Finance.TenantId)}={query.TenantId}");
                }
                if (query.MallBaseId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_WarehouseOut_Finance.MallBaseId)}={query.MallBaseId}");
                }
                if (query.RB_Group_Id > 0)
                {
                    builder.Append($" AND a.{nameof(RB_WarehouseOut_Finance.RB_Group_Id)}={query.RB_Group_Id}");
                }
                if (query.RB_Branch_Id > -1)
                {
                    builder.Append($" AND a.{nameof(RB_WarehouseOut_Finance.RB_Branch_Id)}={query.RB_Branch_Id}");
                }
            }
            return GetPage<RB_WarehouseOut_Finance>(pageIndex, pageSize, out rowCount, builder.ToString()).ToList();
        }


        /// <summary>
        /// 出库申请列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_WarehouseOut_Finance> GetApplyList(RB_WarehouseOut_Finance query)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append($" select * from {TableName} as a where a.Status=0 ");
            if (query != null)
            {
                if (query.ID > 0)
                {
                    builder.Append($" AND a.{nameof(RB_WarehouseOut_Finance.ID)}={query.ID}");
                }
                if (query.TenantId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_WarehouseOut_Finance.TenantId)}={query.TenantId}");
                }
                if (query.MallBaseId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_WarehouseOut_Finance.MallBaseId)}={query.MallBaseId}");
                }
                
            }
            return Get<RB_WarehouseOut_Finance>(builder.ToString()).ToList();
        }
    }
}
