﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 请购单仓储类
    /// </summary>
    public partial class RB_Property_BuyingRequisitionRepository : RepositoryBase<RB_Property_BuyingRequisition>
    {
        /// <summary>
        /// 获取请购单分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_BuyingRequisition_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_BuyingRequisition_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pb.{0}={1}", nameof(RB_Property_BuyingRequisition_Extend.Status), 0);
            where += $@" and pb.RB_Group_Id={dmodel.RB_Group_Id}";            
            if (!string.IsNullOrEmpty(dmodel.Name)) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Name) + " like '%" + dmodel.Name+"%'";
            }
            if (dmodel.Type > 0) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Type) + " =" + dmodel.Type;
            }
            if (dmodel.CreateBy > 0) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateBy) + " =" + dmodel.CreateBy;
            }
            if (dmodel.BuyStatus > 0) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + " =" + (int)dmodel.BuyStatus;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime)) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " >='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime)) {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " <='" + dmodel.EndTime + " 23:59:59'";
            }
            string sql = $@" select pb.*,pc.Name as CategoryName from RB_Property_BuyingRequisition pb
left join rb_property_category pc on pb.CategoryId = pc.Id
{where} order by pb.Id desc";
            return GetPage<RB_Property_BuyingRequisition_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }
        /// <summary>
        /// 获取列表数据
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_BuyingRequisition_Extend> GetList(RB_Property_BuyingRequisition_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pb.{0}={1}", nameof(RB_Property_BuyingRequisition_Extend.Status), 0);
            where += $@" and pb.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrEmpty(dmodel.Name))
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (dmodel.Type > 0)
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.Type) + " =" + dmodel.Type;
            }
            if (dmodel.BuyStatus > 0)
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.BuyStatus) + " =" + (int)dmodel.BuyStatus;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " >='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pb." + nameof(RB_Property_BuyingRequisition_Extend.CreateDate) + " <='" + dmodel.EndTime + " 23:59:59'";
            }
            string sql = $@" select pb.*,pc.Name as CategoryName from RB_Property_BuyingRequisition pb
left join rb_property_category pc on pb.CategoryId = pc.Id
{where} order by pb.Id desc";
            return Get<RB_Property_BuyingRequisition_Extend>(sql).ToList();
        }
    }
}
