﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产分类仓储类
    /// </summary>
    public partial class RB_Property_CategoryRepository : RepositoryBase<RB_Property_Category>
    {
        /// <summary>
        /// 获取岗位分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Category_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_Category_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pc.{0}={1}", nameof(RB_Property_Category_Extend.Status), 0);
            where += $@" and pc.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.RB_Branch_Id > -1)
            {
                where += " and pc." + nameof(RB_Property_Category_Extend.RB_Branch_Id) + "=" + dmodel.RB_Branch_Id;
            }
            if (dmodel.ParentId.HasValue && dmodel.ParentId > 0)
            {
                where += " and pc." + nameof(RB_Property_Category_Extend.ParentId) + "=" + dmodel.ParentId;
            }
            if (dmodel.Tier.HasValue && dmodel.Tier > 0)
            {
                where += " and pc." + nameof(RB_Property_Category_Extend.Tier) + "=" + dmodel.Tier;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.Name.Trim()))
            {
                where += " and pc." + nameof(RB_Property_Category_Extend.Name) + " like '%" + dmodel.Name.Trim() + "%'";
            }
            if (dmodel.Type > 0) {
                where += " and pc." + nameof(RB_Property_Category_Extend.Type) + "=" + dmodel.Type;
            }
            string sql = $@" select pc.*,pc2.Name as ParentName from RB_Property_Category pc
left join RB_Property_Category pc2 on pc.ParentId=pc2.Id
{where} order by pc.Id desc";
            return GetPage<RB_Property_Category_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 根据条件获取岗位列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Category_Extend> GetList(RB_Property_Category_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Category_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.RB_Branch_Id > -1)
            {
                where += " and " + nameof(RB_Property_Category_Extend.RB_Branch_Id) + "=" + dmodel.RB_Branch_Id;
            }
            if (dmodel.ParentId.HasValue && dmodel.ParentId >= 0)
            {
                where += " and " + nameof(RB_Property_Category_Extend.ParentId) + "=" + dmodel.ParentId;
            }
            if (dmodel.Tier.HasValue && dmodel.Tier > 0)
            {
                where += " and " + nameof(RB_Property_Category_Extend.Tier) + "=" + dmodel.Tier;
            }
            if (!string.IsNullOrEmpty(dmodel.Name))
            {
                where += " and " + nameof(RB_Property_Category_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.CategoryIdStr)) 
            {
                where += " and " + nameof(RB_Property_Category_Extend.Id) + " in(" + dmodel.CategoryIdStr + ")";
            }
            if (dmodel.Type > 0)
            {
                where += " and " + nameof(RB_Property_Category_Extend.Type) + "=" + dmodel.Type;
            }
            return Get<RB_Property_Category_Extend>($"select * from RB_Property_Category {where} order by Id desc").ToList();
        }
    }
}
