﻿using Property.Model.Entity;
using Property.Model.Extend;
using REBORN.Common.Enum;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产盘点明细仓储类
    /// </summary>
    public partial class RB_Property_CheckDetailRepository : RepositoryBase<RB_Property_CheckDetail>
    {
        /// <summary>
        /// 获取盘点分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_CheckDetail_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_CheckDetail_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND cd.{0}={1}", nameof(RB_Property_CheckDetail_Extend.Status), 0);
            where += $@" and cd.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.PropertyId > 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.PropertyId) + "=" + dmodel.PropertyId;
            }
            if (dmodel.CheckId > 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.CheckId) + "=" + dmodel.CheckId;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyName))
            {
                where += " and pi." + nameof(RB_Property_Info.Name) + " like '%" + dmodel.PropertyName + "%'";
            }
            if (dmodel.AuditStatus > 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.AuditStatus) + "=" + dmodel.AuditStatus;
            }
            if (dmodel.CheckStatus > 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.CheckStatus) + "=" + (int)dmodel.CheckStatus;
            }
            if (dmodel.DealStatus >= 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.DealStatus) + "=" + dmodel.DealStatus;
            }
            if (dmodel.IsSelectCheckLoss == 1) {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.CheckStatus) + " in(3,4)";
            }
            string sql = $@" select cd.*,pi.Name as PropertyName,pi.PropertyNum,c.Name as CategoryName,pi.PropertyStatus,pi.BrandName from RB_Property_CheckDetail cd
left join rb_property_info pi on cd.PropertyId=pi.Id
left join rb_property_category c on pi.CategoryId=c.Id
{where} order by cd.Id desc";
            return GetPage<RB_Property_CheckDetail_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 根据条件获取盘点列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_CheckDetail_Extend> GetList(RB_Property_CheckDetail_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND cd.{0}={1}", nameof(RB_Property_CheckDetail_Extend.Status), 0);
            where += $@" and cd.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.PropertyId > 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.PropertyId) + "=" + dmodel.PropertyId;
            }
            if (dmodel.CheckId > 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.CheckId) + "=" + dmodel.CheckId;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyName))
            {
                where += " and pi." + nameof(RB_Property_Info.Name) + " like '%" + dmodel.PropertyName + "%'";
            }
            if (dmodel.AuditStatus > 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.AuditStatus) + "=" + dmodel.AuditStatus;
            }
            if (dmodel.CheckStatus > 0)
            {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.CheckStatus) + "=" + (int)dmodel.CheckStatus;
            }
            if (dmodel.DealStatus >= 0) {
                where += " and cd." + nameof(RB_Property_CheckDetail_Extend.DealStatus) + "=" + dmodel.DealStatus;
            }
            string sql = $@" select cd.*,pi.Name as PropertyName,pi.PropertyNum,c.Name as CategoryName,pi.PropertyStatus,pi.BrandName from RB_Property_CheckDetail cd
left join rb_property_info pi on cd.PropertyId=pi.Id
left join rb_property_category c on pi.CategoryId=c.Id
{where} order by cd.Id desc";
            return Get<RB_Property_CheckDetail_Extend>(sql).ToList();
        }
    }
}
