﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产盘点仓储类
    /// </summary>
    public partial class RB_Property_CheckRepository : RepositoryBase<RB_Property_Check>
    {
        /// <summary>
        /// 获取盘点分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Check_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_Check_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Check_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.BranchId > -1)
            {
                where += " and " + nameof(RB_Property_Check_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and " + nameof(RB_Property_Check_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (dmodel.CategoryId > 0) {
                where += " and CONCAT(','," + nameof(RB_Property_Check_Extend.CategoryIds) + ",',') like '%," + dmodel.CategoryId + ",%'";
            }
            string sql = $@" select * from RB_Property_Check {where} order by Id desc";
            return GetPage<RB_Property_Check_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 根据条件获取盘点列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Check_Extend> GetList(RB_Property_Check_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Check_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.BranchId > -1)
            {
                where += " and " + nameof(RB_Property_Check_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and " + nameof(RB_Property_Check_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and CONCAT(','," + nameof(RB_Property_Check_Extend.CategoryIds) + ",',') like '%," + dmodel.CategoryId + ",%'";
            }
            string sql = $@" select * from RB_Property_Check {where} order by Id desc";
            return Get<RB_Property_Check_Extend>(sql).ToList();
        }
    }
}
