﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产折旧仓储类
    /// </summary>
    public partial class RB_Property_DepreciationRepository : RepositoryBase<RB_Property_Depreciation>
    {
        /// <summary>
        /// 获取折旧分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Depreciation_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_Depreciation_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Depreciation_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and " + nameof(RB_Property_Category_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (dmodel.Type > 0) {
                where += " and " + nameof(RB_Property_Category_Extend.Type) + "=" + dmodel.Type;
            }
            if (dmodel.CategoryId > 0) {
                where += " and concat(',', CategoryIdString,',') LIKE '%," + dmodel.CategoryId + ",%'";
            }
            string sql = $@" select * from RB_Property_Depreciation
{where} order by Id desc";
            return GetPage<RB_Property_Depreciation_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 根据条件获取折旧列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Depreciation_Extend> GetList(RB_Property_Depreciation_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Depreciation_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and " + nameof(RB_Property_Category_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (dmodel.Type > 0)
            {
                where += " and " + nameof(RB_Property_Category_Extend.Type) + "=" + dmodel.Type;
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and concat(',', CategoryIdString,',') LIKE '%," + dmodel.CategoryId + ",%'";
            }
            string sql = $@" select * from RB_Property_Depreciation
{where} order by Id desc";
            return Get<RB_Property_Depreciation_Extend>(sql).ToList();
        }
    }
}
