﻿using Property.Model.Entity;
using Property.Model.Extend;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产信息仓储类
    /// </summary>
    public partial class RB_Property_InfoRepository : RepositoryBase<RB_Property_Info>
    {
        /// <summary>
        /// 获取资产分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_Info_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";            
            if (!string.IsNullOrWhiteSpace(dmodel.Name.Trim()))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Name) + " like '%" + dmodel.Name.Trim() + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyNum.Trim()))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyNum) + " like '%" + dmodel.PropertyNum.Trim() + "%'";
            }
            if (dmodel.CategoryId > 0) {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.UseStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.UseStatus) + "=" + (int)dmodel.UseStatus;
            }
            if (dmodel.PropertyStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "=" + (int)dmodel.PropertyStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SerialNumber.Trim()))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SerialNumber) + " = '" + dmodel.SerialNumber.Trim() + "'";
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (dmodel.SupplierId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SupplierId) + "=" + dmodel.SupplierId;
            }
            if (dmodel.BranchId >= 0) 
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + "<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.IsSelectDepreciation == 1) 
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "!=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            }
            if (dmodel.IsSelectSelfApplication == 1) {
                where += " and pi.PropertyStatus=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Leisure;
            }
            if (dmodel.IsSelectMyProperty == 1) {
                if (!string.IsNullOrEmpty(dmodel.PropertyIdStr))
                {
                    where += " and (pi.EmployeeId=" + dmodel.CreateBy + " or pi.Id in(" + dmodel.PropertyIdStr + "))";
                }
                else {
                    where += " and pi.EmployeeId=" + dmodel.CreateBy ;
                }
            }
            if (dmodel.IsSelectUseProperty == 1) {
                where += " and pi.EmployeeId > 0 ";
            }
            string sql = $@" select pi.*,pc.Name as CategoryName,ps.Name as SupplierName from RB_Property_Info pi
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_property_supplier ps on pi.SupplierId=ps.Id
{where} order by pi.Id desc";
            return GetPage<RB_Property_Info_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetList(RB_Property_Info_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (dmodel.Id > 0) 
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Id) + "=" + dmodel.Id;
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (!string.IsNullOrEmpty(dmodel.CategoryIds)) {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + " in(" + dmodel.CategoryIds + ")";
            }
            if (dmodel.UseStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.UseStatus) + "=" + (int)dmodel.UseStatus;
            }
            if (dmodel.BranchId >= 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (dmodel.PropertyStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "=" + (int)dmodel.PropertyStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SerialNumber))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SerialNumber) + " = '" + dmodel.SerialNumber + "'";
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (dmodel.SupplierId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SupplierId) + "=" + dmodel.SupplierId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + "<='" + dmodel.EndTime + " 23:59:59'";
            }

            if (!string.IsNullOrEmpty(dmodel.PropertyIdStr)) {
                where += " and pi." + nameof(RB_Property_Info_Extend.Id) + " in(" + dmodel.PropertyIdStr + ")";
            }

            if (dmodel.IsSelectDepreciation == 1)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "!=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            }

            string sql = $@" select pi.*,pc.Name as CategoryName,ps.Name as SupplierName from RB_Property_Info pi
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_property_supplier ps on pi.SupplierId=ps.Id
{where} order by pi.Id desc";
            return Get<RB_Property_Info_Extend>(sql).ToList();
        }

        /// <summary>
        /// 资产汇总
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyGroupQuery(RB_Property_Info_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (dmodel.Id > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Id) + "=" + dmodel.Id;
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (!string.IsNullOrEmpty(dmodel.CategoryIds))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + " in(" + dmodel.CategoryIds + ")";
            }
            if (dmodel.UseStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.UseStatus) + "=" + (int)dmodel.UseStatus;
            }
            if (dmodel.BranchId >= 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (dmodel.PropertyStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "=" + (int)dmodel.PropertyStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SerialNumber))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SerialNumber) + " = '" + dmodel.SerialNumber + "'";
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (dmodel.SupplierId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SupplierId) + "=" + dmodel.SupplierId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + "<='" + dmodel.EndTime + " 23:59:59'";
            }

            if (!string.IsNullOrEmpty(dmodel.PropertyIdStr))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Id) + " in(" + dmodel.PropertyIdStr + ")";
            }

            if (dmodel.IsSelectDepreciation == 1)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "!=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            }

            string sql = $@" select pi.BranchId,pi.CategoryId,pi.PropertyStatus,pc.Name as CategoryName,count(0) as PropertyNumber,Sum(pi.Money) as Money from RB_Property_Info pi
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_property_supplier ps on pi.SupplierId=ps.Id
{where} group by pi.BranchId,pi.CategoryId,pi.PropertyStatus";
            return Get<RB_Property_Info_Extend>(sql).ToList();
        }


        /// <summary>
        /// 获取资产履历分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyRecordPageQuery(int pageIndex, int pageSize, RB_Property_Info_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.UseStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.UseStatus) + "=" + (int)dmodel.UseStatus;
            }
            if (dmodel.PropertyStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "=" + (int)dmodel.PropertyStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SerialNumber))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SerialNumber) + " = '" + dmodel.SerialNumber + "'";
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (dmodel.SupplierId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SupplierId) + "=" + dmodel.SupplierId;
            }
            if (dmodel.BranchId >= 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + "<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.IsSelectDepreciation == 1)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "!=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            }
            if (!string.IsNullOrEmpty(dmodel.LogType)) {
                where += " and pl." + nameof(RB_Property_Log.TypeName) + " like '%" + dmodel.LogType + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.LogStartTime))
            {
                where += " and pl." + nameof(RB_Property_Log.CreateDate) + ">='" + dmodel.LogStartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.LogEndTime))
            {
                where += " and pl." + nameof(RB_Property_Log.CreateDate) + "<='" + dmodel.LogEndTime + " 23:59:59'";
            }
            string sql = $@" select distinct pi.*,pc.Name as CategoryName,ps.Name as SupplierName from RB_Property_Info pi
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_property_supplier ps on pi.SupplierId=ps.Id
left join rb_property_log pl on pl.PropertyId=pi.Id
{where} order by pi.Id desc";
            return GetPage<RB_Property_Info_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取二维码列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyQRCodeList(RB_Property_Info_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name.Trim()))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Name) + " like '%" + dmodel.Name.Trim() + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyNum.Trim()))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyNum) + " like '%" + dmodel.PropertyNum.Trim() + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.UseStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.UseStatus) + "=" + (int)dmodel.UseStatus;
            }
            if (dmodel.PropertyStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "=" + (int)dmodel.PropertyStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SerialNumber.Trim()))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SerialNumber) + " = '" + dmodel.SerialNumber.Trim() + "'";
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (dmodel.SupplierId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SupplierId) + "=" + dmodel.SupplierId;
            }
            if (dmodel.BranchId >= 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BuyDate) + "<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.IsSelectDepreciation == 1)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "!=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            }
            if (dmodel.IsSelectSelfApplication == 1)
            {
                where += " and pi.PropertyStatus=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Leisure;
            }
            if (dmodel.IsSelectMyProperty == 1)
            {
                if (!string.IsNullOrEmpty(dmodel.PropertyIdStr))
                {
                    where += " and (pi.EmployeeId=" + dmodel.CreateBy + " or pi.Id in(" + dmodel.PropertyIdStr + "))";
                }
                else
                {
                    where += " and pi.EmployeeId=" + dmodel.CreateBy;
                }
            }
            if (dmodel.IsSelectUseProperty == 1)
            {
                where += " and pi.EmployeeId > 0 ";
            }
            string sql = $@" select pi.Id,pi.Name,pi.PropertyNum,pi.QRCode from RB_Property_Info pi
{where} order by pi.Id desc";
            return Get<RB_Property_Info_Extend>(sql).ToList();
        }

        /// <summary>
        /// 获取资产待归还分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyStayBackPageQuery(int pageIndex, int pageSize, RB_Property_Info_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.UseStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.UseStatus) + "=" + (int)dmodel.UseStatus;
            }
            if (dmodel.PropertyStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "=" + (int)dmodel.PropertyStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SerialNumber))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SerialNumber) + " = '" + dmodel.SerialNumber + "'";
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (dmodel.SupplierId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SupplierId) + "=" + dmodel.SupplierId;
            }
            if (dmodel.BranchId >= 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.GetTime) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.GetTime) + "<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.BackTime.HasValue) 
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BackTime) + "<='" + dmodel.BackTime.Value.ToString("yyyy-MM-dd") + " 23:59:59'";
            }
            if (dmodel.IsSelectDepreciation == 1)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "!=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            }
            
            string sql = $@" select pi.*,pc.Name as CategoryName,ps.Name as SupplierName from RB_Property_Info pi
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_property_supplier ps on pi.SupplierId=ps.Id
{where} order by pi.Id desc";
            return GetPage<RB_Property_Info_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取资产过期分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyMaturityPageQuery(int pageIndex, int pageSize, RB_Property_Info_Extend dmodel, out long count)
        {
            string where = " where 1=1 and IFNULL(pi.UseMonths,0)>0";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.UseStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.UseStatus) + "=" + (int)dmodel.UseStatus;
            }
            if (dmodel.PropertyStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "=" + (int)dmodel.PropertyStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SerialNumber))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SerialNumber) + " = '" + dmodel.SerialNumber + "'";
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (dmodel.SupplierId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SupplierId) + "=" + dmodel.SupplierId;
            }
            if (dmodel.BranchId >= 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and DATE_ADD(pi.BuyDate,INTERVAL pi.UseMonths MONTH)<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.IsSelectDepreciation == 1)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "!=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            }

            string sql = $@" select pi.*,pc.Name as CategoryName,ps.Name as SupplierName,date_format(DATE_ADD(pi.BuyDate,INTERVAL pi.UseMonths MONTH),'%Y-%m-%d') as MaturityTime 
from RB_Property_Info pi
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_property_supplier ps on pi.SupplierId=ps.Id
{where} order by pi.Id desc";
            return GetPage<RB_Property_Info_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取资产过期数量
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public int GetPropertyMaturityCount(RB_Property_Info_Extend dmodel)
        {
            string where = " where 1=1 and IFNULL(pi.UseMonths,0)>0";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrWhiteSpace(dmodel.Name))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.UseStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.UseStatus) + "=" + (int)dmodel.UseStatus;
            }
            if (dmodel.PropertyStatus > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "=" + (int)dmodel.PropertyStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SerialNumber))
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SerialNumber) + " = '" + dmodel.SerialNumber + "'";
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (dmodel.SupplierId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.SupplierId) + "=" + dmodel.SupplierId;
            }
            if (dmodel.BranchId >= 0)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.BranchId) + "=" + dmodel.BranchId;
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and DATE_ADD(pi.BuyDate,INTERVAL pi.UseMonths MONTH)<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.IsSelectDepreciation == 1)
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + "!=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            }

            string sql = $@" select count(0) as PropertyNumber
from RB_Property_Info pi
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_property_supplier ps on pi.SupplierId=ps.Id
{where} order by pi.Id desc";
            return Get<RB_Property_Info_Extend>(sql).FirstOrDefault()?.PropertyNumber ?? 0;
        }

        /// <summary>
        /// 获取我的资产数量
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public int GetPropertyToMyCount(RB_Property_Info_Extend dmodel) {
            string where = " where 1=1 ";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";

            if (dmodel.IsSelectMyProperty == 1)
            {
                if (!string.IsNullOrEmpty(dmodel.PropertyIdStr))
                {
                    where += " and (pi.EmployeeId=" + dmodel.CreateBy + " or pi.Id in(" + dmodel.PropertyIdStr + "))";
                }
                else
                {
                    where += " and pi.EmployeeId=" + dmodel.CreateBy;
                }
            }
            string sql = $@" select count(0) as PropertyNumber from RB_Property_Info pi
{where} order by pi.Id desc";
            var list = Get<RB_Property_Info_Extend>(sql).ToList();
            if (list.Any())
            {
                return list.FirstOrDefault()?.PropertyNumber ?? 0;
            }
            else {
                return 0;
            }
        }

        /// <summary>
        /// 获取资产概况数据
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public RB_Property_Info_Extend GetPropertyIndexGeneralSituation(RB_Property_Info_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pi.{0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and pi.RB_Group_Id={dmodel.RB_Group_Id}";

            //if (dmodel.LogType == "1")
            //{
            //    where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Leisure;
            //    where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
            //    where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.AllotW;
            //    where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.BorrowW;
            //    where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.ReceiveW;
            //    where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.DisposeW;
            //}
            //else {
            //    where += " and (pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " =" + (int)REBORN.Common.Enum.PropertyStatusEnum.Leisure;
            //    where += " or pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " =" + (int)REBORN.Common.Enum.PropertyStatusEnum.AllotW;
            //    where += " or pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " =" + (int)REBORN.Common.Enum.PropertyStatusEnum.BorrowW;
            //    where += " or pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " =" + (int)REBORN.Common.Enum.PropertyStatusEnum.ReceiveW;
            //    where += " or pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " =" + (int)REBORN.Common.Enum.PropertyStatusEnum.DisposeW + ")";
            //}
            if (dmodel.LogType == "1")
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Leisure;
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.Dispose;
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " !=" + (int)REBORN.Common.Enum.PropertyStatusEnum.DisposeW;
            }
            else
            {
                where += " and pi." + nameof(RB_Property_Info_Extend.PropertyStatus) + " =" + (int)REBORN.Common.Enum.PropertyStatusEnum.Leisure;
            }

            string sql = $@" select COUNT(0) as PropertyNumber,SUM(pi.Money) as Money
from RB_Property_Info pi
{where} order by pi.Id desc";
            return Get<RB_Property_Info_Extend>(sql).FirstOrDefault();
        }

        /// <summary>
        /// 获取资产状态占比
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyIndexPropertyStatusRatio(RB_Property_Info_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.LogType == "1")
            {
                string sql = $@" SELECT PropertyStatus,COUNT(0) as PropertyNumber
FROM rb_property_info {where}
GROUP BY PropertyStatus";
                return Get<RB_Property_Info_Extend>(sql).ToList();
            }
            else {
                where += $@" and UseStatus={(int)REBORN.Common.Enum.PropertyUseStateEnum.Repair}";
                string sql = $@" SELECT COUNT(0) as PropertyNumber
FROM rb_property_info {where}";
                return Get<RB_Property_Info_Extend>(sql).ToList();
            }
        }

        /// <summary>
        /// 获取资产入库领用情况
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Info_Extend> GetPropertyIndexPropertyInStock(RB_Property_Info_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Info_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.LogType == "1")
            {
                //入库情况
                if (!string.IsNullOrEmpty(dmodel.StartTime)) 
                {
                    where += $@" and CreateDate >='{dmodel.StartTime}'";
                }
                if (!string.IsNullOrEmpty(dmodel.EndTime))
                {
                    where += $@" and CreateDate <='{dmodel.EndTime} 23:59:59'";
                }
                if (!string.IsNullOrEmpty(dmodel.CategoryIds))
                {
                    where += $@" and CategoryId in({dmodel.CategoryIds})";
                }
                string sql = $@" SELECT CategoryId,DATE_FORMAT(CreateDate,'%Y-%m') AS StartTime,COUNT(0) AS PropertyNumber
FROM rb_property_info {where}
GROUP BY CategoryId,DATE_FORMAT(CreateDate,'%Y-%m')";
                return Get<RB_Property_Info_Extend>(sql).ToList();
            }
            else
            {
                //领取情况
                if (!string.IsNullOrEmpty(dmodel.StartTime))
                {
                    where += $@" and pu.Time >='{dmodel.StartTime}'";
                }
                if (!string.IsNullOrEmpty(dmodel.EndTime))
                {
                    where += $@" and pu.Time <='{dmodel.EndTime} 23:59:59'";
                }
                if (!string.IsNullOrEmpty(dmodel.CategoryIds)) 
                {
                    where += $@" and pi.CategoryId in({dmodel.CategoryIds})";
                }
                string sql = $@" SELECT pi.CategoryId,DATE_FORMAT(pu.Time,'%Y-%m') AS StartTime,COUNT(0) AS PropertyNumber 
FROM rb_property_usereceive pu
LEFT JOIN rb_property_userelevance pur on pu.Id=pur.ReceiveId
LEFT JOIN rb_property_info pi on pur.PropertyId=pi.Id
WHERE pu.Source=1 and pu.AuditStatus=2 and pur.Status=0
GROUP BY pi.CategoryId,DATE_FORMAT(pu.Time,'%Y-%m') ";
                return Get<RB_Property_Info_Extend>(sql).ToList();
            }
        }
    }
}
