﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产日志仓储类
    /// </summary>
    public partial class RB_Property_LogRepository : RepositoryBase<RB_Property_Log>
    {
        /// <summary>
        /// 获取岗位分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Log_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_Log_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Log_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";            
            if (dmodel.PropertyId > 0) {
                where += " and " + nameof(RB_Property_Log_Extend.PropertyId) + "=" + dmodel.PropertyId;
            }
            string sql = $@" select * from RB_Property_Log {where} order by Id desc";
            return GetPage<RB_Property_Log_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }
        /// <summary>
        /// 获取列表数据
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Log_Extend> GetList(RB_Property_Log_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Log_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.PropertyId > 0)
            {
                where += " and " + nameof(RB_Property_Log_Extend.PropertyId) + "=" + dmodel.PropertyId;
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyIds)) {
                where += " and " + nameof(RB_Property_Log_Extend.PropertyId) + " in(" + dmodel.PropertyIds + ")";
            }
            if (!string.IsNullOrEmpty(dmodel.TypeName))
            {
                where += " and " + nameof(RB_Property_Log_Extend.TypeName) + " like '%" + dmodel.TypeName + "%'";
            }
            string sql = $@" select * from RB_Property_Log {where} order by Id desc";
            return Get<RB_Property_Log_Extend>(sql).ToList();
        }
    }
}
