﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产供应商仓储类
    /// </summary>
    public partial class RB_Property_SupplierRepository : RepositoryBase<RB_Property_Supplier>
    {
        /// <summary>
        /// 获取岗位分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_Supplier_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_Supplier_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Supplier_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";            
            if (!string.IsNullOrWhiteSpace(dmodel.Name.Trim()))
            {
                where += " and " + nameof(RB_Property_Supplier_Extend.Name) + " like '%" + dmodel.Name.Trim() + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.Contact.Trim()))
            {
                where += " and " + nameof(RB_Property_Supplier_Extend.Contact) + " like '%" + dmodel.Contact.Trim() + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.Mobile.Trim()))
            {
                where += " and " + nameof(RB_Property_Supplier_Extend.Mobile) + " = '" + dmodel.Mobile.Trim() + "'";
            }
            string sql = $@" select * from RB_Property_Supplier {where} order by Id desc";
            return GetPage<RB_Property_Supplier_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }
        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_Supplier_Extend> GetList(RB_Property_Supplier_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Property_Supplier_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrEmpty(dmodel.Name))
            {
                where += " and " + nameof(RB_Property_Supplier_Extend.Name) + " like '%" + dmodel.Name + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.Contact))
            {
                where += " and " + nameof(RB_Property_Supplier_Extend.Contact) + " like '%" + dmodel.Contact + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.Mobile))
            {
                where += " and " + nameof(RB_Property_Supplier_Extend.Mobile) + " = '" + dmodel.Mobile + "'";
            }
            string sql = $@" select * from RB_Property_Supplier {where} order by Id desc";
            return Get<RB_Property_Supplier_Extend>(sql).ToList();
        }
    }
}
