﻿using Property.Model.Entity;
using Property.Model.Extend;
using REBORN.Common.Enum;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产使用仓储类
    /// </summary>
    public partial class RB_Property_UseReceiveRepository : RepositoryBase<RB_Property_UseReceive>
    {
        /// <summary>
        /// 获取资产使用分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_UseReceive_Extend> GetPageList(int pageIndex, int pageSize, RB_Property_UseReceive_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pu.{0}={1}", nameof(RB_Property_UseReceive_Extend.Status), 0);
            where += $@" and pu.RB_Group_Id={dmodel.RB_Group_Id}";            
            if (!string.IsNullOrEmpty(dmodel.OrderCode))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.OrderCode) + " like '%" + dmodel.OrderCode + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyName))
            {
                where += " and pi." + nameof(RB_Property_Info.Name) + " like '%" + dmodel.PropertyName + "%'";
            }
            if (dmodel.CategoryId > 0) {
                where += " and pi." + nameof(RB_Property_Info.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.AuditStatus > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)dmodel.AuditStatus;
            }
            if (dmodel.Source > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Source) + "=" + (int)dmodel.Source;
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + "<='" + dmodel.EndTime + " 23:59:59'";
            }

            if (!string.IsNullOrEmpty(dmodel.BackSTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.BackTime) + ">='" + dmodel.BackSTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.BackETime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.BackTime) + "<='" + dmodel.BackETime + " 23:59:59'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyIdStr)) {
                where += $@" and pur.PropertyId in({dmodel.PropertyIdStr})";
            }
            if (dmodel.CreateBy > 0) {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.CreateBy) + "=" + dmodel.CreateBy;
            }
            if (dmodel.IsSelfApplication == 1) {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.IsSelfApplication) + "=" + dmodel.IsSelfApplication;
            }
            if (dmodel.DisposeType > 0) {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.DisposeType) + "=" + (int)dmodel.DisposeType;
            }
            string sql = $@" select distinct pu.* from 
RB_Property_UseReceive pu 
left join rb_property_userelevance pur on pu.Id=pur.ReceiveId
left join RB_Property_Info pi on pur.PropertyId=pi.Id
left join RB_Property_Category pc on pc.Id=pi.CategoryId
{where} order by pu.Id desc";
            return GetPage<RB_Property_UseReceive_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Property_UseReceive_Extend> GetPropertyUseReceiveList(RB_Property_UseReceive_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pu.{0}={1}", nameof(RB_Property_UseReceive_Extend.Status), 0);
            where += $@" and pu.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrEmpty(dmodel.OrderCode))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.OrderCode) + " like '%" + dmodel.OrderCode + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyName))
            {
                where += " and pi." + nameof(RB_Property_Info.Name) + " like '%" + dmodel.PropertyName + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.AuditStatus > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)dmodel.AuditStatus;
            }
            if (dmodel.Source > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Source) + "=" + (int)dmodel.Source;
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + "<='" + dmodel.EndTime + " 23:59:59'";
            }

            if (!string.IsNullOrEmpty(dmodel.BackSTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.BackTime) + ">='" + dmodel.BackSTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.BackETime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.BackTime) + "<='" + dmodel.BackETime + " 23:59:59'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyIdStr))
            {
                where += $@" and pur.PropertyId in({dmodel.PropertyIdStr})";
            }
            if (dmodel.CreateBy > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.CreateBy) + "=" + dmodel.CreateBy;
            }
            string sql = $@" select pu.*,pur.PropertyId from 
RB_Property_UseReceive pu 
left join rb_property_userelevance pur on pu.Id=pur.ReceiveId
left join RB_Property_Info pi on pur.PropertyId=pi.Id
left join RB_Property_Category pc on pc.Id=pi.CategoryId
{where} order by pu.Id desc";
            return Get<RB_Property_UseReceive_Extend>(sql).ToList();
        }


        /// <summary>
        /// 获取待我审批分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_UseReceive_Extend> GetPropertyWaitMyAuditPageList(int pageIndex, int pageSize, RB_Property_UseReceive_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pu.{0}={1}", nameof(RB_Property_UseReceive_Extend.Status), 0);
            where += $@" and pu.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrEmpty(dmodel.OrderCode))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.OrderCode) + " like '%" + dmodel.OrderCode + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyName))
            {
                where += " and pi." + nameof(RB_Property_Info.Name) + " like '%" + dmodel.PropertyName + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.AuditStatus > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)dmodel.AuditStatus;
            }
            if (dmodel.Source > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Source) + "=" + (int)dmodel.Source;
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + "<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.CreateBy > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.CreateBy) + "=" + dmodel.CreateBy;
            }
            if (dmodel.AuditEmId > 0) {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + "=" + (int)WFRrocessStatus.NotAudit;
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)OrderStateEnum.Auditing;//需要申请单在审核中
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.SpecialNode) + " !=" + (int)WFSpecialNodeEnum.Pay;//排除签名的
            }
            if (dmodel.AuditedEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditedEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + " in(" + (int)WFRrocessStatus.AuditThrough + "," + (int)WFRrocessStatus.AuditNotThrough + "," + (int)WFRrocessStatus.Rejected + ")";
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.SpecialNode) + " !=" + (int)WFSpecialNodeEnum.Pay;//排除签名的
            }
            string sql = $@" select distinct pu.* from 
RB_Property_UseReceive pu 
left join rb_property_userelevance pur on pu.Id=pur.ReceiveId
left join RB_Property_Info pi on pur.PropertyId=pi.Id
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_workflow_auditrecord wa on pu.Id=wa.WorkFlowId
LEFT JOIN rb_workflow_auditrelevance war on wa.AuditId=war.Id
{where} order by pu.Id desc";
            return GetPage<RB_Property_UseReceive_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取待我签字分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="demodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Property_UseReceive_Extend> GetPropertyWaitMySignPageList(int pageIndex, int pageSize, RB_Property_UseReceive_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pu.{0}={1}", nameof(RB_Property_UseReceive_Extend.Status), 0);
            where += $@" and pu.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrEmpty(dmodel.OrderCode))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.OrderCode) + " like '%" + dmodel.OrderCode + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyName))
            {
                where += " and pi." + nameof(RB_Property_Info.Name) + " like '%" + dmodel.PropertyName + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.AuditStatus > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)dmodel.AuditStatus;
            }
            if (dmodel.Source > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Source) + "=" + (int)dmodel.Source;
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + "<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.CreateBy > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.CreateBy) + "=" + dmodel.CreateBy;
            }
            if (dmodel.AuditEmId > 0)
            {
                where += $@" and ar.SpecialNode=2 and ar.Stauts=1 and (ar2.Stauts=2 or ar2.Id is null)";
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + "=" + (int)WFRrocessStatus.NotAudit;
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)OrderStateEnum.Auditing;//需要申请单在审核中
            }
            if (dmodel.AuditedEmId > 0)
            {
                where += $@" and ar.SpecialNode=2 and ar.Stauts=2 ";
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditedEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + " in(" + (int)WFRrocessStatus.AuditThrough + "," + (int)WFRrocessStatus.AuditNotThrough + "," + (int)WFRrocessStatus.Rejected + ")";
            }
            string sql = $@" select distinct pu.* from 
RB_Property_UseReceive pu 
LEFT JOIN rb_workflow_auditrelevance ar on ar.WorkFlowId=pu.Id
LEFT JOIN rb_workflow_auditrelevance ar2 on ar.WorkFlowId=ar2.WorkFlowId AND (ar.Sort-1)=ar2.Sort
left join rb_property_userelevance pur on pu.Id=pur.ReceiveId
left join RB_Property_Info pi on pur.PropertyId=pi.Id
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_workflow_auditrecord wa on pu.Id=wa.WorkFlowId
{where} order by pu.Id desc";
            return GetPage<RB_Property_UseReceive_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }


        /// <summary>
        /// 获取待我签字数量
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public int GetPropertyWaitMySignCount(RB_Property_UseReceive_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pu.{0}={1}", nameof(RB_Property_UseReceive_Extend.Status), 0);
            where += $@" and pu.RB_Group_Id={dmodel.RB_Group_Id}";
            where += $@" and ar.SpecialNode=2 and ar.Stauts=1 and (ar2.Stauts=2 or ar2.Id is null)";
            if (!string.IsNullOrEmpty(dmodel.OrderCode))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.OrderCode) + " like '%" + dmodel.OrderCode + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyName))
            {
                where += " and pi." + nameof(RB_Property_Info.Name) + " like '%" + dmodel.PropertyName + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.AuditStatus > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)dmodel.AuditStatus;
            }
            if (dmodel.Source > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Source) + "=" + (int)dmodel.Source;
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + "<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.CreateBy > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.CreateBy) + "=" + dmodel.CreateBy;
            }
            if (dmodel.AuditEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + "=" + (int)WFRrocessStatus.NotAudit;
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)OrderStateEnum.Auditing;//需要申请单在审核中
            }
            if (dmodel.AuditedEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditedEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + " in(" + (int)WFRrocessStatus.AuditThrough + "," + (int)WFRrocessStatus.AuditNotThrough + "," + (int)WFRrocessStatus.Rejected + ")";
            }
            string sql = $@"
select count(distinct pu.Id) as Number from 
RB_Property_UseReceive pu 
LEFT JOIN rb_workflow_auditrelevance ar on ar.WorkFlowId=pu.Id
LEFT JOIN rb_workflow_auditrelevance ar2 on ar.WorkFlowId=ar2.WorkFlowId AND (ar.Sort-1)=ar2.Sort
left join rb_property_userelevance pur on pu.Id=pur.ReceiveId
left join RB_Property_Info pi on pur.PropertyId=pi.Id
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_workflow_auditrecord wa on pu.Id=wa.WorkFlowId
{where} order by pu.Id desc";
            var model = Get<RB_Property_UseReceive_Extend>(sql).FirstOrDefault();
            if (model != null)
            {
                return model.Number ?? 0;
            }
            else {
                return 0;
            }
        }

        /// <summary>
        /// 获取待我审批数量
        /// </summary>
        /// <param name="dmodel"></param>        
        /// <returns></returns>
        public int GetPropertyWaitMyAuditCount(RB_Property_UseReceive_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pu.{0}={1}", nameof(RB_Property_UseReceive_Extend.Status), 0);
            where += $@" and pu.RB_Group_Id={dmodel.RB_Group_Id}";
            if (!string.IsNullOrEmpty(dmodel.OrderCode))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.OrderCode) + " like '%" + dmodel.OrderCode + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyNum))
            {
                where += " and pi." + nameof(RB_Property_Info.PropertyNum) + " like '%" + dmodel.PropertyNum + "%'";
            }
            if (!string.IsNullOrEmpty(dmodel.PropertyName))
            {
                where += " and pi." + nameof(RB_Property_Info.Name) + " like '%" + dmodel.PropertyName + "%'";
            }
            if (dmodel.CategoryId > 0)
            {
                where += " and pi." + nameof(RB_Property_Info.CategoryId) + "=" + dmodel.CategoryId;
            }
            if (dmodel.AuditStatus > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)dmodel.AuditStatus;
            }
            if (dmodel.Source > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Source) + "=" + (int)dmodel.Source;
            }
            if (dmodel.EmployeeId > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            if (!string.IsNullOrEmpty(dmodel.StartTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + ">='" + dmodel.StartTime + "'";
            }
            if (!string.IsNullOrEmpty(dmodel.EndTime))
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.Time) + "<='" + dmodel.EndTime + " 23:59:59'";
            }
            if (dmodel.CreateBy > 0)
            {
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.CreateBy) + "=" + dmodel.CreateBy;
            }
            if (dmodel.AuditEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + "=" + (int)WFRrocessStatus.NotAudit;
                where += " and pu." + nameof(RB_Property_UseReceive_Extend.AuditStatus) + "=" + (int)OrderStateEnum.Auditing;//需要申请单在审核中
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.SpecialNode) + " !=" + (int)WFSpecialNodeEnum.Pay;//排除签名的
            }
            if (dmodel.AuditedEmId > 0)
            {
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "=" + dmodel.AuditedEmId;
                where += " and wa." + nameof(Rb_Workflow_Auditrecord.AuditStatus) + " in(" + (int)WFRrocessStatus.AuditThrough + "," + (int)WFRrocessStatus.AuditNotThrough + "," + (int)WFRrocessStatus.Rejected + ")";
                where += " and war." + nameof(Rb_Workflow_AuditRelevance_Extend.SpecialNode) + " !=" + (int)WFSpecialNodeEnum.Pay;//排除签名的
            }
            string sql = $@"
select count(distinct pu.Id) as Number from 
RB_Property_UseReceive pu 
left join rb_property_userelevance pur on pu.Id=pur.ReceiveId
left join RB_Property_Info pi on pur.PropertyId=pi.Id
left join RB_Property_Category pc on pc.Id=pi.CategoryId
left join rb_workflow_auditrecord wa on pu.Id=wa.WorkFlowId
LEFT JOIN rb_workflow_auditrelevance war on wa.AuditId=war.Id
{where} order by pu.Id desc";
            return Get<RB_Property_UseReceive_Extend>(sql).FirstOrDefault()?.Number ?? 0;
        }
    }
}
