﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 资产使用关联仓储类
    /// </summary>
    public partial class RB_Property_UseRelevanceRepository : RepositoryBase<RB_Property_UseRelevance>
    {
        /// <summary>
        /// 获取资产使用分页数据
        /// </summary>
        /// <param name="dmodel"></param>        
        /// <returns></returns>
        public List<RB_Property_UseRelevance_Extend> GetList(RB_Property_UseRelevance_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pur.{0}={1}", nameof(RB_Property_UseRelevance_Extend.Status), 0);
            where += $@" and pur.RB_Group_Id={dmodel.RB_Group_Id}";            
            if (dmodel.ReceiveId > 0)
            {
                where += " and pur." + nameof(RB_Property_UseRelevance_Extend.ReceiveId) + "=" + dmodel.ReceiveId;
            }

            string sql = $@" select pur.*,pi.Name as PropertyName,pi.PropertyNum,pi.BrandName,pi.PropertyModel,pc.Name as CategoryName from 
rb_property_userelevance pur 
left join RB_Property_Info pi on pur.PropertyId=pi.Id
left join RB_Property_Category pc on pc.Id=pi.CategoryId
{where} order by pur.Id desc";
            return Get<RB_Property_UseRelevance_Extend>(sql).ToList();
        }


        public List<RB_Property_UseRelevance_Extend> GetPropertySureList(RB_Property_UseRelevance_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND pur.{0}={1}", nameof(RB_Property_UseRelevance_Extend.Status), 0);
            where += $@" and pur.RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.ReceiveId > 0)
            {
                where += " and pur." + nameof(RB_Property_UseRelevance_Extend.ReceiveId) + "=" + dmodel.ReceiveId;
            }
            if (dmodel.EmployeeId > 0) {
                where += " and pu.EmployeeId=" + dmodel.EmployeeId;
                where += " and pu.Source in(1,3)";//领用+借用
                where += " and pu.AuditStatus!=1";
                where += " and pu.Status=0";
                where += " and pi.PropertyStatus in(5,7)";
            }

            string sql = $@" select pur.* from 
rb_property_userelevance pur 
left join rb_property_usereceive pu on pur.ReceiveId=pu.Id
left join rb_property_info pi on pur.PropertyId=pi.Id
{where} order by pur.Id desc";
            return Get<RB_Property_UseRelevance_Extend>(sql).ToList();
        }


    }
}
