﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 流程日志仓储类
    /// </summary>
    public partial class RB_Workfolw_Change_LogRepository : RepositoryBase<RB_Workfolw_Change_Log>
    {
        /// <summary>
        /// 获取分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Workfolw_Change_Log> GetPageList(int pageIndex, int pageSize, RB_Workfolw_Change_Log dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";            
            if (dmodel.ResourceId > 0) {
                where += " and " + nameof(RB_Workfolw_Change_Log.ResourceId) + "=" + dmodel.ResourceId;
            }
            if (dmodel.Type > 0) {
                where += " and " + nameof(RB_Workfolw_Change_Log.Type) + "=" + dmodel.Type;
            }
            string sql = $@" select * from RB_Workfolw_Change_Log {where} order by LogId asc";
            return GetPage<RB_Workfolw_Change_Log>(pageIndex, pageSize, out count, sql).ToList();
        }
        /// <summary>
        /// 获取列表数据
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Workfolw_Change_Log> GetList(RB_Workfolw_Change_Log dmodel)
        {
            string where = " where 1=1 ";
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.ResourceId > 0)
            {
                where += " and " + nameof(RB_Workfolw_Change_Log.ResourceId) + "=" + dmodel.ResourceId;
            }
            if (dmodel.Type > 0)
            {
                where += " and " + nameof(RB_Workfolw_Change_Log.Type) + "=" + dmodel.Type;
            }
            string sql = $@" select * from RB_Workfolw_Change_Log {where} order by Id desc";
            return Get<RB_Workfolw_Change_Log>(sql).ToList();
        }
    }
}
