﻿using DapperExtensions.Lambda;
using REBORN.Common.Enum;
using Property.Model.Entity;
using Property.Model.Extend;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using System.Threading.Tasks;

namespace Property.Repository
{
    /// <summary>
    /// 工作流程审核记录表
    /// </summary>
    public partial class Rb_Workflow_AuditrecordRepository : RepositoryBase<Rb_Workflow_Auditrecord>
    {

        /// <summary>
        /// 根据工作流id 和 模版类型获取审核详情
        /// </summary>
        /// <param name="WorkFlowId"></param>
        /// <returns></returns>
        public List<Rb_Workflow_Auditrecord_Extend> GetAuditRecordList(int WorkFlowId)
        {
            string where = $@" where 1=1 ";
            if (WorkFlowId > 0)
            {
                where += $@" and ar.{nameof(Rb_Workflow_AuditRelevance.WorkFlowId) }={WorkFlowId}";
            }
            string sql = $@"SELECT ar.* from rb_workflow_auditrecord ar {where}";
            return Get<Rb_Workflow_Auditrecord_Extend>(sql).ToList();
        }
        /// <summary>
        /// 根据工作流id 审核id 和 模版类型获取审核详情
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public List<Rb_Workflow_Auditrecord_Extend> GetFinaceAuditRecordList(Rb_Workflow_Auditrecord_Extend model)
        {
            string where = $@" where 1=1 ";
            if (model.Id > 0)
            {
                where += $@" and ar.{nameof(Rb_Workflow_Auditrecord.Id) }={model.Id}";
            }
            if (!string.IsNullOrEmpty(model.RecordIdStr)) {
                where += $@" and ar.{nameof(Rb_Workflow_Auditrecord.Id) } in({model.RecordIdStr})";
            }
            if (model.WorkFlowId > 0)
            {
                where += $@" and ar.{nameof(Rb_Workflow_Auditrecord.WorkFlowId) }={model.WorkFlowId}";
            }
            if (!string.IsNullOrWhiteSpace(model.FrIdStr))
            {
                where += $@" and ar.{nameof(Rb_Workflow_Auditrecord.WorkFlowId) } in({model.FrIdStr})";
            }
            if (model.TemplateType > 0)
            {
                where += $@" and ar.{nameof(Rb_Workflow_Auditrecord.TemplateType)}={(int)model.TemplateType}";
            }
            if (model.AuditId > 0)
            {
                where += $@" and ar.{nameof(Rb_Workflow_Auditrecord.AuditId)}={model.AuditId}";
            }
            if (model.AuditEmId > 0)
            {
                where += $@" and ar.{nameof(Rb_Workflow_Auditrecord.AuditEmId)}={model.AuditEmId}";
            }
            if (model.AuditStatus > 0)
            {
                where += $@" and ar.{nameof(Rb_Workflow_Auditrecord.AuditStatus)}={(int)model.AuditStatus}";
            }
            string sql = $@"SELECT ar.* from rb_workflow_auditrecord ar {where}";
            return Get<Rb_Workflow_Auditrecord_Extend>(sql).ToList();
        }
    }
}
