﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;

namespace Property.Repository
{
    /// <summary>
    /// 审批流程模版扩展方法财务专用
    /// </summary>
    public class Rb_Workflow_TemplateRepository : RepositoryBase<Rb_Workflow_Template>
    {
        /// <summary>
        /// 表名称
        /// </summary>
        public string TableName { get { return nameof(Rb_Workflow_Template); } }

        /// <summary>
        /// 获取模板列表
        /// </summary>
        /// <param name="model"></param>
        /// <returns></returns>
        public List<Rb_Workflow_Template_Extend> GetList(Rb_Workflow_Template_Extend model)
        {
            string where = " WHERE 1=1 ";
            if (model.Status > 0) //状态==0的时候查询停用和正常的
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.Status) + "={0}", (int)model.Status);
            }
            else
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.Status) + "!={0}", 3);
            }
            if (model.Id > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.Id) + "={0}", model.Id);
            }
            if (model.Type > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.Type) + "={0}", (int)model.Type);
            }
            if (model.RB_GroupId > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.RB_GroupId) + "={0}", model.RB_GroupId);
            }
            if (model.RB_BranchId >= 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.RB_BranchId) + "={0}", model.RB_BranchId);
            }
            if (model.TemplateType.HasValue && model.TemplateType.Value > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.TemplateType) + "={0}", (int)model.TemplateType);
            }
            if (!string.IsNullOrEmpty(model.TemplateIds))
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.Id) + " in ({0})", model.TemplateIds);
            }
            if (model.TemplateSorce > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.TemplateSorce) + "={0}", model.TemplateSorce);
            }
            if (model.PropertyType > 0) {
                where += string.Format(" AND " + nameof(Rb_Workflow_Template.PropertyType) + "={0}", (int)model.PropertyType);
            }
            string sql = string.Format(" SELECT * FROM {0} {1}", TableName, where);
            return Get<Rb_Workflow_Template_Extend>(sql).ToList();
        }


        /// <summary>
        /// 获取自定义模板
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="model"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<Rb_Workflow_Template_Finance_Extend> GetPageList(int pageIndex, int pageSize, Rb_Workflow_Template_Finance_Extend model, out long count)
        {
            string where = "1=1";
            where += string.Format(" AND A." + nameof(Rb_Workflow_Template.Status) + "!=3");
            if (model.TemplateType > 0)
            {
                where += string.Format(" AND A." + nameof(Rb_Workflow_Template.TemplateType) + "={0}", (int)model.TemplateType);
            }
            if (model.RB_GroupId > 0)
            {
                where += string.Format(" AND A." + nameof(Rb_Workflow_Template.RB_GroupId) + "={0}", model.RB_GroupId);
            }
            if (model.RB_BranchId >= 0)
            {
                where += string.Format(" AND A." + nameof(Rb_Workflow_Template.RB_BranchId) + "={0}", model.RB_BranchId);
            }
            if (model.Type > 0)
            {
                where += string.Format(" AND A." + nameof(Rb_Workflow_Template.Type) + "={0}", (int)model.Type);
            }
            if (!string.IsNullOrEmpty(model.TemplateIds))
            {
                where += string.Format(" AND A." + nameof(Rb_Workflow_Template.TemplateType) + " in({0}) ", model.TemplateIds);
            }
            if (!string.IsNullOrWhiteSpace(model.Name)) {
                where += string.Format(" AND A." + nameof(Rb_Workflow_Template.Name) + " like '%{0}%'", model.Name);
            }
            if (model.CostTypeId > 0)
            {
                where += $@" and A.Id in(SELECT flowtemplateId FROM rb_financeflowconnect WHERE type=2 AND `Status`=0 and suitableobjectId={model.CostTypeId})";
            }
            if (model.TemplateSorce > 0) {
                where += string.Format(" AND A." + nameof(Rb_Workflow_Template.TemplateSorce) + "={0}", model.TemplateSorce);
            }
            string sql = string.Format(" select * from {0} as A where {1}", TableName, where);
            return GetPage<Rb_Workflow_Template_Finance_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取我审批的，待我审批的。
        /// </summary>
        /// <param name="model"></param>
        /// <param name="FrIdStr"></param>
        /// <returns></returns>
        public List<Rb_Workflow_Auditrecord> GetAgreeOrWaitList(Rb_Workflow_Auditrecord model,string FrIdStr="")
        {
            string where = " WHERE 1=1 ";
            //审核人ID
            if (model.AuditEmId > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Auditrecord.AuditEmId) + "={0}", model.AuditEmId);
            }
            if (model.WorkFlowId > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Auditrecord.WorkFlowId) + "={0}", model.WorkFlowId);
            }
            if (!string.IsNullOrWhiteSpace(FrIdStr))
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Auditrecord.WorkFlowId) + " in({0})", FrIdStr);
            }
            if (model.AuditStatus > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Auditrecord.AuditStatus) + "={0}", (int)model.AuditStatus);
            }
            if (model.TemplateType > 0)
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Auditrecord.TemplateType) + "={0}", (int)model.TemplateType);
            }
            string sql = string.Format(" SELECT * FROM {0} {1}", nameof(Rb_Workflow_Auditrecord), where);
            return Get<Rb_Workflow_Auditrecord>(sql).ToList();
        }
        /// <summary>
        /// 获取待我审核的单据数量
        /// </summary>
        /// <param name="emID"></param>
        /// <param name="AuditStatus"></param>
        /// <returns></returns>
        public int GetNotDealCount(int emID, int AuditStatus)
        {
            string sql = " SELECT Count(1) FROM Rb_Workflow_Auditrecord where AuditEmId=" + emID + " and AuditStatus=" + AuditStatus;
            var obj = base.ExecuteScalar(sql);
            if (obj != null)
            {
                return int.Parse(obj.ToString());
            }
            else
            {
                return 0;
            }
        }

        /// <summary>
        /// 通过条件获取模板列表
        /// </summary>
        /// <param name="GroupId"></param>
        /// <param name="Type"></param>
        /// <param name="TempLateClass"></param>
        /// <returns></returns>
        public List<Rb_Workflow_Template> GetTempateList(int GroupId, int Type, int TempLateClass)
        {
            string where = " where 1=1";
            if (GroupId > 0)
            {
                where += " and " + nameof(Rb_Workflow_Template.RB_GroupId) + "=" + GroupId;
            }
            if (Type > 0)
            {
                where += " and " + nameof(Rb_Workflow_Template.Type) + "=" + Type;
            }
            if (TempLateClass > 0)
            {
                where += " and " + nameof(Rb_Workflow_Template.TempLateClass) + "=" + TempLateClass;
            }
            return Get($@" select * from Rb_Workflow_Template {where}").ToList();
        }
        /// <summary>
        /// 获取待我审核的记录列表
        /// </summary>
        /// <param name="AuditEmIds"></param>
        /// <returns></returns>
        public List<Rb_Workflow_Auditrecord> GetAgreeOrWaitList(string AuditEmIds)
        {
            string where = " WHERE 1=1 ";
            //审核人ID
            if (!string.IsNullOrEmpty(AuditEmIds))
            {
                where += string.Format(" AND " + nameof(Rb_Workflow_Auditrecord.AuditEmId) + " in({0}) ", AuditEmIds);
            }
            string sql = string.Format(" SELECT * FROM {0} {1}", nameof(Rb_Workflow_Auditrecord), where);
            return Get<Rb_Workflow_Auditrecord>(sql).ToList();
        }
    }
}
