﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 耗材申请仓储类
    /// </summary>
    public partial class RB_Supplies_ApplyforRepository : RepositoryBase<RB_Supplies_Applyfor>
    {
        /// <summary>
        /// 获取耗材申请分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_Applyfor_Extend> GetPageList(int pageIndex, int pageSize, RB_Supplies_Applyfor_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Supplies_Applyfor_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";            
            if (dmodel.BranchId>=-1)
            {
                where += " and " + nameof(RB_Supplies_Applyfor_Extend.BranchId) + " =" + dmodel.BranchId;
            }
            if (dmodel.Enabled > 0) {
                where += " and " + nameof(RB_Supplies_Applyfor_Extend.Enabled) + " =" + dmodel.Enabled;
            }
            
            string sql = $@" select * from RB_Supplies_Applyfor {where} order by Id desc";
            return GetPage<RB_Supplies_Applyfor_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }


        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_Applyfor_Extend> GetList(RB_Supplies_Applyfor_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Supplies_Applyfor_Extend.Status), 0);
            where += $@" and RB_Group_Id={dmodel.RB_Group_Id}";
            if (dmodel.BranchId >= -1)
            {
                where += " and " + nameof(RB_Supplies_Applyfor_Extend.BranchId) + " =" + dmodel.BranchId;
            }
            if (dmodel.Enabled > 0)
            {
                where += " and " + nameof(RB_Supplies_Applyfor_Extend.Enabled) + " =" + dmodel.Enabled;
            }

            string sql = $@" select * from RB_Supplies_Applyfor {where} order by Id desc";
            return Get<RB_Supplies_Applyfor_Extend>(sql).ToList();
        }
    }
}
