﻿using Property.Model.Entity;
using Property.Model.Extend;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 耗材申请特殊日期仓储类
    /// </summary>
    public partial class RB_Supplies_ApplyforSpecialRepository : RepositoryBase<RB_Supplies_ApplyforSpecial>
    {
        /// <summary>
        /// 获取耗材申请特殊日期分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_ApplyforSpecial_Extend> GetPageList(int pageIndex, int pageSize, RB_Supplies_ApplyforSpecial_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Supplies_ApplyforSpecial_Extend.Status), 0); 
            if (dmodel.ApplyforId>=0)
            {
                where += " and " + nameof(RB_Supplies_ApplyforSpecial_Extend.ApplyforId) + " =" + dmodel.ApplyforId;
            }
            
            string sql = $@" select * from RB_Supplies_ApplyforSpecial {where} order by Id desc";
            return GetPage<RB_Supplies_ApplyforSpecial_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }


        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Supplies_ApplyforSpecial_Extend> GetList(RB_Supplies_ApplyforSpecial_Extend dmodel)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND {0}={1}", nameof(RB_Supplies_ApplyforSpecial_Extend.Status), 0);
            where += $@" and {nameof(RB_Supplies_ApplyforSpecial_Extend.Date)} >='{DateTime.Now.ToString("yyyy-MM-dd")}'";//必须要大于等于当前时间
            if (dmodel.ApplyforId >= 0)
            {
                where += " and " + nameof(RB_Supplies_ApplyforSpecial_Extend.ApplyforId) + " =" + dmodel.ApplyforId;
            }
            if (!string.IsNullOrEmpty(dmodel.ApplyforIds)) 
            {
                where += " and " + nameof(RB_Supplies_ApplyforSpecial_Extend.ApplyforId) + " in(" + dmodel.ApplyforIds + ")";
            }

            string sql = $@" select * from RB_Supplies_ApplyforSpecial {where} order by Id desc";
            return Get<RB_Supplies_ApplyforSpecial_Extend>(sql).ToList();
        }
    }
}
