﻿using Property.Model.Entity;
using Property.Model.Extend.Supplies;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository.Supplies
{
    public class RB_Supplies_ReportLossRecordDetailRepository : RepositoryBase<RB_Supplies_ReportLossRecordDetail>
    {
        public string TableName { get { return nameof(RB_Supplies_ReportLossRecordDetail); } }

        /// <summary>
        /// 盘点报损分页
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowCount"></param>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Supplies_ReportLossRecordDetail_Extend> GetWarehouseOutPageList(int pageIndex, int pageSize, out long rowCount, RB_Supplies_ReportLossRecordDetail_Extend query)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append($" select * from {TableName} as a where a.Status=0 ");
            if (query != null)
            {
                if (query.Id > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.Id)}={query.Id}");
                }

                if (query.SuppliesId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.SuppliesId)}={query.SuppliesId}");
                }
                if (query.ReportLossRecordId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.ReportLossRecordId)}={query.ReportLossRecordId}");
                }
            }
            return GetPage<RB_Supplies_ReportLossRecordDetail_Extend>(pageIndex, pageSize, out rowCount, builder.ToString()).ToList();
        }


        /// <summary>
        /// 盘点报损列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Supplies_ReportLossRecordDetail_Extend> GetReportLossRecordDetailList(RB_Supplies_ReportLossRecordDetail_Extend query)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append($" select * from {TableName} as a where a.Status=0 ");
            if (query != null)
            {
                if (query.Id > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.Id)}={query.Id}");
                }

                if (query.SuppliesId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.SuppliesId)}={query.SuppliesId}");
                }
                if (query.ReportLossRecordId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.ReportLossRecordId)}={query.ReportLossRecordId}");
                }
            }
            return Get<RB_Supplies_ReportLossRecordDetail_Extend>(builder.ToString()).ToList();
        }


        /// <summary>
        /// 盘点报损列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Supplies_ReportLossRecordDetail_Extend> GetReportLossRecordDetail(RB_Supplies_ReportLossRecordDetail_Extend query)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append($@"  select a.*,b.InventoryNum,b.RealityNum,c.`Name` as GoodsName,c.SpecificationName from {TableName} as a LEFT JOIN rb_supplies_checkdetail as b on a.CheckDetailId=b.Id
LEFT JOIN rb_supplies_material as c on a.SuppliesId = c.Id where a.Status=0 ");
            if (query != null)
            {
                if (query.Id > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.Id)}={query.Id}");
                }

                if (query.SuppliesId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.SuppliesId)}={query.SuppliesId}");
                }
                if (query.ReportLossRecordId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecordDetail_Extend.ReportLossRecordId)}={query.ReportLossRecordId}");
                }
            }
            return Get<RB_Supplies_ReportLossRecordDetail_Extend>(builder.ToString()).ToList();
        }
    }
}
