﻿using Property.Model.Entity;
using Property.Model.Extend.Supplies;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository.Supplies
{
    public class RB_Supplies_ReportLossRecordRepository : RepositoryBase<RB_Supplies_ReportLossRecord>
    {
        public string TableName { get { return nameof(RB_Supplies_ReportLossRecord); } }

        /// <summary>
        /// 盘点报损分页
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowCount"></param>
        /// <param name="query"></param>
        /// <returns></returns>
        public List<RB_Supplies_ReportLossRecord_Extend> GetSuppliesReportLossRecordPageList(int pageIndex, int pageSize, out long rowCount, RB_Supplies_ReportLossRecord_Extend query)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append($" select * from {TableName} as a where a.Status=0 ");
            if (query != null)
            {
                if (query.Id > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecord_Extend.Id)}={query.Id}");
                }

                if (query.WarehouseId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecord_Extend.WarehouseId)}={query.WarehouseId}");
                }
                if (query.CheckId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecord_Extend.CheckId)}={query.CheckId}");
                }
                if (query.CheckStatus.HasValue && query.CheckStatus > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecord_Extend.CheckStatus)}={(int)query.CheckStatus}");
                }
            }
            return GetPage<RB_Supplies_ReportLossRecord_Extend>(pageIndex, pageSize, out rowCount, builder.ToString()).ToList();
        }


        /// <summary>
        /// 盘点报损列表
        /// </summary>
        /// <param name="query">查询条件</param>
        /// <returns></returns>
        public List<RB_Supplies_ReportLossRecord_Extend> GetReportLossRecordList(RB_Supplies_ReportLossRecord_Extend query)
        {
            StringBuilder builder = new StringBuilder();
            builder.Append($" select * from {TableName} as a where a.Status=0 ");
            if (query != null)
            {
                if (query.Id > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecord_Extend.Id)}={query.Id}");
                }

                if (query.WarehouseId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecord_Extend.WarehouseId)}={query.WarehouseId}");
                }
                if (query.CheckId > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecord_Extend.CheckId)}={query.CheckId}");
                }
                if (query.CheckStatus.HasValue && query.CheckStatus > 0)
                {
                    builder.Append($" AND a.{nameof(RB_Supplies_ReportLossRecord_Extend.CheckStatus)}={(int)query.CheckStatus}");
                }

            }
            return Get<RB_Supplies_ReportLossRecord_Extend>(builder.ToString()).ToList();
        }

    }
}
