﻿using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 耗材出库单仓储类
    /// </summary>
    public partial class RB_Supplies_StockOutRepository : RepositoryBase<RB_Supplies_StockOut>
    {
        /// <summary>
        /// 获取出库单分页数据
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Supplies_StockOut_Extend> GetPageList(int pageIndex, int pageSize, RB_Supplies_StockOut_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            where += string.Format(" AND ss.{0}={1}", nameof(RB_Supplies_StockOut_Extend.Status), 0);
            where += $@" and ss.RB_Group_Id={dmodel.RB_Group_Id}";            
            if (!string.IsNullOrWhiteSpace(dmodel.StartTime))
            {
                where += $@" and ss.{nameof(RB_Supplies_StockOut_Extend.StockOutDate)} >='{dmodel.StartTime}'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.EndTime))
            {
                where += $@" and ss.{nameof(RB_Supplies_StockOut_Extend.StockOutDate)} <='{dmodel.EndTime + " 23:59:59"}'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.StockOutNum))
            {
                where += " and ss." + nameof(RB_Supplies_StockOut_Extend.StockOutNum) + " like '%" + dmodel.StockOutNum + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SuppliesNum.Trim()))
            {
                where += " and sm." + nameof(RB_Supplies_StockOut_Extend.SuppliesNum) + " like '%" + dmodel.SuppliesNum.Trim() + "%'";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.SuppliesName.Trim()))
            {
                where += " and sm." + nameof(RB_Supplies_Material.Name) + " like '%" + dmodel.SuppliesName.Trim() + "%'";
            }
            if (dmodel.Id > 0)
            {
                where += " and ss." + nameof(RB_Supplies_StockOut_Extend.Id) + "=" + dmodel.Id;
            }
            if (dmodel.WarehouseId > 0) {
                where += " and ss." + nameof(RB_Supplies_StockOut_Extend.WarehouseId) + "=" + dmodel.WarehouseId;
            }
            if (dmodel.EmployeeId > 0) {
                where += " and ss." + nameof(RB_Supplies_StockOut_Extend.EmployeeId) + "=" + dmodel.EmployeeId;
            }
            
            string sql = $@" select distinct ss.*,sw.Name as WareHouseName from RB_Supplies_StockOut ss
left join rb_supplies_warehouse sw on ss.WarehouseId=sw.Id
left join rb_supplies_stockoutdetail ssd on ss.Id=ssd.StockOutId
left join rb_supplies_material sm on ssd.SuppliesId=sm.Id
{where} order by ss.Id desc";
            return GetPage<RB_Supplies_StockOut_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }        
    }
}
