﻿using REBORN.Common.Enum;
using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Property.Repository
{
    /// <summary>
    /// 审批委托
    /// </summary>
    public class RB_Audit_DelegateRepository : RepositoryBase<RB_Audit_Delegate>
    {
        /// <summary>
        /// 根据发起人id获取委托信息
        /// </summary>
        /// <param name="empId">委托人id</param>
        /// <param name="dateTime">审核时间</param>
        /// <param name="delegateContent">审核内容</param>
        /// <returns></returns>
        public RB_Audit_Delegate GetDelegateByInitiatorEmpId(int empId, string dateTime, DelegateContentEnum delegateContent)
        {
            string sql = $@"SELECT * from rb_audit_delegate d where d.DelegateState = {(int)DelegateStateEnum.Normal} and d.InitiatorEmpId = {empId} and '{dateTime}' >= d.StartDate and '{dateTime}' <= d.EndDate and d.DelegateContent like '%{(int)delegateContent}%'";
            return Get<RB_Audit_Delegate>(sql).FirstOrDefault();
        }

        /// <summary>
        /// 获取发起人时间段内所有重复数据
        /// </summary>
        /// <param name="where">查询条件</param>
        /// <returns></returns>
        public List<RB_Audit_Delegate> GetDelegateByInitiatorEmpId(RB_Audit_Delegate where)
        {
            string sql = $@"SELECT * from rb_audit_delegate d where d.DelegateState = {(int)DelegateStateEnum.Normal} and d.InitiatorEmpId = {where.InitiatorEmpId} and ( ('{where.StartDate}' >= d.StartDate and '{where.StartDate}' <= d.EndDate) Or ('{where.EndDate}' >= d.StartDate and '{where.EndDate}' <= d.EndDate))";
            return Get<RB_Audit_Delegate>(sql).ToList();
        }

        /// <summary>
        /// 获取我的委托分页查询
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="empId">员工id</param>
        /// <param name="count">总条数</param>
        /// <returns></returns>
        public List<RB_Audit_Delegate_Extend> GetMyDelegatePageList(int pageIndex, int pageSize, int empId, out long count)
        {
            string sql = $@"SELECT d.*,e.EmName as UserName,e.EmPhoto as UserPhoto from rb_audit_delegate d
                            LEFT JOIN rb_employee e on d.ReciveEmpId = e.EmployeeId
                            where d.InitiatorEmpId = {empId} and d.DelegateState != {(int)DelegateStateEnum.Delete} ORDER BY d.CreateDate desc";
            return GetPage<RB_Audit_Delegate_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }

        /// <summary>
        /// 获取我的委托分页查询
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="empId">员工id</param>
        /// <param name="count">总条数</param>
        /// <returns></returns>
        public List<RB_Audit_Delegate_Extend> GetDelegateMePageList(int pageIndex, int pageSize, int empId, out long count)
        {
            string sql = $@"SELECT d.*,e.EmName as UserName,e.EmPhoto as UserPhoto from rb_audit_delegate d
                            LEFT JOIN rb_employee e on d.InitiatorEmpId = e.EmployeeId
                            where d.ReciveEmpId = {empId} and d.DelegateState = {(int)DelegateStateEnum.Normal} ORDER BY d.CreateDate desc";
            return GetPage<RB_Audit_Delegate_Extend>(pageIndex, pageSize, out count, sql).ToList();
        }
    }
}
