﻿using Property.Model.Entity;
using Property.Model.Extend;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Property.Repository
{
    /// <summary>
    /// 订单修改日志表仓储层
    /// </summary>
    public class RB_System_Push_LogRepository : RepositoryBase<RB_System_Push_Log>
    {

        /// <summary>
        /// 获取订单修改日志分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="rowsCount"></param>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_System_Push_LogExtend> GetPageList(int pageIndex, int pageSize, RB_System_Push_LogExtend dmodel, out long rowsCount)
        {
            string where = "";
            if (dmodel.IsRead != null && dmodel.IsRead >= 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.IsRead)}={dmodel.IsRead}";
            }
            if (dmodel.IsSys != null && dmodel.IsSys >= 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.IsSys)}={dmodel.IsSys}";
            }
            if (dmodel.RB_Branch_id != null && dmodel.RB_Branch_id >= 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.RB_Branch_id)}={dmodel.RB_Branch_id}";
            }
            if (dmodel.Recipient != null && dmodel.Recipient > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.Recipient)}={dmodel.Recipient}";
            }
            if (dmodel.RecPlatform != null && dmodel.RecPlatform > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.RecPlatform)}={(int)dmodel.RecPlatform}";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.Title))
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.Title)} like '%{dmodel.Title}%'";
            }
            if (dmodel.LogType > 0)
            {
                if (dmodel.LogType == 1)
                {
                    where += $@" and {nameof(RB_System_Push_LogExtend.Title)} !='新增库存推送'";
                }
                else {
                    where += $@" and {nameof(RB_System_Push_LogExtend.Title)} ='新增库存推送'";
                }
            }
            if (dmodel.Type.HasValue && dmodel.Type > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.Type)} = {(int)dmodel.Type}";
            }
            if (dmodel.ShowShortcut != null && dmodel.ShowShortcut >= 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.ShowShortcut)} = {dmodel.ShowShortcut}";
            }

            where += $@" and {nameof(RB_System_Push_LogExtend.RecipientType)} = {dmodel.RecipientType}";
            //HK新加
            string sqlMinId = string.Format("SELECT ID FROM RB_System_Push_Log WHERE 1=1 AND IsRead=0 AND Recipient={0}  and RecipientType={1}  LIMIT 1;", dmodel.Recipient, dmodel.RecipientType);
            object obj = base.ExecuteScalar(sqlMinId);
            string where2 = "";
            if (obj != null && Convert.ToInt32(obj) > 0)
            {
                where2 += string.Format(" AND ID>={0} ", Convert.ToInt32(obj));
            }
            string sql = string.Format("SELECT * FROM RB_System_Push_Log WHERE 1=1 {0}  {1}  ORDER BY ID desc", where2, where);
            var list= GetPage<RB_System_Push_LogExtend>(pageIndex, pageSize, out rowsCount, sql).ToList();
            return list;
        }



        /// <summary>
        /// 获取未读数量
        /// </summary>
        /// <param name="eid"></param>
        /// <param name="typeid"></param>
        /// <param name="RecPlatform"></param>
        /// <returns></returns>
        public int GetUnReadNum(int eid, int typeid, int RecPlatform)
        {
            string where = " where 1=1";
            where += $@" and t.{nameof(RB_System_Push_LogExtend.IsRead)}=0";
            if (eid > 0)
            {
                where += $@" and t.{nameof(RB_System_Push_LogExtend.Recipient)}={eid}";
            }
            if (typeid > 0)
            {
                where += $@" and t.{nameof(RB_System_Push_LogExtend.Type)} = {typeid}";
            }
            if (RecPlatform > 0)
            {
                where += $@" and t.{nameof(RB_System_Push_LogExtend.RecPlatform)} = {RecPlatform}";
            }
            return Convert.ToInt32(ExecuteScalar($@"select count(ID) from RB_System_Push_Log as t {where}"));
        }

        /// <summary>
        /// 获取列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_System_Push_LogExtend> GetList(RB_System_Push_LogExtend dmodel)
        {
            string where = " where 1=1";
            if (dmodel.RB_Group_id > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.RB_Group_id)}={dmodel.RB_Group_id}";
            }
            if (dmodel.RB_Branch_id >= 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.RB_Branch_id)}={dmodel.RB_Branch_id}";
            }
            if (dmodel.Type > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.Type)}={(int)dmodel.Type}";
            }
            if (dmodel.CreateBy > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.CreateBy)}={dmodel.CreateBy}";
            }
            if (dmodel.Recipient > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.Recipient)}={dmodel.Recipient}";
            }
            if (dmodel.RecPlatform > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.RecPlatform)}={(int)dmodel.RecPlatform}";
            }
            if (!string.IsNullOrWhiteSpace(dmodel.Title))
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.Type)} like '%{dmodel.Title}%'";
            }
            if (dmodel.SourceId > 0)
            {
                where += $@" and {nameof(RB_System_Push_LogExtend.SourceId)}={(int)dmodel.SourceId}";
            }
            string sql = $@" select * from RB_System_Push_Log {where}";
            return Get<RB_System_Push_LogExtend>(sql).ToList();
        }
    }
}