﻿
using Property.Model.Entity;
using Property.Model.Extend;
using System.Collections.Generic;
using System.Linq;

namespace Property.Repository
{
    /// <summary>
    /// 菜单扩展方法
    /// </summary>
    public partial class Rb_sys_menuRepository : RepositoryBase<RB_Sys_Menu>
    {
        /// <summary>
        /// 获取菜单分页列表
        /// </summary>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <param name="dmodel"></param>
        /// <param name="count"></param>
        /// <returns></returns>
        public List<RB_Sys_Menu_Extend> GetPageList(int pageIndex, int pageSize, RB_Sys_Menu_Extend dmodel, out long count)
        {
            string where = " where 1=1 ";
            if (!string.IsNullOrWhiteSpace(dmodel.MenuName))
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.MenuName) + " like '%" + dmodel.MenuName + "%'";
            }
            if (dmodel.ParentId.HasValue && dmodel.ParentId > 0)
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.ParentId) + "=" + dmodel.ParentId;
            }
            if (dmodel.Tier.HasValue && dmodel.Tier > 0)
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.Tier) + "=" + dmodel.Tier;
            }
            if (dmodel.MenuStatus.HasValue && dmodel.MenuStatus >= 0)
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.MenuStatus) + "=" + dmodel.MenuStatus;
            }
            return GetPage<RB_Sys_Menu_Extend>(pageIndex, pageSize, out count, "select * from  Rb_sys_menu " + where + " order by Sort asc,MenuId desc").ToList();
        }

        /// <summary>
        /// 根据where获取菜单列表
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Sys_Menu_Extend> GetList(RB_Sys_Menu_Extend dmodel)
        {
            string where = " 1=1";
            if (dmodel.ParentId > 0)
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.ParentId) + "=" + dmodel.ParentId;
            }
            if (dmodel.Tier.HasValue && dmodel.Tier > 0)
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.Tier) + "=" + dmodel.Tier;
            }
            if (dmodel.RootId.HasValue && dmodel.RootId > 0)
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.RootId) + "=" + dmodel.RootId;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.MenuName))
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.MenuName) + " like '%" + dmodel.MenuName + "%'";
            }
            if (dmodel.MenuStatus.HasValue && dmodel.MenuStatus >= 0)
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.MenuStatus) + "=" + dmodel.MenuStatus;
            }
            if (!string.IsNullOrWhiteSpace(dmodel.MenuUrl))
            {
                where += " and " + nameof(RB_Sys_Menu_Extend.MenuUrl) + "='" + dmodel.MenuUrl + "'";
            }
            return Get<RB_Sys_Menu_Extend>(" select * from RB_Sys_Menu where" + where+ " order by Sort asc,MenuId asc").ToList();
        }

        /// <summary>
        /// 获取系统版本菜单
        /// </summary>
        /// <param name="dmodel"></param>
        /// <returns></returns>
        public List<RB_Sys_Menu_Extend> GetVersionsMenuList(RB_Sys_Menu_Extend dmodel)
        {
            string where = " 1=1";
            if (dmodel.MenuStatus.HasValue && dmodel.MenuStatus >= 0)
            {
                where += " and m." + nameof(RB_Sys_Menu_Extend.MenuStatus) + "=" + dmodel.MenuStatus;
            }
            if (dmodel.VersionsId.HasValue && dmodel.VersionsId > 0)
            {
                where += " and p.Versions_Id=" + dmodel.VersionsId;
            }
            return Get<RB_Sys_Menu_Extend>(" select distinct m.* from RB_Sys_Menu m left join rb_sys_versions_permission p ON m.MenuId=p.Menu_Id where" + where+" order by m.Sort asc,m.MenuId asc").ToList();
        }

        /// <summary>
        /// 获取岗位拥有的所的菜单列表
        /// </summary>
        /// <param name="postId">岗位id</param>
        /// <returns></returns>
        public List<RB_Sys_Menu_Extend> GetPostAllRoleByPostId(int postId)
        {
            //临时注释HK
            string sql = $@"SELECT * from rb_sys_menu m where MenuStatus=0 and m.MenuType=2 AND m.MenuId in(
  SELECT rp.Menu_Id from rb_role_permission rp where rp.Role_Id in (
    SELECT p.RoleId from rb_post_role p where p.PostId = {postId}
     )
) order by Sort asc,MenuId asc";
            //string sql2 = "SELECT * from rb_sys_menu m where MenuStatus=0";
            var menuList = Get<RB_Sys_Menu_Extend>(sql).ToList();
            return menuList;
        }

        /// <summary>
        /// 获取系统所有菜单
        /// </summary>
        /// <returns></returns>
        public List<RB_Sys_Menu_Extend> GetSystemAllMenu()
        {
            var menuList = Get<RB_Sys_Menu_Extend>($@"SELECT m.MenuUrl from rb_sys_menu m").ToList();
            return menuList;
        }
    }
}
