﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Newtonsoft.Json;
using Property.Model.Entity.Mall;
using Property.Model.Extend.Mall;
using Property.Module.Mall;
using REBORN.Common;
using REBORN.Common.API;

namespace Property.WebApi.Controllers.Mall
{
  
    public class AuthorizeController : PApiController
    {
        private readonly AuthorizeModule authorizeModule = new AuthorizeModule();


        /// <summary>
        /// 获取人员授权分页信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public ApiResult GetMaterialPageList()
        {
            var requestParm = GetRequestParm();
            UserInfo userInfo = CacheManager.User.UserReidsCache.GetUserLoginInfo(requestParm.uid);
            ResultPageModel pagelist = JsonConvert.DeserializeObject<ResultPageModel>(requestParm.msg.ToString());
            RB_ERP_Authorize_Extend demodel = JsonConvert.DeserializeObject<RB_ERP_Authorize_Extend>(requestParm.msg.ToString());
            demodel.ERPGroupId = userInfo.RB_Group_id;
            var list = authorizeModule.GetAuthorizePageList(pagelist.pageIndex, pagelist.pageSize, out long count, demodel);
            pagelist.count = Convert.ToInt32(count);
            pagelist.pageData = list.Select(x => new
            {
                x.ID,
                x.Type,
                x.Status,
                x.TenantId,
                x.MallBaseId,
                x.CreateBy,
                x.EmpName,
                x.DomainName,
                x.Account,
                x.MallUserName,
                x.MallBaseName,
                x.TenantName,
                CreateDate = x.CreateDate.HasValue ? x.CreateDate.Value.ToString("yyyy-MM-dd") : "",
                UpdateDate = x.UpdateDate.HasValue ? x.UpdateDate.Value.ToString("yyyy-MM-dd") : ""
            });
            return ApiResult.Success("", pagelist);
        }


        /// <summary>
        /// 新增授权信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public ApiResult UpdateAuthorize()
        {
            var requestParm = GetRequestParm();
            RB_ERP_Authorize demodel = JsonConvert.DeserializeObject<RB_ERP_Authorize>(requestParm.msg.ToString());

            demodel.UpdateDate = System.DateTime.Now;

            bool result = authorizeModule.UpdateERPAuthorize(demodel);

            if (result)
            {
                return ApiResult.Success("操作成功");
            }
            else
            {
                return ApiResult.Failed("操作失败");

            }
        }


    }
}
